/* PTS */


package rCr._BUILDER;


import rCr.initiator.I_Config;
import rCr.agentModel.I_AgentModel;
import rCr.agentModel.C_RcR_Baseline;
import rCr.agentModel.C_RcR_RRR;
import rCr.agent.I_Agent;
import rCr.agent.rCrAgentBaseline.C_Civilian;
import rCr.agentWorkingMemory.I_AgentWorkingMemory;
import rCr.agentWorkingMemory.E_WorkingMemory;
import rCr.agent.rCrAgentRRR.C_Civilian_RouterTest;
import rCr.agentWorkingMemory.E_WorkingMemory_RRR;
import rCr.agentWorkingMemory.E_WorkingMemory_RRR.E_SpaceGridParameters;


/**
 *  @author PTS
 *  @since MAY-2004
 */
public class C_BUILDER_Civilian
extends C_BUILDER_RcR
{
   protected int getAgentType()
   {
      return I_Config.AGENT_TYPE_CIVILIAN;
   }


   protected void setAgentModelCommunicationRestriction( I_AgentModel acl_agentModel )
   {
      /** There are no communication restrictions on Civilian
       * (Civilians are represented only for testing purposes)
       */
      acl_agentModel.setHearingLimit( Integer.MAX_VALUE );
   }


   protected I_AgentModel createAgentModel()
   {
      // return new C_RcR_Baseline();
      return new C_RcR_RRR();
   }


   protected I_Agent createAgent()
   {
      // return new C_Civilian();
      return new C_Civilian_RouterTest();
   }


   protected I_AgentWorkingMemory createAgentWorkingMemory()
   {
      // return new E_WorkingMemory ();
      return new E_WorkingMemory_RRR();
   }


   protected void postWorkingMemoryInitialize( I_AgentWorkingMemory aitf_agentWorkingMemory )
   {
      E_SpaceGridParameters lcl_spaceGridParameters = new E_SpaceGridParameters(
         I_Config.AGENT_TYPE_CIVILIAN,
         I_AgentWorkingMemory.pint_numberColumnsSpaceGrid_default, I_AgentWorkingMemory.pint_numberLinesSpaceGrid_default );
      aitf_agentWorkingMemory.postInitialize( lcl_spaceGridParameters );
   }
}
