/* PTS */


package rCr.agent;


import rCr.agentWorkingMemory.I_AgentWorkingMemory;
import rCr.util.X_RcR_Accao;
import yab.agent.object.RealObject;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.skillLevel_1.I_PlannerBaseline;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public interface I_Agent
{
   public void setAgentWorkingMemory( I_AgentWorkingMemory acl_agentWorkingMemory );
   public void setPrimaryCapability( B_PrimaryCapability acl_primaryCapability );
   public void setHigherCapability( I_Planner acl_plannerCapability );
   public void setHigherCapability( I_PlannerBaseline acl_plannerCapability );
   /**
    * True if:
    * - "aint_agentID" == "self" representation at real world (from GIS)
    */
   public boolean isSelf ( int aint_agentID );

   /**
    * Pre Simulation Cycle Processing
    */
   public void preSimulation();

   /**
    * Update world representation according to the received perception
    */
   public void updateWorld( Object aobj_percepcao );

   /**
    * Default "Agent Model" interface:
    * - preActuar
    * - actuar
    * - posActuar
    */
   public void preAct();
   public void act() throws X_RcR_Accao;
   public void postAct();

   /**
    * Handle a communicative act sent by "aint_senderID" with content "astr_content"
    * - handleHearSay: natural voide utterance
    * - handleHearTell: telecomunication utterance
    * (at RcR_v0.44 HEAR_SAY & HEAR_TELL were separated from previous HEAR)
    */
   public void handleHearSay( int aint_senderID, String astr_content );
   public void handleHearTell( int aint_senderID, String astr_content );

   /**
    * Decide whether to accpet the communicative act:
    * - sent by "aint_senderID"
    * - with "aint_remainingHearingUtterances" (if the current one is accepted)
    */
   public boolean acceptHearSay( int aint_senderID, int aint_remainingHearingUtterances );
   public boolean acceptHearTell( int aint_senderID, int aint_remainingHearingUtterances );
}
