/* PTS */

package rCr.agent.rCrAgentBaseline;

import rCr.agentWorkingMemory.E_WorkingMemory;
import yab.agent.DisasterSpace;
import rCr.agentWorkingMemory.I_AgentWorkingMemory;
import yab.agent.object.RealObject;
import yab.io.KaSense;
import yab.agent.object.Humanoid;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.skillLevel_1.I_PlannerBaseline;
import rCr.agent.skillLevel_1.B_GIS_Router_Yab;
import rCr.agent.I_Agent;


abstract public class C_Agent
implements I_Agent
{
   // The Agent Working Memory
   // (includes current disaster space)
   protected E_WorkingMemory agentWorkingMemory;
   protected DisasterSpace currentDisasterSpace;
   /**
    * 2 Planners (routers):
    * - 5Rings
    * - YabAI
    */
   protected I_Planner plannerCapability;
   protected I_PlannerBaseline plannerCapabilityYab;


   // Agent Primary Capability
   // (to be cast at each subclass)
   abstract public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability );


   abstract protected void handleCommunicativeAct( RealObject aobj_sender, String astr_content );


   private RealObject self()
   {
      return ( RealObject )currentDisasterSpace.self;
   }


   public void setAgentWorkingMemory( I_AgentWorkingMemory agentWorkingMemory )
   {
      this.agentWorkingMemory = ( E_WorkingMemory)agentWorkingMemory;
      this.currentDisasterSpace = this.agentWorkingMemory.getCurrentDisasterSpace();
   }


   public void setPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      acl_primaryCapability.setAgentID( self().id );
      setAgentPrimaryCapability( acl_primaryCapability );
   }


   public void setHigherCapability( I_Planner acl_plannerCapability )
   {
      this.plannerCapability = acl_plannerCapability;
      this.plannerCapability.setAgentSelf( self() );
   }


   public void setHigherCapability( I_PlannerBaseline acl_plannerCapability )
   {
      this.plannerCapabilityYab = acl_plannerCapability;
      this.plannerCapabilityYab.setAgentSelf( self() );
   }


   public boolean isSelf ( int aint_agentID )
   {
      return self() == currentDisasterSpace.get( aint_agentID );
   }


   public void preSimulation()
   {
   }


   public void updateWorld( Object aobj_percepcao )
   {
      KaSense lobj_kaSense = ( KaSense )aobj_percepcao;
      currentDisasterSpace.update( lobj_kaSense.selfAndMap,
                                   lobj_kaSense.time );
   }


   public void handleHearSay( int aint_senderID, String astr_content )
   {
      // PARA MANTER COMPATIBILIDADE COM CODIGO ANTERIOR
       handleCommunicativeAct( aint_senderID, astr_content );
   }


   public void handleHearTell( int aint_senderID, String astr_content )
   {
      // PARA MANTER COMPATIBILIDADE COM CODIGO ANTERIOR
       handleCommunicativeAct( aint_senderID, astr_content );
   }


   /**
    * Handle a communicative act sent by "aint_senderID" with content "astr_content"
    */
   public void handleCommunicativeAct( int aint_senderID, String astr_content )
   {
      RealObject lobj_emissor = currentDisasterSpace.get( aint_senderID );
      handleCommunicativeAct( lobj_emissor, astr_content );
   }


   public boolean acceptHearSay( int aint_senderID, int aint_remainingHearingUtterances )
   {
      return true;
   }


   public boolean acceptHearTell( int aint_senderID, int aint_remainingHearingUtterances )
   {
      return true;
   }
}
