/* PTS */

package rCr.agent.rCrAgentBaseline;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;

import rCr.initiator.I_Config;
import rCr.util.X_RcR_Accao;
import rCr.util.RingBuffer;
import yab.agent.Condition;
import yab.agent.object.Building;
import yab.agent.object.Civilian;
import yab.agent.object.Humanoid;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Node;
import yab.agent.object.PointObject;
import yab.agent.object.Property;
import yab.agent.object.RealObject;
import yab.agent.object.Refuge;
import yab.agent.object.Road;
import rCr.agent.skillLevel_0.I_PrimaryCapability_AmbulanceTeam;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import yab.agent.object.AmbulanceTeam;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import java.util.Vector;
import java.lang.reflect.Array;


/**
 *  @author PTS
 *  @version 0.0
 *  @since SET-2001
 */
public class C_AmbulanceTeam
extends C_Humanoid
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_AmbulanceTeam primaryCapability;

   private static final int limitOfTimesMovingToSamePlace = 3;
   private static final int numberOfPositionsWalkingBackToSolveBlockadge =6;

   // AR: Informacao de Estado
   int estado = 0 ;// 1-> Mover, 2-> Load, 3->UnLoad, 4-> rescue, 0-> nao especificado 
   MotionlessObject icl_destinoMovimento = null; // case estado = 1
   int counterOfTimesMovingToTheSamePlace=0;
   // Variavel para manter estado se ja avisamos de bloqueio de estrada
   private int blockageNotified = 0;
   
   Humanoid  iobj_emissor_help_me = null;
   private boolean firstTime = true;

   private Humanoid m_loadingInjured = null;
	private Set m_unvisitedBuildings=null;
   // private ArrayList m_buildingsInHearRadius = null;

   // Vector neighborhoodWithCiviliansInNeedOfHelp, guarda as motionlessObject das oordenadas de 0nde se ouviram help_me
	private Vector neighborhoodWithCiviliansInNeedOfHelp = new Vector();
	// Vector civiliansInNeedOfHelp, guarda os objectos dos Civilians que pediram ajuda
	private Vector civiliansInNeedOfHelp = new Vector();  
	// Vector walkedPath, guarda as ultimas posicoes do agente
    private RingBuffer walkedPath = new RingBuffer(20);
	// Vector teamsInNeedOfHelp, guarda os objectos RealObject
	// dos Humanoid que pediram ajuda qd estes sao Policias, bombeiros ou ambulancias ou
	// dos MotionlessObject's
	private Vector teamsInNeedOfHelp = new Vector();
   // Vector buildingsInNeighborhood, guarda os buildings a visitar na vizinhanca de determinado ponto
   private Vector buildingsInNeighborhood = new Vector();

   protected static final Property
        DAMAGE_PRP     = Property.get("Humanoid", "damage");protected final static Property BURIEDNESS_PRP = Property.get("Humanoid", "buriedness");protected final static Property POSITION_PRP   = Property.get("MovingObject", "position");protected final static Property FIERYNESS_PRP  = Property.get("Building", "fieryness");

    protected static final Condition
        IS_NOT_BURNING_CND = FIERYNESS_PRP.lt(1).or(FIERYNESS_PRP.gt(3));


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryCapability_AmbulanceTeam )acl_primaryCapability;
   }


   // PTS: PARA TIRAR
   public I_PrimaryAction getAgentPrimaryCapability()
      {
         return primaryCapability;
      }


   protected AmbulanceTeam self()
   {
      return ( AmbulanceTeam )currentDisasterSpace.self;
   }


   protected MotionlessObject mlpos()
   {
      return self().motionlessPosition();
   }


   public void preAct()
   {
    	if( firstTime )
		   m_unvisitedBuildings = new HashSet(currentDisasterSpace.buildings);
   }


   public void act()
   throws X_RcR_Accao
   {
      if(firstTime)
      {
         firstTime =false;
	   }

      // ---------- Coisas que no efectuam accoes ----------
      // ====================================================

      // Se estou na posicao para onde quis ir salvar alguem, vou retira-la da lista
      if( teamsInNeedOfHelp.contains( self().motionlessPosition() ) )
      {
         println("vou remover a posicao do bombeiro que ajudei a desenterrar");
         teamsInNeedOfHelp.remove(self().motionlessPosition());
      }
      if( civiliansInNeedOfHelp.contains( self().position() ) )
      {
         println("vou remover a posicao do bombeiro que ajudei a desenterrar");
         teamsInNeedOfHelp.remove(self().motionlessPosition());
      }
      //  ---------- Fim das coisas que no efectuam accoes ----------

      // ----------------------------------
      // Se estou enterrado grito por ajuda
      // ----------------------------------
      if( self().buriedness() > 0 )
      {
         println("Ambulancia, Estou enterrado e vou gritar por ajuda...");
         if ( self().position() instanceof Road )
            primaryCapability.tell( "AT AT BURIED ALTO ROAD " + self().position().id  );
         if ( self().position() instanceof Building )
            primaryCapability.tell( "AT AT BURIED ALTO BUILDING " + self().position().id  );
      }

      // -------------------------------------------------------------
      // Se estou a carregar alguem
      // Vou descarrega-lo no refugio ou continuar a mover-me para um
      // -------------------------------------------------------------
	   if ( isLoadingInjured() )
      {
         println("Ambulancia, Estou a carregar alguem...");
         // Se estou a carregar um civilian vou continuar a carregar at um Refugio
	      if ( self().position() instanceof Refuge )
         {
            estado = 2;
            unload();
	      }
         else
         {
            estado = 0 ;
            moverParaYab( currentDisasterSpace.refuges );
	      }
      }
 
      // ----------------------------------------------------------
      // No estou a carregar ninguem,
      // Se estou na posicao de alguem que precisa ou o desenterro
      // ou o carrego na ambulancia
      // ----------------------------------------------------------
      List bombeiros = POSITION_PRP.eq(mlpos()).extract( currentDisasterSpace.fireBrigades );
	   if ( ! bombeiros.isEmpty() )
      {
         //	println("Tenho alguem na minha posicao...");
	      List brd = BURIEDNESS_PRP.gt(0).extract( bombeiros );
	      if ( ! brd.isEmpty() )
         {
            //	println("Tenho alguem enterrado na minha posicao...");
	         if(teamsInNeedOfHelp.contains(self().motionlessPosition()))
            {
               println("vou remover a posicao do bombeiro que ajudei a desenterrar");
	            teamsInNeedOfHelp.remove(self().motionlessPosition());
	         }
	         estado = 4;
	         rescue((Humanoid) DAMAGE_PRP.max(brd));
	      }
      }
      List policias = POSITION_PRP.eq(mlpos()).extract( currentDisasterSpace.policeForces );
      if (!policias.isEmpty())
      {
         //	println("Tenho alguem na minha posicao...");
         List brd = BURIEDNESS_PRP.gt(0).extract(policias);
         if (!brd.isEmpty())
         {
            //	println("Tenho alguem enterrado na minha posicao...");
            estado = 4;
            rescue((Humanoid) DAMAGE_PRP.max(brd));
         }
      }

	   // hmns, lista de humanos na minha posio
	   List hmns = POSITION_PRP.eq(mlpos()).extract(currentDisasterSpace.civilians);
	   hmns.remove(self());
      if (!hmns.isEmpty())
      {
         //	println("Tenho alguem na minha posicao...");
         List brd = BURIEDNESS_PRP.gt(0).extract(hmns);
	      if (!brd.isEmpty())
         {
            //	println("Tenho alguem enterrado na minha posicao...");
	         estado = 4;
	         rescue((Humanoid) DAMAGE_PRP.max(brd));
	      }
         // load hmns
         List inj = DAMAGE_PRP.gt(0).extract(hmns);
         if (!inj.isEmpty() && !(self().position() instanceof Refuge))
         {
            // println("Tenho alguem aleijado na minha posicao, vou fazer load...");
	         estado = 2;
	         load((Humanoid) DAMAGE_PRP.max(inj));
	      }
      }

      //===========
      // Estrategia
      //===========
      // ----------------------------------------------------
      // Estava a movimentar-me e fiquei bloqueado
      // estado=1-> Mover MotionlessPosition igual
      // vou mover para um ponto desbloqueado por onde passei
      // ----------------------------------------------------
	   MotionlessObject lastPosition = ((MotionlessObject) walkedPath.getLast(0));
	   println("Ambulancia, lastposition="+lastPosition +" estado="+ estado);
	   //elementAt( walkedPath.indexOf( walkedPath.lastElement()) -1)).id; 
	   if( (estado == 1) &&
          lastPosition != null &&
          ( self().position().id == lastPosition.id ) )
      {
         println("Ambulancia, Detectei Bloqueio, vou retornar a uma posicao anterior desbloqueada...");
	      // Vou-me certificar que e' bloqueio de estrada para pedir ajuda a um policia
	      MotionlessObject pos = self().motionlessPosition();

	      // Atributos de coordenadas pos.x e pos.y pos.direction pos.distance
	      if( ( pos instanceof Road ) )
         {
            Road road = (Road) pos;
	         if ( blockageNotified <=5 && road.passableLines() == 0 )
            {
               // say() ou tell()
	            ++blockageNotified;
	            println("Ambulancia, AT PF ROAD_BLOCKADE ROAD");
	            primaryCapability.tell("AT PF ROAD_BLOCKADE ROAD " + road.id  );
	            
	         }
            else
            {
	            estado=0;
	         }
         }
	      
	      if(teamsInNeedOfHelp.contains(icl_destinoMovimento))
         {
	          println("vou remover a posicao do bombeiro que estava a tentar ajudar, mas expirou tentativas");
	          teamsInNeedOfHelp.remove(icl_destinoMovimento);
         }
	      if( civiliansInNeedOfHelp.contains(icl_destinoMovimento) )
         {
	         println("vou remover a posicao do civil que estava a tentar ajudar, mas expirou tentativas");
	         civiliansInNeedOfHelp.remove(icl_destinoMovimento);
	      }
      }
      else
      {
	      // System.out.println("Vou fazer RESET para conseguir gritar por bloqueios..");
	      blockageNotified = 0;	
         // Guardar registo das 20 ultimas MotionlessPositions por onde passei
         // Util para voltar atrs nos engarrafamentos, 0 para posicao mais antiga e 20 para mais recente
         walkedPath.put(self().position().motionlessPosition());
	   }

      // ----------------------------------------------------
      // Estava a movimentar-me para uma MotionlessPosition
      // estado=1-> Mover
      // ----------------------------------------------------
      if( (estado == 1) &&
          (self().position().id != icl_destinoMovimento.id) )
      {
         // se ainda nao cheguei ao destino, vou continuar a ir para l
         if(counterOfTimesMovingToTheSamePlace < limitOfTimesMovingToSamePlace)
         {
            ++counterOfTimesMovingToTheSamePlace;
             println("Ambulancia, Vou insistir em mover para este destino: "+counterOfTimesMovingToTheSamePlace);
            println("Ambulancia, Destino: "+icl_destinoMovimento.id);

            moverParaYab (icl_destinoMovimento);
         }
         else
         {
            if(teamsInNeedOfHelp.contains(icl_destinoMovimento))
            {
               println("vou remover a posicao do bombeiro que estava a tentar ajudar, mas expirou tentativas");
               teamsInNeedOfHelp.remove(icl_destinoMovimento);
            }
            if( civiliansInNeedOfHelp.contains(icl_destinoMovimento) )
            {
               println("vou remover a posicao do civil que estava a tentar ajudar, mas expirou tentativas");
               civiliansInNeedOfHelp.remove(icl_destinoMovimento);
            }
         println("Ambulancia, Vou desistir de mover para este destino...");
         }
      }
      counterOfTimesMovingToTheSamePlace = 0;
	      
      // -----------------------------------------------------
      // Recebi um pedido de ajuda de um colega
      // Policia, Bombeiro ou Ambulancia, Vou mover-me para l
      // -----------------------------------------------------
	   if(!teamsInNeedOfHelp.isEmpty())
      {
         MotionlessObject teammateInNeedOfHelp = getNearestBuildingFromCollection(teamsInNeedOfHelp);
         println("Ambulancia, Vou ajudar colega, id: " + teammateInNeedOfHelp.id);
         if( (teammateInNeedOfHelp != null)&& (teammateInNeedOfHelp.motionlessPosition()!= null))
         {
            icl_destinoMovimento = teammateInNeedOfHelp ;
            println("Ambulancia, mover para: " + teammateInNeedOfHelp.id);
            estado = 1;
            moverParaYab (icl_destinoMovimento);
         }
      }
	      
      // ------------------------------------------------
      // Se alguem gritou help_me e j sei a posicao dele
      // Vou mover-me para l
      // ------------------------------------------------
      if( ! civiliansInNeedOfHelp.isEmpty() )
      {
         println("alguem gritou help_me e sei a posicao dele");
	      //RealObject civilianInNeedOfHelp = getNearestHumanoidWithKnownPositionFromCollection(civiliansInNeedOfHelp);
	      MotionlessObject civilianInNeedOfHelp = getNearestBuildingFromCollection(civiliansInNeedOfHelp);
	      if( (civilianInNeedOfHelp != null) &&
             (civilianInNeedOfHelp.motionlessPosition()!= null))
         {
            icl_destinoMovimento = civilianInNeedOfHelp ;
	         estado =1;
	         println("alguem gritou help_me e vou-me mover para a posicao dele"+ icl_destinoMovimento .id);
	         moverParaYab (icl_destinoMovimento );
	      }
	   }

      // -------------------------------------------------------
      // Se alguem gritou help_me e ainda no sei a posicao dele
      // Vou varrer os predios das redondezas  sua procura
      // -------------------------------------------------------
      // Se no tenho uma vizinhanca estabelecida vou ver se  necessrio estabelecer
	   if( buildingsInNeighborhood.isEmpty())
      {
         // Se tenho sitios onde procurar
	      if(!neighborhoodWithCiviliansInNeedOfHelp.isEmpty())
         {
            println("alguem gritou help_me e ainda no sei a posicao dele");
	         MotionlessObject mo = getNearestBuildingFromCollection(neighborhoodWithCiviliansInNeedOfHelp);
	         buildingsInNeighborhood = buildingsInHearRadius( 30, mo); 
	         if (neighborhoodWithCiviliansInNeedOfHelp.contains(mo))
               neighborhoodWithCiviliansInNeedOfHelp.remove(mo);
	      }
	   }
	   
	   if( !buildingsInNeighborhood.isEmpty())
      {
         // Tenho uma vizinhanca pre-estabelecida para procurar um civil
	      Building b = (Building)getNearestBuildingFromCollection(buildingsInNeighborhood);
	      icl_destinoMovimento = b;
	      buildingsInNeighborhood.remove(b);
	      estado = 1;
	      println("Estou a procurar alguem nesta vizinhanca");
	      moverParaYab (icl_destinoMovimento);
	   }

      // se j cheguei e nao esta ninguem vamos arrancar para outra posicao
      // -------------------------------------
      // No ouvi ninguem a chamar por help_me
      // vou varrer os buildings da cidade
      // -------------------------------------
      Random rdm = new Random();
      int random=0;
      random = rdm.nextInt();
	   if( random < 0)
         random = random * -1;
	      
      // No estou na posio de nenhum Humano
      List bldgs = IS_NOT_BURNING_CND.extract(m_unvisitedBuildings);
	   // List bldgs = IS_NOT_BURNING_CND.extract(currentDisasterSpace.refuges);
	   if (!bldgs.isEmpty())
      {
         // println("Vou mover para outro predio..."/*+((Building) bldgs.get(0)).id*/);
	      estado =1;
	      if (mlpos() instanceof Building)
         {
            println("Ambulancia, Ja visitei um Building vou remove-lo da lista a visitar...");
	         // m_unvisitedBuildings.remove(mlpos());
	         icl_destinoMovimento = (MotionlessObject) bldgs.get((random+1)%bldgs.size());
            //	icl_destinoMovimento = (MotionlessObject) bldgs.get(1);
	         moverParaYab (icl_destinoMovimento);
	      }
         else
         {
            Building bbb =(Building) bldgs.get(random%bldgs.size());
            //	Building bbb =(Building) bldgs.get(0);
	         icl_destinoMovimento = (MotionlessObject) bbb;
            println("Ambulancia, Vou mover para:"+ bbb.id);
	         moverParaYab (bbb);
	      }
	   }
      println("Ambulancia, No fiz accao nenhuma, fim do actuar...");
	   throw new X_RcR_Accao(); 
   }


   public void postAct()
   {
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      if( ( aobj_emissor != null ) && ( aobj_emissor instanceof Civilian ) &&
          (astr_actoDiscurso.equals("help_me")) )
      {
         println("Ambulancia, AD:"+astr_actoDiscurso);
	      iobj_emissor_help_me = (Humanoid)aobj_emissor;
	      if(iobj_emissor_help_me.position() != null )
         {
            println("Ouvi um grito help_me e sei a sua Posicao...");
	         civiliansInNeedOfHelp.add( iobj_emissor_help_me.motionlessPosition() );
	      }
	      if( iobj_emissor_help_me.position() == null /*&& m_buildingsInHearRadius == null*/)
         {
	          println("Ouvi um grito help_me e nao conheo a sua Posicao...");
	          neighborhoodWithCiviliansInNeedOfHelp.add(self().position().motionlessPosition());
	         // m_buildingsInHearRadius = buildingsInHearRadius(30, self().position());
	      }

	      return;
      }

      // Testar se  uma msg de pedido de ajuda, e actualizar a sua posicao
      // PF AT BURIED BAIXO ROAD id
      // FB AT BURIED BAIXO ROAD id
      // AT AT BURIED ALTO ROAD id
	   String[] ad_array = astr_actoDiscurso.split(" ");
	   int length = Array.getLength(ad_array);
	   if( length == 6 && ad_array[1].equals("AT") && ad_array[2].equals("BURIED"))
      {
         println("Ambulancia, AD:"+astr_actoDiscurso);
         RealObject ro= null;
         if( ad_array[4].equals("ROAD") )
         {
            ro = findByIdInCollection(currentDisasterSpace.roads, Integer.parseInt(ad_array[5]));
         }
         if( ad_array[4].equals("BUILDING") )
         {
            ro = findByIdInCollection(currentDisasterSpace.buildings, Integer.parseInt(ad_array[5]));
         }
         if ( ro != null)
         {
            println("Ambulancia, Recebi pedido de ajuda de um colega id:" +ro.id);
            if ( !teamsInNeedOfHelp.contains(ro))
               teamsInNeedOfHelp.add(ro);
         }
	   }
   }

   /**
    * Desenterra civis. 
    */
   protected void rescue(Humanoid target )
   throws X_RcR_Accao
   {
      // selfID e targetID
      println("Rescue de um civil");
	   primaryCapability. rescue( target );
   }

   /**
    * Carrega civis que estejam parados e aleijados 
    */
   protected void load(Humanoid target)
   throws X_RcR_Accao
   {
      // selfID e targetID
      println("Load de um civil");
	   m_loadingInjured = target;
	   primaryCapability.load( target );
   }

   /**
    * Descarrega Civis. 
    */
   protected void unload()
   throws X_RcR_Accao
   {
      println("UnLoad de um civil");
	   m_loadingInjured = null;
	   primaryCapability.unload();
   }

   protected Humanoid loadingInjured()
   {
      return m_loadingInjured;
   }

   protected boolean isLoadingInjured()
   {
      return m_loadingInjured != null;
   }

   protected void checkLoadingInjured()
   {
      if( loadingInjured() instanceof Humanoid &&
          loadingInjured().position() != self() )
         m_loadingInjured = null;
   }

   //*************************************************************************
   //                        buildingsInHearRadius
   //
   //      Vector buildingsInHearRadius( int hearRadius, RealObject ro)
   //*************************************************************************
   protected Vector buildingsInHearRadius( int hearRadius, RealObject ro)
   {
	   // println("buildingsInHearRadius()...");	
	   Vector col= new Vector();
	   int myX =-1; 
	   int myY =-1;
	   int testX = -1;
	   int testY = -1;
	   double hearRadius_mm = hearRadius * 1000;
	   
	   Building  building = null;
	   
	   if( ro instanceof Road )
      {
	      ro = ( ( Road )ro ).head();
         // ((Road)ro).tail();// Vamos assumir que ele esta' mais perto do head
	   }
	   if( (ro instanceof Building) || ( ro instanceof Node) )
      {
	      myX = ((PointObject)ro).x();
	      myY = ((PointObject)ro).y();
	   }
	   if ( myX != -1 && myY!=-1 )
      {
         // obtemos uma posio vlida
	      for( Iterator iter = currentDisasterSpace.buildings.iterator();
	           iter.hasNext(); )
	      {
            building = (Building)iter.next();
	         testX = building.x();
	         testY = building.y();
	         double x1 = Math.pow( ( testX - myX ), 2); //(( testX - myX ) * ( testX - myX ));//
	         double y1= Math.pow( ( testY - myY ),2);  //(( testY - myY ) * ( testY - myY ));
	         double z = x1 + y1 ;
	         double r2= Math.pow(hearRadius_mm, 2);
	         if ( z <=  r2 )
            {
	            col.add(building);
	            // println("Building adicionado" + building+ " com x="+testX+ " e y ="+testY);		
	         }
	      }
	   }
	   return col;
   }

   // *************************************************************************
   //                         howManyCiviliansWithKnownPosition
   //
   //               ArrayList howManyCiviliansWithKnownPosition()
   // *************************************************************************
   protected ArrayList howManyCiviliansWithKnownPosition()
   {
      ArrayList al= new ArrayList();
	   Civilian civ=null;

	   for( Iterator iter = currentDisasterSpace.civilians.iterator();
           iter.hasNext(); )
	   {
	      civ = ( Civilian )iter.next();
	      if( civ.position()!= null )
         {
            //	println("Civilian com posicao conhecida...");
            al.add(civ);
	      }
	   }
	   return al;
   }
   
   // *************************************************************************
   //                         getNearestCivilianWithKnownPosition
   //
   //               Civilian getNearestCivilianWithKnownPosition()
   // *************************************************************************
   protected Civilian getNearestCivilianWithKnownPosition()
   {
      Civilian nearestCivilian=null;
	   Civilian aux = null;
	   int myX = self().position().x();
	   int myY = self().position().y();
	   int auxX = -1, auxY = -1, auxEucDistance = -1;
	   int nearestEucledeanDistance = -1;
	   
	   for( Iterator iter = currentDisasterSpace.civilians.iterator();
	        iter.hasNext(); )
      {
         aux = (Civilian)iter.next();
         if( aux.position() != null)
         {
            auxX = aux.position().x();
            auxY = aux.position().y();

            if(nearestCivilian == null)
            {
               nearestCivilian = aux;
               nearestEucledeanDistance = (myX - auxX) + (myY - auxY);
               continue;
            }
            auxEucDistance = (myX - auxX) + (myY - auxY);
            if( auxEucDistance < nearestEucledeanDistance)
            {
               nearestCivilian = aux;
               nearestEucledeanDistance = auxEucDistance;
            }
         }
	   }	
      return nearestCivilian;
   }
   
   // *************************************************************************
   //                         civiliansInSenseRadius
   //
   //               Vector civiliansInSenseRadius( int senseRadius, RealObject ro)
   //   Mtodo utilitario que nos retorna os civis que estao no nosso raio sensatorial
   // *************************************************************************
   protected Vector civiliansInSenseRadius( int senseRadius, RealObject ro)
   {
      // println("civiliansInSenseRadius()...");
      Vector col= new Vector();
      int myX =-1;
      int myY =-1;
      int testX = -1;
      int testY = -1;
      double senseRadius_mm = senseRadius *1000;
	   
      Civilian  civilian = null;
	   
      if( ro instanceof Road )
      {
         ro = ((Road)ro).head();
         // ((Road)ro).tail();// Vamos assumir que ele esta' mais perto do head
      }
      if( (ro instanceof Building) || ( ro instanceof Node) )
      {
         myX = ((PointObject)ro).x();
         myY = ((PointObject)ro).y();
      }
      if ( myX != -1 && myY!=-1 )
      {
         // obtemos uma posio vlida
         for( Iterator iter = currentDisasterSpace.civilians.iterator();
              iter.hasNext(); )
         {
            civilian  = (Civilian)iter.next();
            testX = civilian.x();
            testY = civilian.y();
            double x1 = Math.pow( ( testX - myX ), 2); //(( testX - myX ) * ( testX - myX ));//
            double y1= Math.pow( ( testY - myY ),2);  //(( testY - myY ) * ( testY - myY ));
            double z = x1 + y1 ;
            double r2= Math.pow(senseRadius_mm, 2);
            if ( z <=  r2 )
            {
               col.add(civilian);
               //  println("Building adicionado" + civilian+ " com x="+testX+ " e y ="+testY);
            }
         }
      }
      return col;
   }
   
   // *************************************************************************
   //                         getNearestBuildingFromCollection
   //
   //               MotionlessObject getNearestBuildingFromCollection( Vector collection)
   //   Retorna o MotionlessObject mais perto do self da collection 
   // de MotionlessObejct's passado como argumento 
   // *************************************************************************      
   protected MotionlessObject getNearestBuildingFromCollection( Vector collection)
   {
      MotionlessObject nearestBuilding=null;
      MotionlessObject aux = null;
      int myX = self().position().x();
      int myY = self().position().y();
      int auxX = -1, auxY = -1, auxEucDistance = -1;
      int nearestEucledeanDistance = -1;
	
      for( Iterator iter = collection.iterator();
           iter.hasNext(); )
      {
         aux = (MotionlessObject)iter.next();
         if( aux.motionlessPosition() != null)
         {
            auxX = aux.x();
            auxY = aux.y();
	         
            if(nearestBuilding == null)
            {
               nearestBuilding = aux;
               nearestEucledeanDistance = (myX - auxX) + (myY - auxY);
               continue;
            }
            auxEucDistance = (myX - auxX) + (myY - auxY);
            if( auxEucDistance < nearestEucledeanDistance)
            {
               nearestBuilding = aux;
               nearestEucledeanDistance = auxEucDistance;
            }
         }
      }
      return nearestBuilding;
   }


   private RealObject findByIdInCollection( ArrayList collection, int id)
   {
      RealObject aux = null;
	   for ( Iterator iter = collection.iterator(); iter.hasNext(); )
      {
         aux = (RealObject)iter.next();
         if( aux.id == id )
            return aux;
	   }
      return null;
	}     
	
   private void println( String str)
   {
	   //System.out.println(self().id+":"+str);
	   System.out.println(str);
	} 
}
