/* PTS */


package rCr.agent.rCrAgentBaseline;
import rCr.initiator.I_Config;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.Civilian;
import yab.agent.object.RealObject;
import yab.agent.object.MotionlessObject;
import yab.io.ProtocolConstants;
import yab.agent.object.Road;
import yab.agent.object.Refuge;
import java.util.ArrayList;
import java.util.Random;
import rCr.util.X_RcR_Accao;
import yab.agent.object.Property;
import yab.agent.Condition;
import java.util.Collection;
import yab.agent.object.AmbulanceTeam;
import java.util.Set;
import java.util.HashSet;
import java.util.Stack;
import yab.agent.DisasterSpace;
import java.util.Iterator;
import rCr.agent.skillLevel_0.I_PrimaryCapability_Civilian;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;


/**
 *  @author PTS
 *  @since SET.2001
 *  @since MAY.2004
 */
public class C_Civilian extends C_Humanoid 
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_Civilian primaryCapability;

   /*
   C := C0   // C0 representa as crenas iniciais
   I := I0   // I0 representa as intenes iniciais
   WHILE TRUE DO
      P := obter_prxima_percepo
      C := rever_crenas( C, P )
      D := optar( C, I )
      I := filtrar( C, D, I )
      plano := construir_plano( C, I )
      executar_plano( plano )
   END WHILE
   */

   // Para teste
   private boolean ibln_moverParaAmbulancia = true;

   // -----------
   // - Crencas -
   // -----------
   // C0: informacaoGeografica (icl_representacaoDoAmbiente)

   // -----------
   // - Desejos -
   // - tipo: Accao (DA)
   // - tipo: Comunicacao (DC)
   // -----------
   // (conjunto DA)
   // DA_1: estarNoRefugio
   // DA_2: estarNaAmbulancia
   // DA_3: vaguear
   // DA_4: ficarInactivo
   // (conjunto DC)
   // DC_1: pedirAjuda
   protected Set iset_desejoAccao = new HashSet();
   protected Set iset_desejoComunicacao = new HashSet();

   // -------------
   // - Intencoes -
   // -------------
   // (pilha)
   // I0: estarNoRefugio
   protected Stack istc_intencao = new Stack();

   // Usado para numeros pseudo-aleatorios
   protected final Random icl_aleatorio;


   public C_Civilian()
   {
      icl_aleatorio = new Random();//( ( long )self().id );
   }


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryCapability_Civilian )acl_primaryCapability;
   }


   // PTS: PARA TIRAR
   public I_PrimaryAction getAgentPrimaryCapability()
   {
      return primaryCapability;
   }


   protected Civilian self()
   {
      return ( Civilian )currentDisasterSpace.self;
   }


   public void preAct()
   {
      // ----------------------------------
      // Beliefs: Informational attitudes
      // Desires: Motivational attitudes
      // Intentions: Deliberative attitudes
      // ----------------------------------

      construirDesejos( currentDisasterSpace, istc_intencao );
   }


   private void construirDesejos( DisasterSpace acl_crenca, Stack astc_intencao )
   {
      // Verificar se "estou em seguranca"
      // "estou em seguranca", se:
      // - estou num dos refugios OU estou numa ambulancia
      boolean lbln_estouNumRefugio = ( self().motionlessPosition() instanceof Refuge );
      boolean lbln_estouNumaAmbulacia = ( self().position() instanceof AmbulanceTeam );
      boolean lbln_estouEmSeguranca = lbln_estouNumRefugio || lbln_estouNumaAmbulacia;

      // Verificar se por perto existe:
      // - alguma ambulancia OU algum refugio
      boolean lbln_existeAmbulanciaPerto = ( ! acl_crenca.ambulanceTeams.isEmpty() );
      boolean lbln_existeRefugioPerto = ( ! acl_crenca.refuges.isEmpty() );

      // ------------------
      // Desejo Comunicacao
      // ------------------
      // Limpar o conjunto de "desejo comunicacao"
      iset_desejoComunicacao.clear();

      if( ( ! lbln_estouEmSeguranca ) && lbln_existeAmbulanciaPerto )
      {
         I_Desejo lcl_desejo = new I_Comunicacao()
            {
               public void realizar() throws X_RcR_Accao
               { primaryCapability.say( "AJUDA" ); }
            };
         iset_desejoComunicacao.add( lcl_desejo );
      }

      // ------------
      // Desejo Accao
      // ------------
      // Limpar o conjunto de "desejo accao"
      iset_desejoAccao.clear();

      if( ( ! lbln_estouEmSeguranca ) && lbln_existeRefugioPerto )
      {
         I_Desejo lcl_desejo = new I_EstarNoRefugio()
            {
               public void realizar() throws X_RcR_Accao
               { moverParaYab ( currentDisasterSpace.refuges ); }
            };
         iset_desejoAccao.add( lcl_desejo );
      }

      if( lbln_estouEmSeguranca )
      {
         I_Desejo lcl_desejo = new I_PermanecerInactivo()
            {
               public void realizar() throws X_RcR_Accao
               { primaryCapability.rest(); }
            };
         iset_desejoAccao.add( lcl_desejo );
      }
   }


   //protected void actuar_NOVO_EM_CONSTRUCAO()
   public void act()
   throws X_RcR_Accao
   {
      Iterator litr_iteradorDesejos;

      litr_iteradorDesejos = iset_desejoComunicacao.iterator();
      if( litr_iteradorDesejos.hasNext() )
      {
         ( ( I_Desejo )litr_iteradorDesejos.next() ).realizar();
      }

      litr_iteradorDesejos = iset_desejoAccao.iterator();
      if( litr_iteradorDesejos.hasNext() )
      {
         ( ( I_Desejo )litr_iteradorDesejos.next() ).realizar();
      }
   }


   //protected void actuar()
   public void actuar_ANTIGO()
   throws X_RcR_Accao
   {
      /*
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            "=== actuar ========================== HP:" + self().hp() );
      */

      // - R1 -
      // Se estiver dentro de uma "ambulancia"
      // entao nao faz nada ("rest")
      // - R2 -
      // Se existir alguma ambulancia visivel,
      // entao pede ("say") "ajuda" e move-se ("move") para la'
      // - R3 -
      // Se nenhuma das anteriores regras se aplicar
      // entao move-se aleatoriamente pelos varios "node"

      // Obter lista de "ambulancias" visiveis
      ArrayList larr_ambulanciasVisiveis = currentDisasterSpace.ambulanceTeams;

      // - R1 -
      // ------
      Property lcl_posicaoDeAmbulancia = Property.get( "AmbulanceTeam", "position" );
      Condition lcl_agenteEstaNumaAmbulancia = lcl_posicaoDeAmbulancia.eq( self().position() );
      Collection lcl_resultado = lcl_agenteEstaNumaAmbulancia.extract( larr_ambulanciasVisiveis );
      boolean lbln_agenteEstaNumaAmbulancia = ( ! lcl_resultado.isEmpty() );
      if( lbln_agenteEstaNumaAmbulancia )
      {
         primaryCapability.rest();
      }

      // - R2 -
      // ------
      boolean lbln_agenteTemAmbulanciasVisiveis = ( ! larr_ambulanciasVisiveis.isEmpty() );
      if( lbln_agenteTemAmbulanciasVisiveis )
      {
         // Pedir "ajuda"
         primaryCapability.say( "AJUDA" );

         // Decide mover-se para a ambulancia se ela esta' visivel
         if( ibln_moverParaAmbulancia )
         {
            // Mover para a "primeira ambulancia" que o agente esta a ver
            // (a que esta na primeira posicao do vector)
            ibln_moverParaAmbulancia = false;
            AmbulanceTeam lcl_ambulancia = ( AmbulanceTeam )( larr_ambulanciasVisiveis.get( 0 ) );
            moverParaYab ( ( MotionlessObject )( lcl_ambulancia.motionlessPosition() ) );
         }
      }

      /*
      // Obter a actual "posicao estatica" do agente
      //MotionlessObject lcl_posicaoEstatica = self().motionlessPosition();

      // Pede ajuda: vez sim, vez nao
      // Nota: "say" e "tell" nao originam excepcao (X_RcR_Accao),
      //       ou seja, numa mesma invocacao de "actuar" e' possivel:
      //       - enviar varias mensagens ("say" e "tell")
      //       - enviar uma accao (origina excepcao X_RcR_Accao)
      // ibln_pedirAjuda = ! ibln_pedirAjuda;
      //if( ibln_pedirAjuda )
      //{
         say( "AJUDA" );
      //}

      // Quando nao ha nenhuma "ambulancia" visivel,
      // anda a vaguear aleatoriamente pelos varios "node"
      //if( lcl_posicaoEstatica instanceof MotionlessObject )
      //{
         ArrayList larr_vectorNos = currentDisasterSpace.nodes;
         if( ! larr_vectorNos.isEmpty() )
         {
            // Caso exista mais do que um no' ("node") visivel,
            // escolher de modo aleatorio, um desses nos
            int lint_indice = icl_aleatorio.nextInt( larr_vectorNos.size() - 1 );
            MotionlessObject lcl_proximoDestino =
               ( MotionlessObject )( larr_vectorNos.get( lint_indice ) );

            moverPara( lcl_proximoDestino.motionlessPosition() );
         }
      //}
      */
   }


   public void postAct()
   {
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            "=== posActuar ===" );
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      System.out.println( astr_actoDiscurso );
      /*
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            astr_actoDiscurso );
      */
   }



   // -----------
   // - Desejos -
   // -----------
   public interface I_Desejo { public void realizar() throws X_RcR_Accao; }
   public interface I_EstarNoRefugio extends I_Desejo { }
   public interface I_PermanecerInactivo extends I_Desejo { }
   public interface I_Comunicacao extends I_Desejo { }
}
