/* PTS */

package rCr.agent.rCrAgentBaseline;
import rCr.initiator.I_Config;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.FireBrigade;
import yab.agent.object.Property;
import yab.agent.Condition;
import java.util.Collection;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Road;
import rCr.util.X_RcR_Accao;
import yab.agent.object.RealObject;
import yab.agent.object.Refuge;
import java.util.ArrayList;
import yab.agent.object.Building;
import yab.io.NozzleElement;
import yab.agent.Constants;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryCapability_FireBrigade;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.Civilian;
import java.util.Iterator;


/**
 *  @author PTS
 *  @version 0.0
 *  @since SET-2001
 */
public class C_FireBrigade
extends C_Humanoid
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_FireBrigade primaryCapability;

   private int buriednessNotified = 0;
   private int blockNotified = 0;
   
   protected static final Property
      FIERYNESS_PRP    = Property.get("Building", "fieryness");protected final static Property BURNING_TIME_PRP = Property.get("Building", "burningTime");protected final static Property ENTRANCE_PRP     = Property.get("Building", "entrance");
   protected static final int BURNING_TIME_OF_AN_EARLY_FIRE = 3;
   protected static final Condition
      IS_BURNING_CND = FIERYNESS_PRP.gte(1).and(FIERYNESS_PRP.lte(3));protected final static Condition IS_EARLY_CND   = BURNING_TIME_PRP.lte(BURNING_TIME_OF_AN_EARLY_FIRE);
   protected final Condition
      isNearCnd = distancePrp.lte(Constants.EXTINGUISHABLE_DISTANCE);


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryCapability_FireBrigade )acl_primaryCapability;
   }


   // PTS: PARA TIRAR
   public I_PrimaryAction getAgentPrimaryCapability()
   {
      return primaryCapability;
   }


   protected FireBrigade self()
   {
      return ( FireBrigade )currentDisasterSpace.self;
   }


   protected void reportBlockade()
   {
      MotionlessObject pos = self().motionlessPosition();

      if ( blockNotified <=5 &&
           pos instanceof Road  &&
           ( ( Road )pos ).passableLines() == 0 )
      {
         ++blockNotified;
         println("Bombeiro, FB PF ROAD_BLOCKADE ROAD"+pos.id);
         primaryCapability.tell("FB PF ROAD_BLOCKADE ROAD " + pos.id);
      }

      if ( pos instanceof Road  &&  ((Road) pos).passableLines() > 0)
         blockNotified=0;
   }


   protected void extinguishOrMove(Collection fires)
   throws X_RcR_Accao
   {
      extinguishNearFire(fires);
      moveToEntrances(fires);
   }

   protected void extinguishNearFire(Collection fires)
   throws X_RcR_Accao
   {
      Collection nearFires = isNearCnd.extract(fires);
      if ( ! nearFires.isEmpty() )
         extinguish( ( Building )BURNING_TIME_PRP.min( nearFires ) );
    }

   protected void moveToEntrances(Collection fires)
   throws X_RcR_Accao
    {
      if ( ! fires.isEmpty() )
         moverParaYab ( ENTRANCE_PRP.collect( fires ) );
    }

   protected void moveToRefuges()
   throws X_RcR_Accao
   {
      if (self().motionlessPosition() instanceof Refuge)
         primaryCapability.rest();
      moverParaYab ( currentDisasterSpace.refuges );
    }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      // ----------------------------------
      // Se estou enterrado grito por ajuda
      // ----------------------------------
      if( buriednessNotified <= 6  && self().buriedness()>0 )
      {
         println("Bombeiro, Estou enterrado e vou gritar por ajuda...");
         ++buriednessNotified;
         if ( self().position() instanceof Road )
            primaryCapability.tell("FB AT BURIED ALTO ROAD " + self().position().id  );
         if ( self().position() instanceof Building )
            primaryCapability.tell("FB AT BURIED ALTO BUILDING " + self().position().id  );
      }
	    // Reset  flag buriednessNotified
      if( self().buriedness()==0 )
         buriednessNotified=0;

      Collection fires = IS_BURNING_CND.extract( currentDisasterSpace.buildings );
      Collection earlyFires = IS_EARLY_CND.extract(fires);
	     
      extinguishNearFire(earlyFires);
      extinguishNearFire(fires);
      reportBlockade();
      moveToEntrances(earlyFires);
      moveToEntrances(fires);
      moveToRefuges();
   }


   public void postAct()
   {
   }


    protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
    {
    }


   // Extinguish fire brigade
   protected void extinguish(ArrayList targets)
   throws X_RcR_Accao
   {
      extinguish((Building[]) targets.toArray(new Building[0]));
   }

   protected void extinguish(Building target)
   throws X_RcR_Accao
   {
      extinguish(new Building[] { target });
   }

   protected void extinguish(Building[] targets)
   throws X_RcR_Accao
   {
      MotionlessObject pos = self().motionlessPosition();
      NozzleElement[] nozzles = new NozzleElement[targets.length];
      for (int i = 0;  i < nozzles.length;  i ++)
      {
         Building fire = targets[i];
         if (self().distance(fire) > Constants.EXTINGUISHABLE_DISTANCE)
            throw new Error( self() + " cannot extinguish a far building." );

         nozzles[i] = new NozzleElement( fire.id,
                                         self().direction(fire),
                                         pos.x(),
                                         pos.y(),
                                         Constants.EXTINGUISHABLE_QUANTITY / targets.length);
        }
        extinguish(nozzles);
    }


   protected void extinguish(NozzleElement[] targets)
   throws X_RcR_Accao
   {
      primaryCapability.extinguish( targets );
      throw new X_RcR_Accao();
    }
    
	protected ArrayList howManyCiviliansWithKnownPosition()
   {
      ArrayList al= new ArrayList();
      Civilian civ=null;
	   
      for( Iterator iter = currentDisasterSpace.civilians.iterator();
           iter.hasNext(); )
      {
         civ = (Civilian)iter.next();
         if(civ.position()!= null)
         {
            //	println("Civilian com posicao conhecida...");
            al.add(civ);
         }
      }
      return al;
   }

   private void println( String str)
   {
      System.out.println(str);
   }
}
