/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agent.skillLevel_0.I_PrimaryCapability_AmbulanceTeam;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet;
import rCr.agent.rCrAgentRRR.r0.C_RuleEngine;
import yab.agent.object.Humanoid;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.AmbulanceTeam;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet_AT;
import rCr.util.X_RcR_Accao;
import rCr.agent.rCrAgentRRR.r0.E_Rule;
import yab.agent.object.RealObject;
import rCr.agent.rCrAgentRRR.r1.C_PlanMonitor_Route;
import yab.agent.object.MotionlessObject;
import yab.agent.object.MovingObject;
import java.util.ArrayList;
import rCr.agentWorkingMemory.E_SpaceGrid;
import rCr.util.U_RcR;
import rCr.util.U_Geral;
import java.util.HashMap;
import yab.agent.object.Civilian;
import java.util.Collections;
import java.util.Iterator;
import yab.agent.object.Road;
import rCr.agentWorkingMemory.U_Geometry;
import java.util.List;
import rCr.agent.skillLevel_0.I_PrimaryInteraction_Constants;
import yab.agent.object.FireBrigade;
import yab.agent.object.PoliceForce;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEV.2004
 *  @author PTS
 *  @since JUN.2004
 */
public class C_AmbulanceTeam
extends C_Humanoid
implements I_Feature
{
   // Configuration Parameters
   // ========================
   // Tolerance to rescue humanoid cost [simulation cycle]
   int pint_rescueHumanoidTolerance = 0;
   // Persistence degree to Achieve Intention (move)
   // (maximum number of repairPlans)
   int pint_persistenceIntention_move = 2;
   // ========================

   // =======================================================
   // Each OTHER Institution MapGrid Coordination Perspective
   private E_SpaceGrid spaceGrid_POLICE = null;
   private E_SpaceGrid spaceGrid_FIRE = null;
   // =======================================================

   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_AmbulanceTeam primaryCapability;

   // (BEGIN) Rule Specification and Rule Engine
   // ------------------------------------------
   E_RuleSet r0_ruleSet = null;
   C_RuleEngine r0_ruleEngine = new C_RuleEngine();
   // (END) Rule Specification

   // R1 Monitor
   // ----------
   C_PlanMonitor_Route r1_panMonitor_moveREFUGE = null;

   // My Section GIS elements to Patrol: Buildings
   // (Roads are Patroled by PoliceForce)
   // --------------------------------------------
   private ArrayList iarr_mySectionToPatrol_BUILDINGS = new ArrayList();

   // Health Situation (SELF_TEAM, OTHER_TEAM, CIVILIAN)
   // (each HashMap value is a E_HealthSituation)
   HashMap health_SELF_TEAM = new HashMap();
   HashMap health_OTHER_TEAM = new HashMap();
   HashMap health_CIVILIAN = new HashMap();
   // ALL is a quick access helper structure (to SELF_TEAM, OTHER_TEAM, CIVILIAN)
   HashMap health_ALL = new HashMap();

   // Civilians that Shouted but I do not known where they are
   // (each HashMap value is an ArayList of the proximity nodes: within hear radius)
   HashMap health_CIVILIAN_UNKNOWN = new HashMap();

   // Os outros teams podem fugir sozinhos para o refuge
   // depois o disasterSpace nao reflete essa fuga
   // fico a pensar que ainda aqui esta e entro num ciclo
   // infinito de load!!
   // Solucao: nunca aceitar load de outras equipas (elas vao sozinhas para o refugio...)
   //ArrayList xxx_teamsAlreadyLoaded = new ArrayList();


   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   { this.primaryCapability = ( I_PrimaryCapability_AmbulanceTeam )acl_primaryCapability; }

   protected I_PrimaryAction getPrimaryAction()
   { return ( I_PrimaryAction )primaryCapability; }

   protected AmbulanceTeam self()
   { return ( AmbulanceTeam )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================d
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      // ----------------
      // Build R0 RuleSet
      // ----------------
      r0_ruleSet = new E_RuleSet_AT( this, primaryCapability, plannerCapability );

      // PTS
      // ----------------------------------------------------
      // Isto deve depois passar para o AgentModel
      // (o AgentModel vai "orquestrar" os niveis r0, r1 e r2
      // ----------------------------------------------------
      // Build a r1 PlanMonitor
      r1_panMonitor_moveREFUGE = new C_PlanMonitor_Route( ( MovingObject )self() );

      // --------------------------------------------------------
      // Build OTHER Institution MapGrid Coordination Perspective
      // --------------------------------------------------------
      spaceGrid_POLICE = workingMemory.getSpaceGrid_POLICE();
      spaceGrid_FIRE = workingMemory.getSpaceGrid_FIRE();
   }


   public void r1_communicateWithOtherAgents()
   {
      ArrayList larr_roadsAtSight = getRealObjectsWithinRadiusFrom(
         self().motionlessPosition().x(), self().motionlessPosition().y(),
         currentDisasterSpace.roads.iterator(), pint_visionRadius );
      informBlockade_POLICE_OFFICE ( larr_roadsAtSight );
   }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      act_v01();
   }


   private void act_v01()
   throws X_RcR_Accao
   {
      // ============================
      // Consider Kernel Startup Time
      if( currentTime <= pint_kernelStartupTime)
      { return; }
      // ============================

      // #1 [R0]
      r0_ruleEngine.updateAgenda( r0_ruleSet );

      // #2 [R0] Fire All Interactions
      r0_ruleEngine.runAgendaAllInteraction();

      // #3 [R0] Filter: rescue & load & unload & move(refuge)
      if( ! r0_ruleEngine.isAgendaActionSetEmpty() )
      {
         E_Rule lcl_firstRule = r0_ruleEngine.getAgendaFirstAction();
         String lstr_firstActionName = lcl_firstRule.getStatementName();
         boolean lbln_r0_ACCEPT = r0_filter( lstr_firstActionName, lcl_firstRule );
         // #3.1 [R0] Filter accept ==>> Inform [R1]
         if( lbln_r0_ACCEPT )
         {
            // END
            r1_inform( lstr_firstActionName, lcl_firstRule );
            // END
            r0_ruleEngine.runAgendaFirstAction();
            // END
         }
      }
      // Update: Belief
      r1_updateBelief();

      // Communicate (Blockades to PoliceForce)
      r1_communicateWithOtherAgents();

      // Build: DESIRE + PLAN
      ArrayList larr_newPlan = r1_buildNewPlan( r1_buildDesire() );

      // Persistence Degree to Achieve Intention (move Plan Execution)
      // (possivel configurar o grau de Persistencia no objectivo (move))
      // END
      r1_persistPreviousIntention( larr_newPlan );
      // END

      // END
      r1_acceptNewIntention( larr_newPlan );
      // END

      // END
      r1_gotoContingencyPlan();
      // END
      println( "---------------------------------- END (AMBULANCE TEAM) ----------------------------------" );
   }


   public void postAct()
   {
   }


   private void r1_gotoContingencyPlan()
   throws X_RcR_Accao
   {
      if( iarr_mySectionToPatrol_BUILDINGS.isEmpty() )
      {
         iarr_mySectionToPatrol_BUILDINGS = getMySection_BUILDINGS();
      }
      // -------------
      // Update Belief
      // -------------
      //r1_updateBelief( larr_newPlan );
      ArrayList larr_contingencyPlan = plannerCapability.getWiderShorterRouteTo( getMotionlessObjectHOME() );
      // END
      moveWithDefaultMonitorUsingInitialPlan( larr_contingencyPlan );
      // END
   }


   private void r1_updateBelief()
   {
      // My Position
      MotionlessObject lcl_selfPosition = self().motionlessPosition();

      iarr_mySectionToPatrol_BUILDINGS.remove( lcl_selfPosition);

      for( Iterator litf_iterator = health_CIVILIAN_UNKNOWN.values().iterator();
           litf_iterator.hasNext(); )
      {
         ArrayList larr_possibleLocations = ( ArrayList )litf_iterator.next();
         larr_possibleLocations.remove( lcl_selfPosition);
      }

      // Quando nao faz rescue (estava morto) tem que actualizar estado de vida
      // ("faz de conta" que salvou... - rever isto!!)
      for( Iterator litf_iterator = health_ALL.values().iterator();
           litf_iterator.hasNext(); )
      {
         E_HealthSituation lcl_healthSituation = ( E_HealthSituation )litf_iterator.next();
         if( lcl_selfPosition == ( MotionlessObject )( currentDisasterSpace.get( lcl_healthSituation.AGENT_POSITION ) ) )
         {
            lcl_healthSituation.setTimeOfRescue( currentTime );
         }
      }
      /*
      // Quando nao faz rescue (estava morto) tem que actualizar estado de vida
      E_HealthSituation lcl_healhSituation = new E_HealthSituation(
         currentDisasterSpace.time(), aint_AGENT_POSITION, aint_HP, aint_DAMAGE, aint_BURIEDNESS );
      updateHealthSituation( int aint_AGENT_POSITION, int aint_AGENT_ID, int aint_HP, int aint_DAMAGE, int aint_BURIEDNESS )
      for( Iterator litf_iterator = health_ALL.values().iterator();
           litf_iterator.hasNext(); )
      {
      Humanoid lcl_humanoid = health_ALL.get(
      updateHealthSituation(
      }
      */
      /*
      // Remove inconsistent Belief
      // (I think someone is here with health problem but I found none)
      for( Iterator litf_iterator = health_ALL.values().iterator();
           litf_iterator.hasNext(); )
      {
         //List lift_here = PRP_POSITION.eq( self().position() ).extract( currentDisasterSpace.humanoids );
         //List lift_here_BURIED = CND_BURIED.extract( lift_here );
         Humanoid larr_humanoidWithHealthProblem = ( Humanoid )litf_iterator.next();
         if( ( lcl_selfPosition == currentDisasterSpace.get( larr_healthSituation.AGENT_POSITION ).motionlessPosition() )
             && ninguemBuriedAqui??? como e' feita a actualizacao daquilo que desaparece???
         {
            larr_healthSituation.setTimeOfRescue( currentTime );
         }
      }
      */
   }


   private void r1_acceptNewIntention( ArrayList aarr_newPlan )
   throws X_RcR_Accao
   {
      if( ! isPlanGood( aarr_newPlan ) )
      {
         return;
      }
      // END
      moveWithDefaultMonitorUsingInitialPlan( aarr_newPlan );
      // END
   }


   private void r1_persistPreviousIntention( ArrayList aarr_newPlan )
   throws X_RcR_Accao
   {
      /*
      if( ! isPlanGood( aarr_newPlan ) )
      {
         return;
      }
      */
      //MotionlessObject lcl_newDestination = ( MotionlessObject )aarr_newPlan.get( aarr_newPlan.size() - 1 );
      if( getDefaultMonitor().isExecuting() ) //&&
          //( ! getDefaultMonitor().isEqualDestination( lcl_newDestination ) ) )
      {
         if( getDefaultMonitor().getTotalNumberOfPlanRepair() < pint_persistenceIntention_move )
         {
            // END
            moveWithDefaultMonitorToDestination( getDefaultMonitor().getPlanDestination() );
            // END
         }
      }
   }

   /**
    * Default behaviour:
    * - always accept "rescue"
    * - always accept "load"
    * - always accept "unload"
    * - only accept "move" with a Plan Monitor
    */
   private boolean r0_filter( String astr_actionName, E_Rule acl_rule )
   {
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_rescue ) )
      {
         Humanoid lcl_humanoid = ( Humanoid )( ( acl_rule.getStatementArguments() )[ 0 ] );
         Integer lInt_timeToDie = timeToDie( lcl_humanoid.hp(), lcl_humanoid.damage(), lcl_humanoid.buriedness() );
         if( lInt_timeToDie == null )
         {
            //println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> RESCUE" );
            return true;
         }
         //if( lInt_timeToDie.intValue() > 0 )
         //{ println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> RESCUE == " + lInt_timeToDie.intValue() ); }
         informRescueAccomplished_AMBULANCE_TEAM( lcl_humanoid );
         return ( lInt_timeToDie.intValue() > 0 );
      }

      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_load ) )
      {
         // println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> LOAD" );
         Object lobj_loadedHumanoid = ( Object )( acl_rule.getStatementArguments() )[ 0 ];
         if( ( lobj_loadedHumanoid instanceof AmbulanceTeam ) ||
             ( lobj_loadedHumanoid instanceof FireBrigade ) ||
             ( lobj_loadedHumanoid instanceof PoliceForce ) )
         {
            return false;
         }
         /*
         Object lobj_loadedHumanoid = ( Object )( acl_rule.getStatementArguments() )[ 0 ];
         if( xxx_teamsAlreadyLoaded.contains( lobj_loadedHumanoid ) )
         {
            return false;
         }
         */
         return true;
      }

      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_unload ) )
      {
         // println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> UNLOAD" );
         return true;
      }

      // Only accept a reactive "move refuge" (with a Plan Monitor)
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_move ) )
      {
         // println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> AmbulanceTeam:: MOVE" );
         // println( "SELF>>>> DAMAGE = " + self().damage() + " BURIEDNESS = " + self().buriedness() + "#" );
         /*
         if( ! r1_panMonitor_moveREFUGE.isExecuting() )
         {
            ArrayList larr_plan = ( ArrayList )( ( acl_rule.getStatementArguments() )[ 0 ] );
            r1_panMonitor_moveREFUGE.setON( currentTime, larr_plan );
         }
         return false;
         */
         return true;
      }
      return true;
   }


   /**
    * Default behaviour:
    */
   private void r1_inform( String astr_actionName, E_Rule acl_rule )
   throws X_RcR_Accao
   {
      // rescue: setOFF an executing monitor and update health HashMaps
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_rescue ) )
      {
         if( getDefaultMonitor().isExecuting() )
         {
            getDefaultMonitor().setOFF();
         }
         Humanoid lcl_humanoidToRescue = ( Humanoid )( acl_rule.getStatementArguments() )[ 0 ];
         E_HealthSituation lcl_healthSituation = ( E_HealthSituation )health_ALL.get( lcl_humanoidToRescue );
         if( lcl_healthSituation != null )
         {
            lcl_healthSituation.setTimeOfRescue( currentTime );
         }

         ArrayList larr_possibleLocations = ( ArrayList )health_CIVILIAN_UNKNOWN.get( lcl_humanoidToRescue );
         if( larr_possibleLocations != null )
         {
            // No more unknown locations to deal with!!
            health_CIVILIAN_UNKNOWN.put( lcl_humanoidToRescue, new ArrayList() );
         }
         return;
      }

      // load: setOFF an executing monitor
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_load ) )
      {
         if( getDefaultMonitor().isExecuting() )
         {
            getDefaultMonitor().setOFF();
         }
         /*
         Object lobj_loadedHumanoid = ( Object )( acl_rule.getStatementArguments() )[ 0 ];
         if( ( lobj_loadedHumanoid instanceof AmbulanceTeam ) ||
             ( lobj_loadedHumanoid instanceof FireBrigade ) ||
             ( lobj_loadedHumanoid instanceof PoliceForce ) )
         {
            xxx_teamsAlreadyLoaded.add( lobj_loadedHumanoid );
         }
         */
         return;
      }

      // unload: setOFF an executing monitor
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_unload ) )
      {
         if( getDefaultMonitor().isExecuting() )
         {
            getDefaultMonitor().setOFF();
         }
         return;
      }

      // move: move with monitor
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_AmbulanceTeam.kstr_move ) )
      {
         ArrayList larr_plan = ( ArrayList )( acl_rule.getStatementArguments() )[ 0 ];
         if( larr_plan.isEmpty() )
         {
            return;
         }

         if( getDefaultMonitor().isExecuting() )
         {
            moveWithDefaultMonitorToDestination( ( MotionlessObject )larr_plan.get( larr_plan.size() - 1 ) );
         }
         else
         {
            moveWithDefaultMonitorUsingInitialPlan( larr_plan );
         }
         return;
      }
   }


   private ArrayList r1_buildDesire()
   {
      // 1st: Nearby Buriedness
      ArrayList larr_result = getAndUpdateBuriednessWithinRadiusFrom(
               self().motionlessPosition(), pint_visionRadius, currentDisasterSpace.humanoids );
      //larr_result.remove( self().motionlessPosition() );
      if( ! larr_result.isEmpty() )
      {
         // println( "1st: Nearby Buriedness" );
         return larr_result;
      }

      // 2nd: SelfTeam, OtherTeam, Civilian (with known position)
      E_HealthSituation lcl_higherPriorityRescue = null;
      lcl_higherPriorityRescue = getHigherPriorityRescue( health_SELF_TEAM );
      if( lcl_higherPriorityRescue == null )
      {
         // println( "aa 2nd: SelfTeam, OtherTeam, Civilian (with known position)" );
         lcl_higherPriorityRescue = getHigherPriorityRescue( health_OTHER_TEAM );
      }
      if( lcl_higherPriorityRescue == null )
      {
         // println( "bb 2nd: SelfTeam, OtherTeam, Civilian (with known position)" );
         lcl_higherPriorityRescue = getHigherPriorityRescue( health_CIVILIAN );
      }
      if( lcl_higherPriorityRescue != null )
      {
         // println( "cc 2nd: SelfTeam, OtherTeam, Civilian (with known position)" );
         larr_result.add( currentDisasterSpace.get( lcl_higherPriorityRescue.AGENT_POSITION ).motionlessPosition() );
         larr_result.remove( self().motionlessPosition() );
      }
      if( ! larr_result.isEmpty() )
      {
         // println( "2nd: SelfTeam, OtherTeam, Civilian (with known position)" );
         return larr_result;
      }

      // 3rd: Civilian (with unknown position)
      larr_result = CND_IS_NOT_BURNING.extract( getHigherPriorityUnknownRescue( health_CIVILIAN_UNKNOWN ) );
      /*
      larr_result = getRealObjectsWithinRadiusFrom(
         self().motionlessPosition().x(),
         self().motionlessPosition().y(),
         larr_result.iterator(),
         pint_hearRadius );
      */
      larr_result.remove( self().motionlessPosition() );
      if( ! larr_result.isEmpty() )
      {
         // println( "3rd: Civilian (with unknown position)" );
         return larr_result;
      }

      // 4th: Patrol Role (not burning Buildings)
      if( ! iarr_mySectionToPatrol_BUILDINGS.isEmpty() )
      {
         larr_result = CND_IS_NOT_BURNING.extract( iarr_mySectionToPatrol_BUILDINGS );
         larr_result.remove( self().motionlessPosition() );
      }
      // println( "4th: Patrol Role (not burning Buildings)" );
      return larr_result;
   }


   private ArrayList r1_buildNewPlan( ArrayList aarr_newLocationSet )
   {
      ArrayList larr_newPlan = new ArrayList();
      if( aarr_newLocationSet.isEmpty() )
      {
         return larr_newPlan;
      }
      larr_newPlan = plannerCapability.getWiderShorterRouteTo( aarr_newLocationSet );
      /*
      // ArrayList larr_newPlan = plannerCapability.getPassableRouteTo( aarr_newLocationSet );
      if( ( larr_newPlan.size() == 1 ) &&
          ( ( MotionlessObject )larr_newPlan.get( 0 ) ) == self().motionlessPosition() )
      {
         return larr_emptyPlan;
      }
      */
      return larr_newPlan;
   }


   /*
   private void r1_updateBelief( ArrayList aarr_newPlan )
   {
      MotionlessObject lcl_destination = ( MotionlessObject )aarr_newPlan.get( aarr_newPlan.size() - 1 );
      iarr_mySectionToPatrol_BUILDINGS.remove( lcl_destination );
      for( Iterator litf_iterator = health_CIVILIAN_UNKNOWN.values().iterator();
           litf_iterator.hasNext(); )
      {
         ArrayList larr_possibleLocations = ( ArrayList )litf_iterator.next();
         larr_possibleLocations.remove( lcl_destination );
      }
   }
   */

   protected void handleHearSayXXX( RealObject acl_sender, String astr_messageContent )
   {
   }
   protected void handleHearSay( RealObject acl_sender, String astr_messageContent )
   {
      //println( "::::::::::::::::::::::::::::::::::: AT -- RECEBI (say): " + astr_messageContent + " " + acl_sender.id );
      if( astr_messageContent.equalsIgnoreCase( pstr_TOKEN_HELP_ME ) )
      {
         // println( "::::::::::::::::::::::::::::::::::: AT -- ACEITEI HELP_ME: " + astr_messageContent + " " + acl_sender.id );
         RealObject lcl_civilianPosition = ( ( Civilian )acl_sender ).position();
         if( lcl_civilianPosition != null )
         {
            //println( "::::::::::::::::::::::::::::::::::: AT -- HELP_ME POSICAO CONHECIDA ");
            int x0 = self().motionlessPosition().x();
            int y0 = self().motionlessPosition().y();
            int x1 = lcl_civilianPosition.motionlessPosition().x();
            int y1 = lcl_civilianPosition.motionlessPosition().y();
            boolean lbln_upToDateInformation = ( U_Geometry.getPointToPointDistance( x0, y0, x1, y1 ) <= pint_visionRadius );
            // Known, or up to date, position
            if( lbln_upToDateInformation )
            {
               int AGENT_POSITION = lcl_civilianPosition.motionlessPosition().id;
               int AGENT_ID = ( ( Civilian )acl_sender ).id;
               int HP = ( ( Civilian )acl_sender ).hp();
               int DAMAGE = ( ( Civilian )acl_sender ).damage();
               int BURIEDNESS = ( ( Civilian )acl_sender ).buriedness();
               updateHealthSituation( AGENT_POSITION, AGENT_ID, HP, DAMAGE, BURIEDNESS );
               return;
            }
         }
         //println( "::::::::::::::::::::::::::::::::::: AT -- HELP_ME POSICAO NNNNNNNAAAAAAOOOOOOO CONHECIDA ");
         // Unknown, or out of date, position
         // (keep location: all nodes from current position within hear radius)
         ArrayList larr_locationList = getRealObjectsWithinRadiusFrom(
            self().motionlessPosition().x(),
            self().motionlessPosition().y(),
            currentDisasterSpace.buildings.iterator(),
            pint_hearRadius );
         // Do not overlap
         // Some locations may already be Patrolled
         if( health_CIVILIAN_UNKNOWN.get( acl_sender ) == null )
         {
            health_CIVILIAN_UNKNOWN.put( acl_sender, larr_locationList );
         }
         return;
      }

      String[] larr_situationType = astr_messageContent.split( pstr_SITUATION_SEPARATOR);
      if( larr_situationType.length <= 1 )
      {
         return;
      }
      String lstr_situation = larr_situationType[ 0 ];
      String lstr_content = larr_situationType[ 1 ];
      // Deal with HEALTH messages
      //--------------------------
      if( lstr_situation.equalsIgnoreCase( pstr_SITUATION_HEALTH_RESCUE_ACCOMPLISHED ) )
      {
         assertMessageReception_RESCUE_ACCOMPLISHED( lstr_content );
      }
   }

   protected void handleHearTellXXX( RealObject acl_sender, String astr_messageContent )
   {
   }

   // HEALTH@ADB AgPOS AgID#DB AgPOS AgID#...
   protected void handleHearTell( RealObject acl_sender, String astr_messageContent )
   {
      //println( "::::::::::::::::::::::::::::::::::: AT -- RECEBI (tell): " + astr_messageContent );
      String[] larr_situationType = astr_messageContent.split( pstr_SITUATION_SEPARATOR);
      if( larr_situationType.length <= 1 )
      {
         //println( "????????????????????????????? AT -- RECEBI (tell): sem SITUATION DATA ?????????????????????????????" );
         return;
      }
      String lstr_situation = larr_situationType[ 0 ];
      String lstr_content = larr_situationType[ 1 ];
      // Deal with HEALTH messages
      //--------------------------
      if( lstr_situation.equalsIgnoreCase( pstr_SITUATION_HEALTH ) )
      {
         assertMessageReception_HEALTH( lstr_content );
      }
      if( lstr_situation.equalsIgnoreCase( pstr_SITUATION_HEALTH_CIVILIAN_UNKNOWN ) )
      {
         assertMessageReception_HEALTH_CIVILIAN_UNKNOWN( lstr_content );
      }
   }


   private void assertMessageReception_RESCUE_ACCOMPLISHED( String astr_message )
   {
      String[] larr_messageBlockSet = astr_message.split( pstr_BLOCK_SEPARATOR );
      for( int lint_blockLoop = 0; lint_blockLoop < larr_messageBlockSet.length; lint_blockLoop++ )
      {
         String[] larr_messageToken = larr_messageBlockSet[ lint_blockLoop ].split( pstr_TOKEN_SEPARATOR );
         int HUMANOID_ID = U_Geral.paraInt( larr_messageToken[ 0 ] );

         Humanoid lcl_civilianRescued = ( Humanoid )currentDisasterSpace.get( HUMANOID_ID );

         health_CIVILIAN_UNKNOWN.put( lcl_civilianRescued, new ArrayList() );

         E_HealthSituation lcl_oldValue = ( E_HealthSituation )health_ALL.get( lcl_civilianRescued );
         if( lcl_oldValue == null )
         {
            health_ALL.put( lcl_civilianRescued, new E_HealthSituation( currentTime ) );
         }
         else
         {
            lcl_oldValue.setTimeOfRescue( currentTime );
         }
      }
   }


   private void assertMessageReception_HEALTH_CIVILIAN_UNKNOWN( String astr_message )
   {
      String[] larr_messageBlockSet = astr_message.split( pstr_BLOCK_SEPARATOR );
      for( int lint_blockLoop = 0; lint_blockLoop < larr_messageBlockSet.length; lint_blockLoop++ )
      {
         String[] larr_messageToken = larr_messageBlockSet[ lint_blockLoop ].split( pstr_TOKEN_SEPARATOR );
         int MOTIONLESS_POSITION_ID = U_Geral.paraInt( larr_messageToken[ 0 ] );
         int CIVILIAN_ID            = U_Geral.paraInt( larr_messageToken[ 1 ] );
         // println( "...to AT -- HEARD CIVILIAN: MOTIONLESS_POSITION_ID= " + MOTIONLESS_POSITION_ID + " CIVILIAN_ID= " + CIVILIAN_ID );
         // Unknown, or out of date, position
         // (keep location: all nodes, within hear radius, from position where civilian was heard )
         MotionlessObject lcl_civilianWasHeardHere = currentDisasterSpace.get( MOTIONLESS_POSITION_ID ).motionlessPosition();
         Civilian lcl_civilianHeard = ( Civilian )currentDisasterSpace.get( CIVILIAN_ID );
         if( health_CIVILIAN_UNKNOWN.get( lcl_civilianHeard ) != null )
         {
            return;
         }
         ArrayList larr_locationList = getRealObjectsWithinRadiusFrom(
            lcl_civilianWasHeardHere.x(),
            lcl_civilianWasHeardHere.y(),
            currentDisasterSpace.buildings.iterator(),
            pint_hearRadius );
         health_CIVILIAN_UNKNOWN.put( lcl_civilianHeard, larr_locationList );
      }
   }


   private void assertMessageReception_HEALTH( String astr_message )
   {
      String[] larr_messageBlockSet = astr_message.split( pstr_BLOCK_SEPARATOR );
      for( int lint_blockLoop = 0; lint_blockLoop < larr_messageBlockSet.length; lint_blockLoop++ )
      {
         String[] larr_messageToken = larr_messageBlockSet[ lint_blockLoop ].split( pstr_TOKEN_SEPARATOR );
         int HP               = U_Geral.paraInt( larr_messageToken[ 0 ] );
         int DAMAGE           = U_Geral.paraInt( larr_messageToken[ 1 ] );
         int BURIEDNESS       = U_Geral.paraInt( larr_messageToken[ 2 ] );
         int AGENT_POSITION   = U_Geral.paraInt( larr_messageToken[ 3 ] );
         int AGENT_ID         = U_Geral.paraInt( larr_messageToken[ 4 ] );
         // println( "HP= " + HP + " DAMAGE= " + DAMAGE + " BURIEDNESS= " + BURIEDNESS + " AGENT_POSITION= " + AGENT_POSITION + " AGENT_ID= " + AGENT_ID );
         // Update heath situation
         updateHealthSituation( AGENT_POSITION, AGENT_ID, HP, DAMAGE, BURIEDNESS );
      }
   }


   private void updateHealthSituation( int aint_AGENT_POSITION, int aint_AGENT_ID, int aint_HP, int aint_DAMAGE, int aint_BURIEDNESS )
   {
      E_HealthSituation lcl_healhSituation = new E_HealthSituation(
         currentDisasterSpace.time(), aint_AGENT_POSITION, aint_HP, aint_DAMAGE, aint_BURIEDNESS );
      RealObject lcl_realObject = currentDisasterSpace.get( aint_AGENT_ID );

      updateHealthSituationHashMap( lcl_realObject, lcl_healhSituation, health_ALL );
      if( lcl_realObject instanceof AmbulanceTeam )
      {
         updateHealthSituationPriorityHashMap( lcl_realObject, lcl_healhSituation, health_SELF_TEAM );
         return;
      }
      if( lcl_realObject instanceof Civilian )
      {
         updateHealthSituationPriorityHashMap( lcl_realObject, lcl_healhSituation, health_CIVILIAN );
         return;
      }
      updateHealthSituationPriorityHashMap( lcl_realObject, lcl_healhSituation, health_OTHER_TEAM );
   }


   private void updateHealthSituationHashMap( RealObject acl_key, E_HealthSituation acl_value, HashMap acl_hashMap )
   {
      E_HealthSituation lcl_oldValue = ( E_HealthSituation )acl_hashMap.get( acl_key );
      if( lcl_oldValue == null )
      {
         acl_hashMap.put( acl_key, acl_value );
      }
      else
      {
         lcl_oldValue.update( acl_value );
      }
   }


   private void updateHealthSituationPriorityHashMap( RealObject acl_key, E_HealthSituation acl_value, HashMap acl_hashMap )
   {
      E_HealthSituation lcl_oldValue = ( E_HealthSituation )acl_hashMap.get( acl_key );
      if( lcl_oldValue == null )
      {
         acl_hashMap.put( acl_key, acl_value );
      }
   }


   private E_HealthSituation getHigherPriorityRescue( HashMap acl_toRescue )
   {
      if( acl_toRescue.isEmpty() )
      {
         return null;
      }
      // Get first potential rescue target
      // (independently of Section Location)
      E_HealthSituation lcl_mySectionHigherPriorityRescue = null;
      E_HealthSituation lcl_otherSectionRescue = null;
      Iterator litf_iterator = acl_toRescue.values().iterator();
      boolean lbln_foundHigherPriorityRescue = false;
      while( litf_iterator.hasNext() && ( ! lbln_foundHigherPriorityRescue ) )
      {
         E_HealthSituation lcl_healthSituation = ( E_HealthSituation )litf_iterator.next();
         if( ( lcl_healthSituation.timeToDie() != null ) &&
             ( lcl_healthSituation.timeToDie().intValue() > 0 ) )
         {
            lbln_foundHigherPriorityRescue = true;
            lcl_mySectionHigherPriorityRescue = lcl_healthSituation;
         }
      }
      lcl_otherSectionRescue = lcl_mySectionHigherPriorityRescue;

      // The higher priority rescue target within my section
      // or higher priority at another Section
      while( litf_iterator.hasNext() )
      {
         E_HealthSituation lcl_healthSituation = ( E_HealthSituation )litf_iterator.next();
         if( lcl_healthSituation.timeToDie() != null )
         {
            int lint_timeToDie = lcl_healthSituation.timeToDie().intValue();
            if( lint_timeToDie > 0 )
            {
               MotionlessObject lcl_object = ( MotionlessObject )currentDisasterSpace.get( lcl_healthSituation.AGENT_POSITION );
               int x0 = lcl_object.x();
               int y0 = lcl_object.y();
               if( getMySection().isPointInsideSection( x0, y0 ) )
               {
                  if( lint_timeToDie < lcl_mySectionHigherPriorityRescue.timeToDie().intValue() )
                  {
                     lcl_mySectionHigherPriorityRescue = lcl_healthSituation;
                  }
               }
               else
               {
                  if( lint_timeToDie < lcl_otherSectionRescue.timeToDie().intValue() )
                  {
                     lcl_otherSectionRescue = lcl_healthSituation;
                  }
               }
            }
         }
      }
      if( lcl_mySectionHigherPriorityRescue == null )
      {
         return lcl_otherSectionRescue;
      }
      return lcl_mySectionHigherPriorityRescue;
   }


   private ArrayList getHigherPriorityUnknownRescue( HashMap acl_civilianWithUnknownLocation )
   {
      /*
      ArrayList larr_result = new ArrayList();
      Iterator litf_iterator = acl_civilianWithUnknownLocation.values().iterator();
      if( litf_iterator.hasNext() )
      {
         larr_result = ( ArrayList )litf_iterator.next();
      }
      */
      // The first within my section
      // or any at another Section
      // MELHORAR: devolver o que esta ha mais tempo 'a espera...
      ArrayList larr_otherSectionLocationSet = new ArrayList();
      for( Iterator litf_iterator = acl_civilianWithUnknownLocation.values().iterator();
           litf_iterator.hasNext(); )
      {
         ArrayList larr_possibleLocationSet = ( ArrayList )litf_iterator.next();
         for( Iterator litf_iteratorPossibleLocation = larr_possibleLocationSet.iterator();
              litf_iteratorPossibleLocation.hasNext(); )
         {
            MotionlessObject lcl_object = ( MotionlessObject )litf_iteratorPossibleLocation.next();
            int x0 = lcl_object.x();
            int y0 = lcl_object.y();
            if( getMySection().isPointInsideSection( x0, y0 ) )
            {
               return larr_possibleLocationSet;
            }
            else
            {
               larr_otherSectionLocationSet = larr_possibleLocationSet;
            }
         }
      }
      return larr_otherSectionLocationSet;
   }


   public ArrayList getAndUpdateBuriednessWithinRadiusFrom(
      MotionlessObject acl_fromObject, int aint_radius, ArrayList aarr_humanoids )
   {
      ArrayList larr_result = new ArrayList();
      if( aarr_humanoids.isEmpty() )
      {
         return larr_result;
      }
      // Object coordinates
      int x0 = acl_fromObject.x();
      int y0 = acl_fromObject.y();

      for( Iterator litf_iterator = aarr_humanoids.iterator();
           litf_iterator.hasNext();  )
      {
         Humanoid lcl_humanoid = ( Humanoid )litf_iterator.next();
         RealObject lcl_humanoidPosition = lcl_humanoid.position();
         if( lcl_humanoidPosition != null )
         {
            int x1 = lcl_humanoidPosition.x();
            int y1 = lcl_humanoidPosition.y();
            double ldbl_distance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );
            if( ( ldbl_distance <= aint_radius ) &&
                ( lcl_humanoid.buriedness() > 0 ) )
            {
               Integer lInt_timeToDie = timeToDie( lcl_humanoid.hp(), lcl_humanoid.damage(), lcl_humanoid.buriedness() );
               if( lInt_timeToDie != null )
               {
                  if( lInt_timeToDie.intValue() > 0 )
                  {
                     larr_result.add( lcl_humanoidPosition.motionlessPosition() );
                     // Update Health Situation
                     updateHealthSituation( lcl_humanoidPosition.motionlessPosition().id, lcl_humanoid.id,
                                            lcl_humanoid.hp(), lcl_humanoid.damage(), lcl_humanoid.buriedness() );
                  }
               }
            }
         }
      }
      return larr_result;
   }


   private void informRescueAccomplished_AMBULANCE_TEAM( Humanoid acl_humanoid )
   {
      // Send message
      // RESCUE_ACCOMPLISHED@HUMANOID_ID#
      String lstr_messageContent =
         I_PrimaryInteraction_Constants.pstr_SITUATION_HEALTH_RESCUE_ACCOMPLISHED +
         pstr_SITUATION_SEPARATOR +
         acl_humanoid.id,
         pstr_BLOCK_SEPARATOR;
      primaryCapability.say( lstr_messageContent );
      primaryCapability.tell( lstr_messageContent );
   }


   /**
    * BLOCKADE@ROAD_ID#ROAD_ID#...
    * (codigo repetido: AmbulanceTeam e FireBrigade...)
    * (falta: mecanismo para lidar com mensagens e protocolos...)
    */
   private void informBlockade_POLICE_OFFICE( ArrayList aarr_roadsAtSight )
   {
      // Build "not passable roads"
      ArrayList larr_roadsNotPassable = new ArrayList();
      for( Iterator litf_iterator = aarr_roadsAtSight.iterator();
           litf_iterator.hasNext(); )
      {
         Road lcl_road = ( Road )litf_iterator.next();
         if( lcl_road.passableLines() == 0 )
         {
            larr_roadsNotPassable.add( lcl_road );
         }
      }
      // Send message about "not passable roads"
      if( larr_roadsNotPassable.isEmpty() )
      {
         return;
      }

      // Send message
      // BLOCKADE@ROAD_ID#ROAD_ID#...
      String lstr_messageContent =
         pstr_SITUATION_BLOCKADE +
         pstr_SITUATION_SEPARATOR;

      boolean lbln_stop = false;
      for( Iterator litf_iterator = larr_roadsNotPassable.iterator();
           litf_iterator.hasNext() && ( ! lbln_stop ); )
      {
         Road lcl_road = ( Road )litf_iterator.next();
         String lstr_message = U_Geral.paraString( lcl_road.id );

         int lint_totalBytes =
            lstr_messageContent.length() +
            lstr_message.length() +
            pstr_BLOCK_SEPARATOR.length();

         if( lint_totalBytes <= pint_maximum_MESSAGE_BYTES )
         {
            lstr_messageContent =
               lstr_messageContent +
               lstr_message +
               pstr_BLOCK_SEPARATOR;
         }
         else
         {
            lbln_stop = true;
         }
      }
      primaryCapability.say( lstr_messageContent );
      primaryCapability.tell( lstr_messageContent );
   }


   static public Integer timeToDie( int aint_HP, int aint_DAMAGE, int aint_BURIEDNESS )
   {
      if( aint_DAMAGE == 0 )
      {
         return null;
      }
      return new Integer( ( int )Math.ceil( aint_HP / aint_DAMAGE ) - aint_BURIEDNESS );
   }


   private void println( String astr_message )
   {
	   System.out.println( "-AT- " + astr_message );
	}





   /**
    * Health Situation to be evaluated
    * "timeToDie" assumes 1 AmbulanceRescue!!
    */
   private static class E_HealthSituation
   {
      int time;
      int AGENT_POSITION;
      int HP;
      int DAMAGE;
      int BURIEDNESS;
      int timeOfRescue = -1;

      public E_HealthSituation( int aint_time )
      {
         this.time = aint_time;
         this.timeOfRescue = aint_time;
      }

      public E_HealthSituation( int aint_time, int aint_AGENT_POSITION, int aint_HP, int aint_DAMAGE, int aint_BURIEDNESS )
      {
         this.time = aint_time;
         this.AGENT_POSITION = aint_AGENT_POSITION;
         this.HP = aint_HP;
         this.DAMAGE = aint_DAMAGE;
         this.BURIEDNESS = aint_BURIEDNESS;
      }

      public Integer timeToDie()
      {
         if( timeOfRescue >= 0 )
         {
            return null;
         }
         return C_AmbulanceTeam.timeToDie( HP, DAMAGE, BURIEDNESS );
      }

      public void setTimeOfRescue( int aint_timeOfRescue )
      {
         this.timeOfRescue = aint_timeOfRescue;
      }

      public void update( E_HealthSituation acl_healthSituation )
      {
         if( timeOfRescue >= 0 )
         {
            return;
         }
         this.time = acl_healthSituation.time;
         this.AGENT_POSITION = acl_healthSituation.AGENT_POSITION;
         this.HP = acl_healthSituation.HP;
         this.DAMAGE = acl_healthSituation.DAMAGE;
         this.BURIEDNESS = acl_healthSituation.BURIEDNESS;
      }
   }
}
