/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agent.rCrAgentRRR.C_Humanoid;
import rCr.agent.skillLevel_0.I_PrimaryCapability_FireBrigade;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet;
import rCr.agent.rCrAgentRRR.r0.C_RuleEngine;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.FireBrigade;
import rCr.util.X_RcR_Accao;
import yab.agent.object.RealObject;
import rCr.agent.rCrAgentRRR.r1.C_PlanMonitor_Route;
import java.util.Collection;
import yab.agent.object.Property;
import yab.agent.Constants;
import yab.agent.object.Refuge;
import java.util.ArrayList;
import yab.agent.object.Building;
import yab.agent.object.MotionlessObject;
import yab.io.NozzleElement;
import yab.agent.object.Civilian;
import java.util.Iterator;
import yab.agent.Condition;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet_FB;
import rCr.agentWorkingMemory.E_SpaceGrid;
import rCr.agent.rCrAgentRRR.r0.E_Rule;
import yab.agent.object.Road;
import rCr.util.U_Geral;


/**
/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEV.2004
 *  @author PTS
 *  @since JUN.2004
 */
public class C_FireBrigade
extends C_Humanoid implements I_Feature
{
   // Agent Primary Capabilities
   // --------------------------
   // Configuration Parameters
   // ========================
   // Tolerance to fire extinguish cost [simulation cycle]
   int pint_fireExtinguishTolerance = 0;

   // Persistence degree to Achieve Intention (move)
   // (maximum number of repairPlans)
   int pint_persistenceIntention_move = 2;


   // =======================================================
   // Each OTHER Institution MapGrid Coordination Perspective
   private E_SpaceGrid spaceGrid_POLICE = null;
   private E_SpaceGrid spaceGrid_AMBULANCE = null;


   private I_PrimaryCapability_FireBrigade primaryCapability;
   // (BEGIN) Rule Specification and Rule Engine
   E_RuleSet r0_ruleSet = null;
   C_RuleEngine r0_ruleEngine = new C_RuleEngine();
   // (END) Rule Specification

   // Current Water Qauntity
   // remediar...
   static final int kint_MAX_WATER = 10000;
   static final int kint_MAX_WATER_EXTINGUISH = 1000;
   static final int kint_MAX_WATER_REFUGE = 1000;
   int iint_currentWaterQuantity = kint_MAX_WATER;
   // (FIM) remendar...

   // Condition about a Near Fire
   Condition CND_IS_NEAR = PRP_DISTANCE.lte( Constants.EXTINGUISHABLE_DISTANCE );
   Condition CND_IS_MOTIONLESS_OBJECT_WITHIN_SECTON = new
      Condition()
      {
         public boolean eval( Object acl_object )
         {
            MotionlessObject lcl_motionlessObject = ( MotionlessObject )acl_object;
            int x0 = lcl_motionlessObject.x();
            int y0 = lcl_motionlessObject.y();
            return getMySection().isPointInsideSection( x0, y0 );
         }
      };

   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   { this.primaryCapability = ( I_PrimaryCapability_FireBrigade )acl_primaryCapability; }

   protected I_PrimaryAction getPrimaryAction()
   { return ( I_PrimaryAction )primaryCapability; }

   protected FireBrigade self()
   { return ( FireBrigade )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      // ----------------
      // Build R0 RuleSet
      // ----------------
      r0_ruleSet = new E_RuleSet_FB( this, primaryCapability, plannerCapability );

      // PTS
      // ----------------------------------------------------
      // Isto deve depois passar para o AgentModel
      // (o AgentModel vai "orquestrar" os niveis r0, r1 e r2
      // ----------------------------------------------------
      // Build a r1 PlanMonitor
      // r1_panMonitor_moveREFUGE = new C_PlanMonitor_Route( ( MovingObject )self() );

      // --------------------------------------------------------
      // Build OTHER Institution MapGrid Coordination Perspective
      // --------------------------------------------------------
      spaceGrid_POLICE = workingMemory.getSpaceGrid_POLICE();
      spaceGrid_AMBULANCE = workingMemory.getSpaceGrid_AMBULANCE();
   }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      act_v01();
   }


   public void act_v01()
   throws X_RcR_Accao
   {
      // ============================
      // Consider Kernel Startup Time
      if( currentTime <= pint_kernelStartupTime)
      { return; }
      // ============================

      // #1 [R0]
      // -------
      r0_ruleEngine.updateAgenda( r0_ruleSet );

      // #2 [R0] Fire All Interactions
      // -----------------------------
      r0_ruleEngine.runAgendaAllInteraction();

      // #3 [R0] Filter: rescue & load & unload & move(refuge)
      // -----------------------------------------------------
      boolean lbln_r0_ACCEPT = false;
      String lstr_firstActionName = "";
      if( ! r0_ruleEngine.isAgendaActionSetEmpty() )
      {
         E_Rule lcl_firstRule = r0_ruleEngine.getAgendaFirstAction();
         lstr_firstActionName = lcl_firstRule.getStatementName();
         lbln_r0_ACCEPT = r0_filter( lstr_firstActionName, lcl_firstRule );
         // #3.1 [R0] Filter accept ==>> Inform [R1]
         // ----------------------------------------
         if( lbln_r0_ACCEPT )
         {
            r1_inform( lstr_firstActionName, lcl_firstRule );
         }
      }

      // Sao ainda Regras de R0...
      // todo: refactoring
      Collection fires = CND_IS_BURNING.extract( currentDisasterSpace.buildings );
      Collection earlyFires = CND_IS_EARLY.extract( fires );
      Collection earlyFiresWithinSection = CND_IS_MOTIONLESS_OBJECT_WITHIN_SECTON.extract( earlyFires );
      if( self().motionlessPosition() instanceof Refuge )
      {
         if( iint_currentWaterQuantity < kint_MAX_WATER )
         {
            iint_currentWaterQuantity = iint_currentWaterQuantity + kint_MAX_WATER_REFUGE;
            primaryCapability.rest();
         }
      }
      else
      {
         if( iint_currentWaterQuantity <= 0 )
         {
            moveRefuge();
         }
      }

      //extinguishNearFire( earlyFiresWithinSection );
      extinguishNearFire( earlyFires );
      extinguishNearFire( fires );

      moveToEntrances( earlyFires );
      moveToEntrances( fires );
      moveHOME();
      //moveToRefuges(); // Aqui vai HOME!!!
   }


   public void postAct()
   {
   }


   /**
    * Default behaviour:
    * - always accept "clear"
    * - only accept "move" with a Plan Monitor
    */
   private boolean r0_filter( String astr_actionName, E_Rule acl_rule )
   {
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_FireBrigade.kstr_extinguish ) )
      {
         return true;
      }

      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_FireBrigade.kstr_move ) )
      {
         return true;
      }
      return true;
   }


   /**
    * Default behaviour:
    * - "clear": account an unexpected road clear cost
    * - "move": do nothing
    */
   private void r1_inform( String astr_actionName, E_Rule acl_rule )
   {
      // extinguish: update building situation
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_FireBrigade.kstr_extinguish ) )
      {
         return;
      }

      // move: do nothing
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_FireBrigade.kstr_move ) )
      {
         return;
      }
   }


   protected void handleHearSay( RealObject aobj_emissor, String astr_actoDiscurso )
   {
   }


   protected void handleHearTell( RealObject aobj_emissor, String astr_actoDiscurso )
   {
   }


   /*
   protected void extinguishOrMove( Collection fires )
   throws X_RcR_Accao
   {
      extinguishNearFire( fires );
      moveToEntrances( fires );
   }
   */


   protected void moveToEntrances( Collection fires )
   throws X_RcR_Accao
   {
      ArrayList larr_roadsAtSight = getRealObjectsWithinRadiusFrom(
         self().motionlessPosition().x(), self().motionlessPosition().y(),
         currentDisasterSpace.roads.iterator(), pint_visionRadius );
      informBlockade_POLICE_OFFICE ( larr_roadsAtSight );

      if ( ! fires.isEmpty() )
      {
         ArrayList larr_newPlan = plannerCapability.getPassableRouteTo( PRP_ENTRANCE.collect( fires ) );
         // END
         moveWithDefaultMonitorUsingInitialPlan( larr_newPlan );
         // END
         // moverParaYab( PRP_ENTRANCE.collect( fires ) );
      }
   }


   /**/
   protected void moveRefuge()
   throws X_RcR_Accao
   {
      if ( self().motionlessPosition() instanceof Refuge )
      {
         primaryCapability.rest();
      }
      ArrayList larr_newPlan = plannerCapability.getPassableRouteTo( currentDisasterSpace.refuges );
      moveWithDefaultMonitorUsingInitialPlan( larr_newPlan );
    }
   /**/


   /**
    * ============================================
    * PTS:
    * (BEGIN)
    * Daqui ate' ao (END) podia ficar em Regras R0
    * todo: refactoring
    */
   protected void extinguishNearFire( Collection fires )
   throws X_RcR_Accao
   {
      Collection nearFires = CND_IS_NEAR.extract( fires );
      if ( ! nearFires.isEmpty() )
      {
         extinguish( ( Building )PRP_BURNING_TIME.min( nearFires ) );
      }
   }


   protected void extinguish( ArrayList targets )
   throws X_RcR_Accao
   {
      extinguish( ( Building[] )targets.toArray( new Building[0] ) );
   }


   protected void extinguish( Building target )
   throws X_RcR_Accao
   {
      extinguish( new Building[] { target } );
   }


   protected void extinguish( Building[] targets )
   throws X_RcR_Accao
   {
      MotionlessObject pos = self().motionlessPosition();
      NozzleElement[] nozzles = new NozzleElement[ targets.length ];
      for( int i = 0;  i < nozzles.length;  i++ )
      {
         Building fire = targets[ i ];
         if( self().distance( fire ) > Constants.EXTINGUISHABLE_DISTANCE )
         {
            throw new Error( self() + " cannot extinguish a far building." );
         }
         nozzles[ i ] = new NozzleElement( fire.id,
                                           self().direction( fire ),
                                           pos.x(),
                                           pos.y(),
                                           // Constants.EXTINGUISHABLE_QUANTITY / targets.length );
                                           kint_MAX_WATER_EXTINGUISH / targets.length );
      }
      iint_currentWaterQuantity = iint_currentWaterQuantity - kint_MAX_WATER_EXTINGUISH;
      extinguish( nozzles );
   }
   /**
    * PTS:
    * (END)
    * Desde (BEGIN) podia estar em Regras R0
    * todo: refactoring
    * ============================================
    */


   protected void extinguish( NozzleElement[] targets )
   throws X_RcR_Accao
   {
      primaryCapability.extinguish( targets );
    }


   /**
    * BLOCKADE@ROAD_ID#ROAD_ID#...
    * (codigo repetido: AmbulanceTeam e FireBrigade...)
    * (falta: mecanismo para lidar com mensagens e protocolos...)
    */
   private void informBlockade_POLICE_OFFICE( ArrayList aarr_roadsAtSight )
   {
      // Build "not passable roads"
      ArrayList larr_roadsNotPassable = new ArrayList();
      for( Iterator litf_iterator = aarr_roadsAtSight.iterator();
           litf_iterator.hasNext(); )
      {
         Road lcl_road = ( Road )litf_iterator.next();
         if( lcl_road.passableLines() == 0 )
         {
            larr_roadsNotPassable.add( lcl_road );
         }
      }
      // Send message about "not passable roads"
      if( larr_roadsNotPassable.isEmpty() )
      {
         return;
      }

      // Send message
      // BLOCKADE@ROAD_ID#ROAD_ID#...
      String lstr_messageContent =
         pstr_SITUATION_BLOCKADE +
         pstr_SITUATION_SEPARATOR;

      boolean lbln_stop = false;
      for( Iterator litf_iterator = larr_roadsNotPassable.iterator();
           litf_iterator.hasNext() && ( ! lbln_stop ); )
      {
         Road lcl_road = ( Road )litf_iterator.next();
         String lstr_message = U_Geral.paraString( lcl_road.id );

         int lint_totalBytes =
            lstr_messageContent.length() +
            lstr_message.length() +
            pstr_BLOCK_SEPARATOR.length();

         if( lint_totalBytes <= pint_maximum_MESSAGE_BYTES )
         {
            lstr_messageContent =
               lstr_messageContent +
               lstr_message +
               pstr_BLOCK_SEPARATOR;
         }
         else
         {
            lbln_stop = true;
         }
      }
      primaryCapability.say( lstr_messageContent );
      primaryCapability.tell( lstr_messageContent );
   }


   private void println( String astr_message )
   {
	   System.out.println( "-FB- " + astr_message );
	}
}
