/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agentWorkingMemory.E_WorkingMemory;
import yab.agent.DisasterSpace;
import rCr.agentWorkingMemory.I_AgentWorkingMemory;
import yab.agent.object.Humanoid;
import yab.agent.object.RealObject;
import rCr.initiator.I_Config;
import yab.agent.object.MotionlessObject;
import rCr.util.X_RcR_Accao;
import java.util.Collections;
import java.util.Collection;
import yab.agent.B_GIS_Router_Yab_Adapter;
import yab.agent.Route;
import yab.agent.object.Property;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import yab.io.KaSense;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import rCr.agent.skillLevel_1.B_GIS_Router_Yab;
import rCr.agent.skillLevel_1.I_PlannerBaseline;
import yab.agent.object.Road;
import yab.agent.object.MovingObject;
import java.util.ArrayList;
import rCr.util.U_LeitorEscritorLinha;
import rCr.util.U_RcR;
import rCr.agent.rCrAgentRRR.r1.C_PlanMonitor_Route;
import rCr.agentWorkingMemory.E_SectionWithRoads;
import java.util.Iterator;
import rCr.agentWorkingMemory.U_Geometry;
import java.util.Random;


/**
 * @author PTS
 * @since JUN.2004
 */
abstract public class C_Humanoid
extends C_Agent
{
   // Configuration Parameters
   // ========================
   // Simulation Kernel startup time [simulation cycle]
   protected int pint_kernelStartupTime = 5;
   // The waiting time before repairing a plan [simulation cycle]
   protected int pint_admissibleWaitingTime = 1;
   // ========================

   // The Humanoid HOME (within the Space Grid)
   // - r2 (Coordination and Cooperation: Social (Macro) Level)
   protected MotionlessObject HOME = null;

   // The Humanoid
   // - r1 (Motivation and Deliberation: Self (Micro) Level)
   private C_PlanMonitor_Route r1_planMonitor = null;


   /**
    * Utility Property
    */
   protected final Property PRP_DISTANCE =
      new Property()
      {
         public Object eval( Object obj )
         {
            return new Integer( self().distance( ( RealObject ) obj ) );
         }
      };


   // ==================================================
   // To support the "moveWithMonitor" utility method
   abstract protected I_PrimaryAction getPrimaryAction();
   // ==================================================


   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   private Humanoid self()
   { return ( Humanoid )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      // Initialize HOME
      // ---------------
      HOME = getMotionlessObjectHOME ();

      // PTS
      // ----------------------------------------------------
      // Isto deve depois passar para o AgentModel
      // (o AgentModel vai "orquestrar" os niveis r0, r1 e r2
      // ----------------------------------------------------
      // Build a r1 PlanMonitor
      r1_planMonitor = new C_PlanMonitor_Route( ( MovingObject )self() );
   }


   protected E_SectionWithRoads getMySection()
   {
      return mySpaceGrid.getHOME( getAge() );
   }


   protected ArrayList getMySection_ROADS()
   {
      return mySpaceGrid.getHOME( getAge() ).getAllSection_ROADS();
   }


   protected ArrayList getMySection_NODES()
   {
      return mySpaceGrid.getHOME( getAge() ).getAllSection_NODES();
   }


   protected ArrayList getMySection_BUILDINGS()
   {
      return mySpaceGrid.getHOME( getAge() ).getAllSection_BUILDINGS();
   }


   protected MotionlessObject getMotionlessObjectHOME()
   {
      if( HOME == null )
      {
         HOME = mySpaceGrid.getHOME( getAge() ).getHOME();
      }
      return HOME;
   }


   /** Utility method */
   protected void moveHOME()
   throws X_RcR_Accao
   {
      ArrayList larr_plan = plannerCapability.getWiderShorterRouteTo( getMotionlessObjectHOME () );
      getPrimaryAction().move( larr_plan );
   }

   boolean isPlanGood( ArrayList aarr_plan )
   {
      if( aarr_plan.isEmpty() )
      {
         return false;
      }
      MotionlessObject lcl_firstPlanPosition = ( MotionlessObject )aarr_plan.get( 0 );
      MotionlessObject lcl_lastPlanPosition = ( MotionlessObject )aarr_plan.get( aarr_plan.size() - 1 );
      MotionlessObject lcl_selfPosition = self().motionlessPosition();
      return ( lcl_selfPosition == lcl_firstPlanPosition ) && ( lcl_selfPosition != lcl_lastPlanPosition );
   }


   /**
    * To be implemented by each subclass
    */
   public void actPreRepairPlan()
   {
   }


   C_PlanMonitor_Route getDefaultMonitor()
   {
      return r1_planMonitor;
   }


   /**
    * PTS
    * This is a new "capacity" (Level1)
    * Now is regarded as an Utility metod...
    * (TODO: refactoring)
    */
   protected void moveWithDefaultMonitorUsingInitialPlan( ArrayList acl_initialPlan )
   throws X_RcR_Accao
   {
      if( acl_initialPlan.isEmpty() )
      {
         return;
      }
      // Move only if not there, yet!
      // ----------------------------
      MotionlessObject lcl_destination = ( MotionlessObject )acl_initialPlan.get( acl_initialPlan.size() - 1 );
      if( ( self().motionlessPosition() == lcl_destination ) ||
          ( lcl_destination == null ) )
      {
         return;
      }
      // Get "current time" (from disasterSpace)
      int lint_currentTime = currentDisasterSpace.time();

      // ----------------------------
      // Rule 1:
      // - create a new "PlanMonitor"
      // ----------------------------
      //if( ( ! r1_planMonitor.isExecuting() ) ||
      //    ( ! r1_planMonitor.isEqualDestination( lcl_destination ) ) )
      //{
         r1_planMonitor.setON( lint_currentTime, acl_initialPlan );
      //   getPrimaryAction().move( acl_initialPlan ); //R1
      //}
      // ------------------
      // Execute Next Rules
      // ------------------
      executeRemainingMonitorRules( lint_currentTime, r1_planMonitor );
   }


   /**
    * PTS
    * This is a new "capacity" (Level1)
    * Now is regarded as an Utility metod...
    * (TODO: refactoring)
    */
   protected void moveWithDefaultMonitorToDestination( MotionlessObject acl_destination )
   throws X_RcR_Accao
   {
      /*
      // Move only if not there, yet!
      // ----------------------------
      if( ( self().motionlessPosition() == acl_destination ) ||
          ( acl_destination == null ) )
      {
         return;
      }
      */
      // Get "current time" (from disasterSpace)
      int lint_currentTime = currentDisasterSpace.time();
      // ----------------------------
      // Rule 1:
      // - create a new "PlanMonitor"
      // ----------------------------
      if( ( ! r1_planMonitor.isExecuting() ) ||
          ( ! r1_planMonitor.isEqualDestination( acl_destination ) ) )
      {
         ArrayList larr_plan = plannerCapability.getWiderShorterRouteTo( acl_destination );
         r1_planMonitor.setON( lint_currentTime, larr_plan );
         getPrimaryAction().move( larr_plan ); //R1
      }
      // ------------------
      // Execute Next Rules
      // ------------------
      executeRemainingMonitorRules( lint_currentTime, r1_planMonitor );
   }


   private void executeRemainingMonitorRules( int aint_currentTime, C_PlanMonitor_Route acl_monitor )
   throws X_RcR_Accao
   {
      /*
      if( ! acl_monitor.isExecuting() )
      {
         return;
      }
      */
      // ----------------------------------------
      // Always update time for an executing plan
      // ----------------------------------------
      acl_monitor.updateTime( currentDisasterSpace.time() );

      // -------------------------
      // Rule 2:
      // - Repair an existing Plan
      // -------------------------
      if( ( acl_monitor.isExecutionOutOfPlan() ) ||
          ( acl_monitor.getNeedToRepairPlan() > pint_admissibleWaitingTime) )
      {
         actPreRepairPlan();
         boolean lbln_possibleToRepair = acl_monitor.repairPlan( aint_currentTime );
         if( ! lbln_possibleToRepair )
         {
            return;
         }
         ArrayList larr_plan = acl_monitor.getRemaningPlan( aint_currentTime );
         getPrimaryAction().move( larr_plan ); //R2
      }

      // -------------------------------------------------
      // Rule 3:
      // - Go on executing and montoring the existing Plan
      // -------------------------------------------------
      if( acl_monitor.isExecuting() )
      {
         ArrayList larr_plan = acl_monitor.getRemaningPlan( aint_currentTime );
         getPrimaryAction().move( larr_plan ); //R3
      }
   }


   /** Utility method */
   protected boolean isCloserToRoadHead( Road acl_road )
   {
      boolean lbln_closerToHead = ( ( ( MovingObject  )self() ).positionExtra() < acl_road.length() / 2 );
      return lbln_closerToHead;
   }


   static public ArrayList getRealObjectsWithinRadiusFrom( int x0, int y0, Iterator aitf_iterator, int aint_radius )
   {
      ArrayList larr_result = new ArrayList();
      while( aitf_iterator.hasNext() )
      {
         RealObject lcl_realObject = ( RealObject )aitf_iterator.next();
         if( lcl_realObject instanceof MovingObject )
         {
            // Unknown Position
            if( ( ( MovingObject )lcl_realObject ).position() == null )
            {
               lcl_realObject = null;
            }
         }
         if( lcl_realObject != null )
         {
            if( U_Geometry.getPointToPointDistance( x0, y0, lcl_realObject.x(), lcl_realObject.y() ) <= aint_radius )
            {
               larr_result.add( lcl_realObject );
            }
         }
      }
      return larr_result;
   }


   public static Object randomChoice( Collection col, Random random )
   {
      if( col.isEmpty() )
         throw new Error("the col must not be empty.");

      Iterator it = col.iterator();
      for ( int i = random.nextInt( col.size() );  i > 0;  i-- )
      {
         it.next();
      }
      return it.next();
    }


   private void println( String astr_message )
   {
      System.out.println( astr_message );
   }
}
