/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agent.skillLevel_0.I_PrimaryCapability_PoliceForce;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet_PF;
import rCr.agent.rCrAgentRRR.r0.C_RuleEngine;
import java.util.ArrayList;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.PoliceForce;
import rCr.util.X_RcR_Accao;
import yab.agent.object.RealObject;
import yab.agent.object.Road;
import rCr.agent.rCrAgentRRR.r0.E_Rule;
import rCr.agent.rCrAgentRRR.r1.C_PlanMonitor_Route;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Civilian;
import yab.agent.object.MovingObject;
import rCr.util.U_RcR;
import rCr.agentWorkingMemory.U_Geometry;
import rCr.agentWorkingMemory.E_SpaceGrid;
import rCr.agent.rCrAgentRRR.C_PoliceForce;
import java.util.HashMap;
import rCr.util.U_Geral;
import java.util.Iterator;
import rCr.agent.rCrAgentRRR.r0.U_RuleSpecification_Util;
import yab.agent.Condition;
import yab.agent.object.Humanoid;
import java.util.Random;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEV.2004
 *  @author PTS
 *  @since JUN.2004
 */
public class C_PoliceForce
extends C_Humanoid
implements I_Feature
{
   // Configuration Parameters
   // ========================
   // Tolerance to clear road repair cost [simulation cycle]
   int pint_clearRoadTolerance = 0;
   // Persistence degree to Achieve Intention (move)
   // (maximum number of repairPlans)
   int pint_persistenceIntention_move = 2;
   // ========================

   // =======================================================
   // Each OTHER Institution MapGrid Coordination Perspective
   private E_SpaceGrid spaceGrid_AMBULANCE = null;
   private E_SpaceGrid spaceGrid_FIRE = null;
   // =======================================================

   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_PoliceForce primaryCapability;

   // (BEGIN) Rule Specification and Rule Engine
   // ------------------------------------------
   E_RuleSet r0_ruleSet = null;
   C_RuleEngine r0_ruleEngine = new C_RuleEngine();
   // (END) Rule Specification

   // My Section GIS elements to Patrol: Roads
   // ----------------------------------------
   private ArrayList iarr_mySectionToPatrol_ROADS = new ArrayList();

   // Blockade Situation (OTHER_TEAM)
   HashMap blockade_OTHER_TEAM = new HashMap();

   // R1 Monitor
   // ----------
   C_PlanMonitor_Route r1_panMonitor_moveREFUGE = null;


   // Condition about Vision Radius
   Condition CND_WITHIN_VISION_RADIUS = PRP_DISTANCE.lte( pint_visionRadius );


   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   { this.primaryCapability = ( I_PrimaryCapability_PoliceForce )acl_primaryCapability; }

   protected I_PrimaryAction getPrimaryAction()
   { return ( I_PrimaryAction )primaryCapability; }

   protected PoliceForce self()
   { return ( PoliceForce )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      // ----------------
      // Build R0 RuleSet
      // ----------------
      r0_ruleSet = new E_RuleSet_PF( this, primaryCapability, plannerCapability );

      // PTS
      // ----------------------------------------------------
      // Isto deve depois passar para o AgentModel
      // (o AgentModel vai "orquestrar" os niveis r0, r1 e r2
      // ----------------------------------------------------
      // Build a r1 PlanMonitor
      r1_panMonitor_moveREFUGE = new C_PlanMonitor_Route( ( MovingObject )self() );

      // --------------------------------------------------------
      // Build OTHER Institution MapGrid Coordination Perspective
      // --------------------------------------------------------
      spaceGrid_AMBULANCE = workingMemory.getSpaceGrid_AMBULANCE();
      spaceGrid_FIRE = workingMemory.getSpaceGrid_FIRE();

   }


   public void r1_communicateWithOtherAgents()
   {
      ArrayList larr_humanoidsAtSight = getRealObjectsWithinRadiusFrom(
         self().motionlessPosition().x(), self().motionlessPosition().y(),
         currentDisasterSpace.humanoids.iterator(), pint_visionRadius );
      informBuriedness_AMBULANCE_TEAM( larr_humanoidsAtSight );
   }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      act_v01();
   }


   private void act_v01()
   throws X_RcR_Accao
   {
      // ============================
      // Consider Kernel Startup Time
      if( currentTime <= pint_kernelStartupTime)
      { return; }
      // ============================

      // #1 [R0]
      r0_ruleEngine.updateAgenda( r0_ruleSet );

      // #2 [R0] Fire All Interactions
      r0_ruleEngine.runAgendaAllInteraction();

      // #3 [R0] Filter: clear & move(refuge)
      if( ! r0_ruleEngine.isAgendaActionSetEmpty() )
      {
         E_Rule lcl_firstRule = r0_ruleEngine.getAgendaFirstAction();
         String lstr_firstActionName = lcl_firstRule.getStatementName();
         boolean lbln_r0_ACCEPT = r0_filter( lstr_firstActionName, lcl_firstRule );
         // #3.1 [R0] Filter accept ==>> Inform [R1]
         if( lbln_r0_ACCEPT )
         {
            // END
            r1_inform( lstr_firstActionName, lcl_firstRule );
            // END
            r0_ruleEngine.runAgendaFirstAction();
            // END
         }
      }
      // Update: Belief
      r1_updateBelief();

      // Communicate (Health Situation to AmbulanceTeam)
      r1_communicateWithOtherAgents();

      // Build: DESIRE + PLAN
      ArrayList larr_newPlan = r1_buildNewPlan( r1_buildDesire() );

      // Persistence Degree to Achieve Intention (move Plan Execution)
      // (possivel configurar o grau de Persistencia no objectivo (move))
      // END
      r1_persistPreviousIntention( larr_newPlan );
      // END

      // END
      r1_acceptNewIntention( larr_newPlan );
      // END

      // END
      r1_gotoContingencyPlan();
      // END

      println( "---------------------------------- END (POLICE FORCE) ----------------------------------" );
   }


   public void postAct()
   {
   }


   /**
    * Default behaviour:
    * - always accept "clear"
    * - only accept "move" with a Plan Monitor
    */
   private boolean r0_filter( String astr_actionName, E_Rule acl_rule )
   {
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_PoliceForce.kstr_clear ) )
      {
         return true;
      }

      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_PoliceForce.kstr_move ) )
      {
         //println( ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> PoliceForce:: MOVE REFUGE" );
         return true;
      }
      return true;
   }


   /**
    * Default behaviour:
    * - "clear": account an unexpected road clear cost
    * - "move": do nothing
    */
   private void r1_inform( String astr_actionName, E_Rule acl_rule )
   throws X_RcR_Accao
   {
      // clear: account an unexpected road clear cost
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_PoliceForce.kstr_clear ) )
      {
         Road lcl_roadToClear = ( Road )( acl_rule.getStatementArguments() )[ 0 ];
         if( getDefaultMonitor().isExecuting() )
         {
            int lint_timeToClearRoad = lcl_roadToClear.repairCost() + pint_clearRoadTolerance;
            getDefaultMonitor().acceptUnexpectedCost( lint_timeToClearRoad );
            getDefaultMonitor().updateTime( currentTime );
         }
         E_BlockadeSituation lcl_blockadeSituation = ( E_BlockadeSituation )blockade_OTHER_TEAM.get( lcl_roadToClear );
         if( lcl_blockadeSituation != null )
         {
            // PROBLEMA: podem aparecer outros bloqueios neste sitio...
            // (nao estou a tratar isso)
            lcl_blockadeSituation.setTimeOfClear( currentTime );
         }
         return;
      }

      // move: move with monitor
      if( astr_actionName.equalsIgnoreCase( I_PrimaryCapability_PoliceForce.kstr_move ) )
      {
         ArrayList larr_plan = ( ArrayList )( acl_rule.getStatementArguments() )[ 0 ];
         if( larr_plan.isEmpty() )
         {
            return;
         }

         if( getDefaultMonitor().isExecuting() )
         {
            moveWithDefaultMonitorToDestination( ( MotionlessObject )larr_plan.get( larr_plan.size() - 1 ) );
         }
         else
         {
            moveWithDefaultMonitorUsingInitialPlan( larr_plan );
         }
         return;
      }
   }


   private ArrayList r1_buildDesire()
   {
      ArrayList larr_result = new ArrayList();
      // 1st: Reported Blockades
      larr_result = getReportedBlockades( blockade_OTHER_TEAM );
      larr_result.remove( self().motionlessPosition() );
      if( ! larr_result.isEmpty() )
      {
         return larr_result;
      }

      // 2nd: Nearby Blockades
      larr_result = getBlockadesWithinRadiusFrom(
               self().motionlessPosition(), pint_visionRadius, getMySection_ROADS() );
      larr_result.remove( self().motionlessPosition() );
      if( ! larr_result.isEmpty() )
      {
         // This "for cycle" is also an updateBelief (pre "buildNewPlan")
         // todo: refactoring
         /*
         for( Iterator litf_iterator = larr_result.iterator(); litf_iterator.hasNext(); )
         {
            Road lcl_road = ( Road )litf_iterator.next();
            updateBlockadeSituation( lcl_road.id );
         }
         */
         return larr_result;
      }

      // 3rd: Patrol Role (Roads at Section)
      if( ! iarr_mySectionToPatrol_ROADS.isEmpty() )
      {
         /*
         Integer lInt_index = U_RcR.getIndexOfFartherFrom( self().motionlessPosition(), iarr_mySectionToPatrol_ROADS );
         if( lInt_index != null )
         {
            larr_result.add( iarr_mySectionToPatrol_ROADS.get( lInt_index.intValue() ) );
         }
         */
         // Random Choice
         Object lcl_object = randomChoice( iarr_mySectionToPatrol_ROADS, new Random( currentTime ) );
         iarr_mySectionToPatrol_ROADS.remove( lcl_object );
         iarr_mySectionToPatrol_ROADS.remove( self().motionlessPosition() );
         larr_result.add( lcl_object );
      }
      larr_result.remove( self().motionlessPosition() );
      return larr_result;
   }


   private ArrayList r1_buildNewPlan( ArrayList aarr_newLocationSet )
   {
      ArrayList larr_newPlan = new ArrayList();
      if( aarr_newLocationSet.isEmpty() )
      {
         return larr_newPlan;
      }
      larr_newPlan = plannerCapability.getWiderShorterRouteTo( aarr_newLocationSet );
      /*
      ArrayList larr_emptyPlan = new ArrayList();
      if( aarr_newLocationSet.isEmpty() )
      {
         return larr_emptyPlan;
      }
      ArrayList larr_newPlan = plannerCapability.getWiderShorterRouteTo( aarr_newLocationSet );
      if( ( larr_newPlan.size() == 1 ) &&
          ( ( MotionlessObject )larr_newPlan.get( 0 ) ) == self().motionlessPosition() )
      {
         return larr_emptyPlan;
      }
      */
      return larr_newPlan;
   }


   private void r1_persistPreviousIntention( ArrayList aarr_newPlan )
   throws X_RcR_Accao
   {
      /*
      if( ! isPlanGood( aarr_newPlan ) )
      {
         return;
      }
      */
      //MotionlessObject lcl_newDestination = ( MotionlessObject )aarr_newPlan.get( aarr_newPlan.size() - 1 );
      if( getDefaultMonitor().isExecuting() ) //&&
          //( ! getDefaultMonitor().isEqualDestination( lcl_newDestination ) ) )
      {
         if( getDefaultMonitor().getTotalNumberOfPlanRepair() < pint_persistenceIntention_move )
         {
            // END
            moveWithDefaultMonitorToDestination( getDefaultMonitor().getPlanDestination() );
            // END
         }
      }
   }


   private void r1_acceptNewIntention( ArrayList aarr_newPlan )
   throws X_RcR_Accao
   {
      if( ! isPlanGood( aarr_newPlan ) )
      {
         return;
      }
      // END
      moveWithDefaultMonitorUsingInitialPlan( aarr_newPlan );
      // END
   }


   private void r1_gotoContingencyPlan()
   throws X_RcR_Accao
   {
      //if( iarr_mySectionToPatrol_ROADS.isEmpty() )
      //{
         iarr_mySectionToPatrol_ROADS = getMySection_ROADS(); //getMySection_BUILDINGS();
      //}
      ArrayList larr_contingencyPlan = plannerCapability.getWiderShorterRouteTo( getMotionlessObjectHOME() );
      // END
      moveWithDefaultMonitorUsingInitialPlan( larr_contingencyPlan );
      // END
   }


   private void r1_updateBelief()
   {
      // My Position
      MotionlessObject lcl_selfPosition = self().motionlessPosition();
      iarr_mySectionToPatrol_ROADS.remove( lcl_selfPosition );

      // O bloqueio pode ter sido limpo por outro agente!!
      E_BlockadeSituation lcl_blockadeSituation = ( E_BlockadeSituation )blockade_OTHER_TEAM.get( lcl_selfPosition );
      if( lcl_blockadeSituation != null )
      {
         // PROBLEMA: podem aparecer outros bloqueios neste sitio...
         // (nao estou a tratar isso)
         lcl_blockadeSituation.setTimeOfClear( currentTime );
      }
   }


   protected void handleHearSay( RealObject acl_sender, String astr_messageContent )
   {
      //println( "::::::::::::::::::::::::::::::::::: PF -- RECEBI (say): " + astr_messageContent + " " + acl_sender.id );
      if( astr_messageContent.equalsIgnoreCase( pstr_TOKEN_HELP_ME) )
      {
         RealObject lcl_civilianPosition = ( ( Civilian )acl_sender ).position();
         if( lcl_civilianPosition != null )
         {
            int x0 = self().motionlessPosition().x();
            int y0 = self().motionlessPosition().y();
            int x1 = lcl_civilianPosition.motionlessPosition().x();
            int y1 = lcl_civilianPosition.motionlessPosition().y();
            boolean lbln_upToDateInformation = ( U_Geometry.getPointToPointDistance( x0, y0, x1, y1 ) <= pint_visionRadius );
            // Known, or up to date, position
            if( lbln_upToDateInformation )
            {
               String lstr_message = U_RuleSpecification_Util.buildMessage_HDB_POS_ID( ( Civilian )acl_sender );
               lstr_message =
                  pstr_SITUATION_HEALTH +
                  pstr_SITUATION_SEPARATOR +
                  lstr_message +
                  pstr_BLOCK_SEPARATOR;
               primaryCapability.tell( lstr_message );
               return;
            }
         }
         int MY_MOTIONLESS_POSITION_ID = self().motionlessPosition().id;
         int CIVILIAN_ID = acl_sender.id;
         String lstr_message =
            pstr_SITUATION_HEALTH_CIVILIAN_UNKNOWN +
            pstr_SITUATION_SEPARATOR +
            U_Geral.paraString( MY_MOTIONLESS_POSITION_ID ) +
            pstr_TOKEN_SEPARATOR +
            U_Geral.paraString( CIVILIAN_ID ) +
            pstr_BLOCK_SEPARATOR;
         primaryCapability.tell( lstr_message );
         return;
      }
   }


   /**
    * BLOCKADE ROAD_ID ...
    */
   protected void handleHearTell( RealObject acl_sender, String astr_messageContent )
   {
      //println( "::::::::::::::::::::::::::::::::::: POLICE FORCE -- RECEBI (tell): " + astr_messageContent );
      String[] larr_situationType = astr_messageContent.split( pstr_SITUATION_SEPARATOR);
      if( larr_situationType.length <= 1 )
      {
         //println( "????????????????????????????? POLICE FORCE -- RECEBI (tell): sem SITUATION DATA ?????????????????????????????" );
         return;
      }
      String lstr_situation = larr_situationType[ 0 ];
      String lstr_content = larr_situationType[ 1 ];
      // Deal with BLOCKADE messages
      //----------------------------
      if( lstr_situation.equalsIgnoreCase( pstr_SITUATION_BLOCKADE ) )
      {
         assertMessageReception_BLOCKADE( lstr_content );
      }
   }


   private void assertMessageReception_BLOCKADE( String astr_message )
   {
      String[] larr_messageBlockSet = astr_message.split( pstr_BLOCK_SEPARATOR );
      for( int lint_blockLoop = 0; lint_blockLoop < larr_messageBlockSet.length; lint_blockLoop++ )
      {
         String[] larr_messageToken = larr_messageBlockSet[ lint_blockLoop ].split( pstr_TOKEN_SEPARATOR );
         int ROAD_ID = U_Geral.paraInt( larr_messageToken[ 0 ] );
         // Update blockade situation
         updateBlockadeSituation( ROAD_ID );
      }
   }


   private void updateBlockadeSituation( int aint_ROAD_ID )
   {
      E_BlockadeSituation lcl_healhSituation = new E_BlockadeSituation( currentDisasterSpace.time(), aint_ROAD_ID );
      RealObject lcl_realObject = currentDisasterSpace.get( aint_ROAD_ID );
      updateBlockadeSituationHashMap( lcl_realObject, lcl_healhSituation, blockade_OTHER_TEAM );
   }


   private void updateBlockadeSituationHashMap( RealObject acl_key, E_BlockadeSituation acl_value, HashMap acl_hashMap )
   {
      E_BlockadeSituation lcl_oldValue = ( E_BlockadeSituation )acl_hashMap.get( acl_key );
      if( lcl_oldValue == null )
      {
         acl_hashMap.put( acl_key, acl_value );
      }
      else
      {
         lcl_oldValue.update( acl_value );
      }
   }


   private ArrayList getReportedBlockades( HashMap acl_toClear )
   {
      ArrayList larr_result = new ArrayList();
      for( Iterator litf_iterator = acl_toClear.values().iterator();
           litf_iterator.hasNext(); )
      {
         E_BlockadeSituation lcl_blockadeSituation = ( E_BlockadeSituation )litf_iterator.next();
         if( ! lcl_blockadeSituation.isClear() )
         {
            int x = currentDisasterSpace.get( lcl_blockadeSituation.ROAD_ID ).x();
            int y = currentDisasterSpace.get( lcl_blockadeSituation.ROAD_ID ).y();
            if( getMySection().isPointInsideSection( x, y ) )
            {
               larr_result.add( currentDisasterSpace.get( lcl_blockadeSituation.ROAD_ID ).motionlessPosition() );
            }
         }
      }
      return larr_result;
   }


   public ArrayList getBlockadesWithinRadiusFrom( MotionlessObject acl_fromObject, int aint_radius, ArrayList aarr_roads )
   {
      ArrayList larr_result = new ArrayList();
      if( aarr_roads.isEmpty() )
      {
         return larr_result;
      }
      // Object coordinates
      int x0 = acl_fromObject.x();
      int y0 = acl_fromObject.y();

      // Iterate go get Road Blockades
      for( Iterator litf_iterator = aarr_roads.iterator();
           litf_iterator.hasNext();  )
      {
         Road lcl_road = ( Road )litf_iterator.next();
         int x1 = lcl_road.x();
         int y1 = lcl_road.y();
         double ldbl_distance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );
         if( ( ldbl_distance <= aint_radius ) &&
             ( lcl_road.passableLines() == 0 ) )
         {
            larr_result.add( lcl_road.motionlessPosition() );
         }
      }
      return larr_result;
   }


   /**
    * HEALTH@H D B AG_POS AG_ID#...
    */
   private void informBuriedness_AMBULANCE_TEAM( ArrayList aarr_humanoidsAtSight )
   {
      // Build "buried humanoids"
      ArrayList larr_humanoidsBuried = new ArrayList();
      for( Iterator litf_iterator = aarr_humanoidsAtSight.iterator();
           litf_iterator.hasNext(); )
      {
         Humanoid lcl_humanoid = ( Humanoid )litf_iterator.next();
         if( lcl_humanoid.buriedness() > 0 )
         {
            Integer lInt_timeToDie = C_AmbulanceTeam.timeToDie(
               lcl_humanoid.hp(), lcl_humanoid.damage(), lcl_humanoid.buriedness() );
            if( lInt_timeToDie != null )
            {
               if( lInt_timeToDie.intValue() > 0 )
               {
                  larr_humanoidsBuried.add( lcl_humanoid );
               }
            }
         }
      }
      // Send message about "buried humanoids"
      if( larr_humanoidsBuried.isEmpty() )
      {
         return;
      }

      // HEALTH@ADB AgPOS AgID#DB AgPOS AgID#...
      String lstr_messageContent =
         pstr_SITUATION_HEALTH +
         pstr_SITUATION_SEPARATOR;

      boolean lbln_stop = false;
      for( Iterator litf_iterator = larr_humanoidsBuried.iterator();
           litf_iterator.hasNext() && ( ! lbln_stop ); )
      {
         Humanoid lcl_humanoid = ( Humanoid )litf_iterator.next();
         String lstr_message = U_RuleSpecification_Util.buildMessage_HDB_POS_ID( lcl_humanoid );

         int lint_totalBytes =
            lstr_messageContent.length() +
            lstr_message.length() +
            pstr_BLOCK_SEPARATOR.length();

         if( lint_totalBytes <= pint_maximum_MESSAGE_BYTES )
         {
            lstr_messageContent =
               lstr_messageContent +
               lstr_message +
               pstr_BLOCK_SEPARATOR;
         }
         else
         {
            lbln_stop = true;
         }
      }
      primaryCapability.say( lstr_messageContent );
      primaryCapability.tell( lstr_messageContent );
   }


   private void println( String astr_message )
   {
      System.out.println( "-PF- " + astr_message );
   }


   /**
    * Health Situation to be evaluated
    * "timeToDie" assumes 1 AmbulanceRescue!!
    */
   private static class E_BlockadeSituation
   {
      int time;
      int ROAD_ID;
      int timeOfClear = -1;

      public E_BlockadeSituation( int aint_time, int aint_ROAD_ID )
      {
         this.time = aint_time;
         this.ROAD_ID = aint_ROAD_ID;
      }

      public boolean isClear()
      {
         return ( timeOfClear >= 0 );
      }

      public void setTimeOfClear( int aint_timeOfClear )
      {
         this.timeOfClear = aint_timeOfClear;
      }

      public void update( C_PoliceForce.E_BlockadeSituation acl_blockadeSituation )
      {
         if( timeOfClear >= 0 )
         {
            return;
         }
         this.time = acl_blockadeSituation.time;
         this.ROAD_ID = acl_blockadeSituation.ROAD_ID;
      }
   }
}
