/* PTS */


package rCr.agent.rCrAgentRRR;


import yab.agent.object.Property;
import yab.agent.Condition;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public interface I_Feature
{
   int BURNING_TIME_OF_AN_EARLY_FIRE = 3;

   Property
      PRP_MOTIONLESS_POSITION = Property.get( "MovingObject", "motionlessPosition" ),
      PRP_POSITION            = Property.get( "MovingObject", "position" ),
      // -------------------
      // Humanoid Properties
      // -------------------
      PRP_HP                  = Property.get( "Humanoid", "hp" ),
      PRP_DAMAGE              = Property.get( "Humanoid", "damage" ),
      PRP_BURIEDNESS          = Property.get( "Humanoid", "buriedness" ),
      // -------------------
      // Building Properties
      // -------------------
      PRP_FIERYNESS     = Property.get( "Building", "fieryness" ),
      PRP_ENTRANCE      = Property.get("Building", "entrance"),
      PRP_BURNING_TIME  = Property.get( "Building", "burningTime" );


   Condition
      // ----------------------
      // Humanoid health status
      // ----------------------
      CND_ALIVE   = PRP_HP.gt( 0 ),
      CND_DAMAGE  = PRP_DAMAGE.gt( 0 ),
      CND_BURIED  = PRP_BURIEDNESS.gt( 0 ),

      // ------------------
      // Humanoid situation
      // ------------------
      // ALIVE | DAMAGE | BURIED | AmbulanceTeam
      // ---------------------------------------
      //   1   |   1    |   0    | load
      //   1   |  0|1   |   1    | rescue
      //   0   |  0|1   |  0|1   | tell ALL
      // ----------------------------------------
      CND_ALIVE_DAMAGE_NOT_BURIED   = CND_ALIVE.and( CND_DAMAGE.and( CND_BURIED.not() ) ),
      CND_ALIVE_x_BURIED            = CND_ALIVE.and( CND_BURIED ),
      CND_NOT_ALIVE_x_x             = CND_ALIVE.not(),

      // ------------------
      // Building situation
      // ------------------
      // isNotBurning == ( fieryness < 1 OR fieryness > 3 )
      CND_IS_NOT_BURNING   = PRP_FIERYNESS.lt( 1 ).or( PRP_FIERYNESS.gt( 3 ) ),
      CND_IS_BURNING       = PRP_FIERYNESS.gte( 1 ).and( PRP_FIERYNESS.lte( 3 ) ),
      CND_IS_EARLY         = PRP_BURNING_TIME.lte( BURNING_TIME_OF_AN_EARLY_FIRE ),

      // --------------------
      // Perception situation
      // --------------------
      CND_HAS_NOT_BEEN_SEEN = Property.get( "RealObject",  "hasBeenSeen" ).equal( Boolean.FALSE );
}
