/* PTS */


package rCr.agent.rCrAgentRRR.r0;
import java.util.Iterator;
import rCr.util.X_RcR_Accao;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class C_RuleEngine
{
   /**
    * @link dependency
    * @supplierRole visitedRuleSet
    */
   /*# E_RuleSet lnkE_RuleSet; */
   /**
    * @directed
    * @supplierRole agenda
    */
   // Agent is itself also a RuleSet
   // (with "readyToFire" Rules
   //  obtained from each "updateAgenda" execution)
   private E_RuleSet icl_agenda = new E_RuleSet();


   public void updateAgenda( E_RuleSet acl_availableRuleSet )
   {
      // -----------------------
      // Initialize a new Agenda
      // -----------------------
      icl_agenda = new E_RuleSet();

      // Add to the Agenda each "readyToFire" Rule from acl_availableRuleSet
      updateAgendaInteractionSet( acl_availableRuleSet );
      updateAgendaActionSet( acl_availableRuleSet );
   }


   public void runAgendaAllInteraction()
   throws X_RcR_Accao
   {
      for( int lint_iLoop = 0; lint_iLoop < icl_agenda.getInteractionSetSize(); lint_iLoop++ )
      {
         runAgendaInteraction( lint_iLoop );
      }
   }


   public void runAgendaInteraction( int aint_index )
   throws X_RcR_Accao
   {
      if( ( aint_index >= 0 ) && ( aint_index < icl_agenda.getInteractionSetSize() ) )
      {
         icl_agenda.getInteractionRule( aint_index ).fire();
      }
   }


   public void runAgendaFirstAction()
   throws X_RcR_Accao
   {
      if( icl_agenda.getActionSetSize() > 0 )
      {
         icl_agenda.getActionRule( 0 ).fire();
      }
   }


   public void runAgendaAction( int aint_index )
   throws X_RcR_Accao
   {
      if( ( aint_index >= 0 ) && ( aint_index < icl_agenda.getActionSetSize() ) )
      {
         icl_agenda.getActionRule( aint_index ).fire();
      }
   }


   public boolean isAgendaInteractionSetEmpty()
   {
      return ( icl_agenda.getInteractionSetSize() <= 0 );
   }


   public boolean isAgendaActionSetEmpty()
   {
      return ( icl_agenda.getActionSetSize() <= 0 );
   }


   public E_Rule getAgendaFirstAction()
   {
      E_Rule lcl_firstRule = null;
      if( ! isAgendaActionSetEmpty() )
      {
         lcl_firstRule = icl_agenda.getActionRule( 0 );
      }
      return lcl_firstRule;
   }


   /**
    * All "readyToFire" interaction rules go to the Agenda
    */
   private void updateAgendaInteractionSet( E_RuleSet acl_availableRuleSet )
   {
      for( Iterator litf_iterator = acl_availableRuleSet.iteratorInteractionSet();
           litf_iterator.hasNext(); )
      {
         E_Rule lcl_rule = ( E_Rule )( litf_iterator.next() );
         if( lcl_rule.isReadyToFire() )
         {
            // Add Rule to Agenda
            // (do not change its "salience")
            icl_agenda.addInteractionRule( lcl_rule, lcl_rule.getSalience() );
         }
      }
   }


   /**
    * The first "readyToFire" action rule along
    * with all rules with that same salience
    * that are also "readyToFire" all go to the Agenda
    * 
    */
   private void updateAgendaActionSet( E_RuleSet acl_availableRuleSet )
   {
      boolean lbln_stop = false;
      boolean lbln_ruleFound = false;
      int lint_ruleFoundSalience = Integer.MIN_VALUE;
      for( Iterator litf_iterator = acl_availableRuleSet.iteratorActionSet();
           litf_iterator.hasNext() && ( ! lbln_stop ); )
      {
         E_Rule lcl_rule = ( E_Rule )( litf_iterator.next() );
         int lint_currentRuleSalience = lcl_rule.getSalience();

         lbln_stop = ( lbln_ruleFound ) ?
                     ( lint_ruleFoundSalience != lint_currentRuleSalience )
                     :
                     false;

         if( ! lbln_stop )
         {
            if( lcl_rule.isReadyToFire() )
            {
               if( ! lbln_ruleFound )
               {
                  lbln_ruleFound = true;
                  lint_ruleFoundSalience = lint_currentRuleSalience;
               }
               // Add Rule to Agenda
               // (do not change its "salience")
               icl_agenda.addActionRule( lcl_rule, lint_currentRuleSalience );
            }
         }
      }
   }
}
