/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class E_RuleSet
{
   /**
    * @link aggregation
    * @associates rCr.agent.rCrAgentRRR.r0.E_Rule
    * @directed
    * @supplierRole interactionSet
    */
   private List ilst_interactionSet = new ArrayList();
   /**
    * @link aggregation
    * @associates rCr.agent.rCrAgentRRR.r0.E_Rule
    * @directed
    * @supplierRole actionSet
    */
   private List ilst_actionSet = new ArrayList();


   public void addInteractionRule( E_Rule acl_ruleToAdd, int aint_ruleSalience )
   {
      addRule( acl_ruleToAdd, aint_ruleSalience, ilst_interactionSet );
   }


   public void addActionRule( E_Rule acl_ruleToAdd, int aint_ruleSalience )
   {
      addRule( acl_ruleToAdd, aint_ruleSalience, ilst_actionSet );
   }


   public E_Rule getInteractionRule( int aint_index )
   {
      return ( E_Rule )ilst_interactionSet.get( aint_index );
   }


   public E_Rule getActionRule( int aint_index )
   {
      return ( E_Rule )ilst_actionSet.get( aint_index );
   }


   public Iterator iteratorInteractionSet()
   {
      return ilst_interactionSet.iterator();
   }


   public Iterator iteratorActionSet()
   {
      return ilst_actionSet.iterator();
   }


   public int getInteractionSetSize()
   {
      return ilst_interactionSet.size();
   }


   public int getActionSetSize()
   {
      return ilst_actionSet.size();
   }


   private void addRule( E_Rule acl_ruleToAdd, int aint_ruleToAddSalience, List alst_ruleSet  )
   {
      acl_ruleToAdd.setSalience( aint_ruleToAddSalience );
      insertLaterInSalienceAscendentOrder( acl_ruleToAdd, aint_ruleToAddSalience, alst_ruleSet );
   }


   private void insertLaterInSalienceAscendentOrder( E_Rule acl_ruleToAdd, int aint_ruleToAddSalience, List alst_ruleSet  )
   {
      final int lint_ruleSetSize = alst_ruleSet.size();
      int lint_insertIndex = lint_ruleSetSize;
      int lint_iLoop = 0;
      boolean lbln_foundIndex = false;
      while( ( ! lbln_foundIndex ) && ( lint_iLoop < lint_ruleSetSize ) )
      {
         E_Rule lcl_ruleFromSet = ( E_Rule )alst_ruleSet.get( lint_iLoop );
         int lint_ruleFromSetSalience = lcl_ruleFromSet.getSalience();
         // Set the Ascendent order relation
         // --------------------------------
         lbln_foundIndex = ( aint_ruleToAddSalience < lint_ruleFromSetSalience );
         lint_iLoop++;
      }
      if( lbln_foundIndex )
      {
         lint_insertIndex = lint_iLoop - 1;
      }
      // [Java manual]
      // IndexOutOfBoundsException - if the specified
      // index is out of range (index < 0 || index > size())
      alst_ruleSet.add( lint_insertIndex, acl_ruleToAdd );
   }
}
