/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import rCr.agent.skillLevel_0.I_PrimaryCapability_AmbulanceTeam;
import yab.agent.object.Property;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import rCr.agent.rCrAgentRRR.I_Feature;
import rCr.agent.rCrAgentRRR.C_Agent;
import rCr.agent.skillLevel_0.I_PrimaryCapability_PoliceForce;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class U_RuleSpecification_Action
implements I_Feature
{
   /**
    * The RuleSpecification Common "getters"
    * - getPreCondition_xxx
    * - getSituation_xxx
    * - getStatementRule_xxx
    */
   private static final U_RuleSpecification_Common rsC = new U_RuleSpecification_Common();


   /**
    * IF other self humanoid is:
    * - not at a refuge &&
    * - alive && damaged && not buried
    * THEN move to a refuge
    * @see .xls file
    * ====
    * PTS:
    * IMPORTANT NOTE
    * This Rule requires the "plannerCapability" (the last method argument)
    * (plan a route to a refuge)
    * ====
    */
   public static synchronized E_Rule getRule_not_refuge_IF_self_ALIVE_DAMAGE_NOT_BURIED_THEN_moveREFUGE(
      C_Agent acl_agent, I_PrimaryAction acl_primaryAction, I_Planner acl_plannerCapability )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_HEALTH_SITUATION( CND_ALIVE_DAMAGE_NOT_BURIED ),
                     rsC.getStatementRule_self_moveREFUGE(
                        acl_primaryAction, I_PrimaryAction.kstr_move, acl_plannerCapability ) );
      // Set the PreCondition proposition: "not refuge"
      // (move to a refuge so that damage becomes zero)
      // ----------------------------------------------
      lcl_rule.setPreCondition( rsC.getSituation_self_motionlessPosition_NOT_REFUGE() );
      return lcl_rule;
   }


   /**
    * IF other (not self) humanoids are here (at self motionlessPosition) with health property:
    * - alive (hp > 0) &&
    * - damage (damage > 0) &&
    * - not buried (buriedness == 0)
    * THEN load (at the AmbulanceTeam) one of those humanoids
    * @see .xls file
    */
   public static synchronized E_Rule getRule_not_loaded_not_refuge_IF_other_here_ALIVE_DAMAGE_NOT_BURIED_THEN_load(
      C_Agent acl_agent, I_PrimaryCapability_AmbulanceTeam acl_primaryAction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_other_here_HEALTH_SITUATION( CND_ALIVE_DAMAGE_NOT_BURIED ),
                     rsC.getStatementRule_other_here_HEALTH_SITUATION(
                        acl_primaryAction, I_PrimaryCapability_AmbulanceTeam.kstr_load ) );
      // Set the PreCondition proposition: "not loaded"
      // (only one Humanoid may get loaded at an AmbulanceTeam)
      // ------------------------------------------------------
      lcl_rule.setPreCondition( rsC.getPreCondition_not_loaded_not_refuge() );
      return lcl_rule;
   }


   /**
    * IF other (not self) humanoids are here (at self motionlessPosition) with health property:
    * - alive (hp > 0) &&
    * - "independently of damage" &&
    * - buried (buriedness > 0)
    * THEN rescue (with the AmbulanceTeam) one of those humanoids
    * @see .xls file
    */
   public static synchronized E_Rule getRule_not_loaded_IF_other_here_ALIVE_x_BURIED_THEN_rescue(
      C_Agent acl_agent, I_PrimaryCapability_AmbulanceTeam acl_primaryAction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_other_here_HEALTH_SITUATION( CND_ALIVE_x_BURIED ),
                     rsC.getStatementRule_other_here_HEALTH_SITUATION(
                        acl_primaryAction, I_PrimaryCapability_AmbulanceTeam.kstr_rescue ) );
      // Set the PreCondition proposition: "not loaded"
      // (only rescue if not loaded yet)
      // ------------------------------------------------------
      lcl_rule.setPreCondition( rsC.getPreCondition_not_loaded() );
      return lcl_rule;
   }


   /**
    * IF other self humanoid is:
    * - loaded (AmbulanceTeam with humanoid loaded) &&
    * - not at a refuge
    * THEN move to a refuge
    * @see .xls file
    * ====
    * PTS:
    * IMPORTANT NOTE
    * This Rule requires the "plannerCapability" (the last method argument)
    * (plan a route to a refuge)
    * ====
    */
   public static synchronized E_Rule getRule_loaded_IF_self_motionlessPosition_NOT_REFUGE_THEN_moveREFUGE(
      C_Agent acl_agent, I_PrimaryCapability_AmbulanceTeam acl_primaryAction, I_Planner acl_plannerCapability )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_motionlessPosition_NOT_REFUGE(),
                     rsC.getStatementRule_self_moveREFUGE(
                        acl_primaryAction, I_PrimaryAction.kstr_move, acl_plannerCapability ) );
      // Set the PreCondition proposition: "loaded"
      // (usualy only when loaded, will an AmbulanceTeam move to a refuge)
      // -----------------------------------------------------------------
      lcl_rule.setPreCondition( rsC.getPreCondition_loaded() );
      return lcl_rule;
   }


   /**
    * IF other self humanoid is:
    * - loaded (AmbulanceTeam with humanoid loaded) &&
    * - at a refuge (at self motionlessPosition)
    * THEN unload the humanoid
    * @see .xls file
    */
   public static synchronized E_Rule getRule_loaded_IF_self_motionlessPosition_REFUGE_THEN_unload(
      C_Agent acl_agent, I_PrimaryCapability_AmbulanceTeam acl_primaryAction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_motionlessPosition_REFUGE(),
                     rsC.getStatementRule_self_motionlessPosition_REFUGE_unload_OR_rest(
                        acl_primaryAction, I_PrimaryCapability_AmbulanceTeam.kstr_unload ) );
      // Set the PreCondition proposition: "loaded"
      // (only a loaded Humanoid may get unloaded)
      // ------------------------------------------
      lcl_rule.setPreCondition( rsC.getPreCondition_loaded() );
      return lcl_rule;
   }


   /**
    * IF other self humanoid is:
    * - damaged (damage > 0) &&
    * - at a refuge (at self motionlessPosition)
    * THEN rest
    * [RcR manual p.4]:
    * (The damage point becomes zero immediately
    *  after the humanoid arrives at a refuge)
    * @see .xls file
    */
   public static synchronized E_Rule getRule_damage_IF_self_motionlessPosition_REFUGE_THEN_rest(
      C_Agent acl_agent, I_PrimaryAction acl_primaryAction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_motionlessPosition_REFUGE(),
                     rsC.getStatementRule_self_motionlessPosition_REFUGE_unload_OR_rest(
                        acl_primaryAction, I_PrimaryAction.kstr_rest ) );
      // Set the PreCondition proposition: "damage"
      // (damage becomes zero at a refuge)
      // ------------------------------------------
      lcl_rule.setPreCondition( rsC.getPreCondition_damage() );
      return lcl_rule;
   }


   public static synchronized E_Rule getRule_IF_self_ROAD_BLOCKADE_THEN_clear(
      C_Agent acl_agent, I_PrimaryCapability_PoliceForce acl_primaryAction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_ROAD_BLOCKADE(),
                     rsC.getStatementRule_self_ROAD_BLOCKADE_clear(
                        acl_primaryAction, I_PrimaryCapability_PoliceForce.kstr_clear ) );
      return lcl_rule;
   }


   private static void println( String astr_message )
   {
	   System.out.println( astr_message );
	}
}
