/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import rCr.agentWorkingMemory.E_FactMemory;
import java.beans.Statement;
import rCr.agent.skillLevel_0.I_PrimaryCapability_AmbulanceTeam;
import yab.agent.object.Humanoid;
import yab.agent.Condition;
import yab.agent.DisasterSpace;
import yab.agent.object.RealObject;
import java.util.List;
import rCr.agentWorkingMemory.E_FactMemory.E_Fact;
import rCr.agentWorkingMemory.I_FactMemoryConstants;
import java.util.Collections;
import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import yab.agent.object.Refuge;
import java.util.ArrayList;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.rCrAgentRRR.I_Feature;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.Road;
import rCr.agent.skillLevel_0.I_PrimaryCapability_PoliceForce;



/**
 * @author PTS
 * @since JUN.2004
 * @see .xls file
 */
public class U_RuleSpecification_Common
implements I_Feature
{
   /**
    * The RuleSpecification Util
    * - buildXxx
    * - finddXxx
    */
   private static final U_RuleSpecification_Util rsU = new U_RuleSpecification_Util();


   /**
    * not loaded
    * ------------------------------------------------------
    * A := last load(X)
    * true <<== A == {}
    * true <<== X.position() != self
    * (When the humanoid is loaded by an ambulance,
    *  "position" is set to the ambulance) [RcR manual, p.4]
    * ------------------------------------------------------
    * IMPORTANT NOTE
    * last load(X):
    * - if there is a single Rule to fire the "load" Statement then
    *   "last load(X)" may be obtained from the FactMemory of that single Rule
    * - otherwise "last load(X)" must be obtained from the Agent FactMemory
    * ====
    * PTS: (deprecated)
    * I am assuming that there is a single Rule to fire the "load" Statement
    * and this PreCondition belongs to that same Rule, so the FactMemory Rule is used
    * ("not loaded" is a PreCondition of the Rule that executes "load")
    * ====
    * PTS:
    * I am assuming that this PreCondition does not belong
    * to that same Rule that executes the "load" statement, so
    * the Agent FactMemory Rule (contains all executed Statements) must be used
    */
   static synchronized E_ConditionRule getPreCondition_not_loaded()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         // return true if:
         // The argument (Humanoid) of the last "load" action
         // is not at my position (AmbulanceTeam) anymore
         public boolean eval( E_FactMemory acl_factMemory )
         {
            // Get the last executed statement with "load" method name
            // A := last load(X)
            Statement lstt_statement = rsU.findLastStatementMethodName(
               acl_factMemory.getAgentWorkingMemory().getFactMemory(), I_PrimaryCapability_AmbulanceTeam.kstr_load );
            // Never done a "load" statement (so it is not loaded!)
            // true <<== A == {}
            if( lstt_statement == null )
            {
               return true;
            }
            // See if:
            // - the argument of the last "load" Statement
            // - is at the self (AmbulanceTeam) position
            Object[] larr_arguments = lstt_statement.getArguments();
            Humanoid lcl_loadedHumanoid = ( Humanoid )( larr_arguments[ 0 ] );
            // true <<== X.position() != self
            return ( lcl_loadedHumanoid.position() != acl_factMemory.getCurrentDisasterSpace().self );
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getPreCondition_not_loaded_not_refuge()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         // return true if:
         // The argument (Humanoid) of the last "load" action
         // is not at my position (AmbulanceTeam) anymore
         public boolean eval( E_FactMemory acl_factMemory )
         {
            // Get the last executed statement with "load" method name
            // A := last load(X)
            Statement lstt_statement = rsU.findLastStatementMethodName(
               acl_factMemory.getAgentWorkingMemory().getFactMemory(), I_PrimaryCapability_AmbulanceTeam.kstr_load );
            // Never done a "load" statement (so it is not loaded!)
            // true <<== A == {}
            if( lstt_statement == null )
            {
               return true;
            }
            // See if:
            // - the argument of the last "load" Statement
            // - is at the self (AmbulanceTeam) position
            Object[] larr_arguments = lstt_statement.getArguments();
            Humanoid lcl_loadedHumanoid = ( Humanoid )( larr_arguments[ 0 ] );
            // true <<== X.position() != self
            boolean lbln_not_loaded = ( lcl_loadedHumanoid.position() != acl_factMemory.getCurrentDisasterSpace().self );
            boolean lbln_not_refuge = ( ! ( acl_factMemory.getCurrentDisasterSpace().self.motionlessPosition() instanceof Refuge ) );
            return lbln_not_loaded && lbln_not_refuge;
         }
      };
      return lC_conditionRule;
   }


   /**
    * loaded
    * ------------------------------------------------------
    * A := last load(X)
    * false <<== A == {}
    * false <<== X.position() != self
    * (When the humanoid is loaded by an ambulance,
    *  "position" is set to the ambulance) [RcR manual, p.4]
    * ------------------------------------------------------
    * ====
    * PTS:
    * I am assuming that this PreCondition does not belong
    * to that same Rule that executes the "load" statement, so
    * the Agent FactMemory Rule (contains all executed Statements) must be used
    * ("loaded" is a PreCondition of the Rule that executes "unload")
    * ====
    * ( ! not_loaded( Agent FactMemory) )
    */
   static synchronized E_ConditionRule getPreCondition_loaded()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         // return true if:
         // The argument (Humanoid) of the last "load" action
         // is not at my position (AmbulanceTeam) anymore
         public boolean eval( E_FactMemory acl_factMemory )
         {
            // Get the last executed statement with "load" method name
            // A := last load(X)
            Statement lstt_statement = rsU.findLastStatementMethodName(
               acl_factMemory.getAgentWorkingMemory().getFactMemory(), I_PrimaryCapability_AmbulanceTeam.kstr_load );
            // Never done a "load" statement (so it is not loaded!)
            // false <<== A == {}
            if( lstt_statement == null )
            {
               return false;
            }
            // See if:
            // - the argument of the last "load" Statement
            // - is at the self (AmbulanceTeam) position
            Object[] larr_arguments = lstt_statement.getArguments();
            Humanoid lcl_loadedHumanoid = ( Humanoid )( larr_arguments[ 0 ] );

            // true <<== X.position() == self
            return ( lcl_loadedHumanoid.position() == acl_factMemory.getCurrentDisasterSpace().self );
         }
      };
      return lC_conditionRule;
   }


   /**
    * Indicates whether self is damaged (damage > 0)
    */
   static synchronized E_ConditionRule getPreCondition_damage()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getPreCondition_damage:: Humanoid Expected" );
            }

            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            lbln_eval = ( lcl_selfHumanoid.damage() > 0 );
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getSituation_self_HEALTH_SITUATION( final Condition acl_HEALTH_SITUATION )
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getCondition_self_HEALTH_SITUATION:: Humanoid Expected" );
            }
            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            List llst_self_HEALTH_SITUATION = acl_HEALTH_SITUATION.extract( Collections.singleton( lcl_selfHumanoid ) );
            lbln_eval = ( ! llst_self_HEALTH_SITUATION.isEmpty() );
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getSituation_self_motionlessPosition_NOT_REFUGE()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            lbln_eval = ( ! getSituation_self_motionlessPosition_REFUGE().eval( acl_factMemory ) );
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getSituation_self_motionlessPosition_REFUGE()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getSituation_self_position_REFUGE:: Humanoid Expected" );
            }
            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            lbln_eval = ( lcl_self.motionlessPosition() instanceof Refuge );
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   /**
    * Build the condition to get the other humanoids (not self) that:
    * - are here (at the self motionlessPosition)
    * - and satisfy the acl_HEALTH_SITUATION
    * @see .xls file
    */
   static synchronized E_ConditionRule getSituation_other_here_HEALTH_SITUATION( final Condition acl_HEALTH_SITUATION )
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getCondition_other_here_HEALTH_SITUATION:: Humanoid Expected" );
            }

            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            List llst_other_here_HEALTH_SITUATION =
               rsU.buildList_other_here_HEALTH_SITUATION ( lcl_currentDisasterSpace.humanoids,
                                                           acl_HEALTH_SITUATION,
                                                           lcl_selfHumanoid );
            lbln_eval = ( ! llst_other_here_HEALTH_SITUATION.isEmpty() );
            if( lbln_eval )
            {
               // ----------------------------------------------------------------
               // Assert this list of "other humanoids here with HEALTH SITUATION"
               // (to be used as the "candidate argument" to the StatementRule)
               // ----------------------------------------------------------------
               E_Fact lcl_fact = new E_Fact( I_FactMemoryConstants.kint_candidateStatementRuleArguments,
                                             llst_other_here_HEALTH_SITUATION );
               acl_factMemory.assertFact( lcl_fact );
            }
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getSituation_other_ALIVE_x_BURIED()
   {
      E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = true;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getSituation_other_ALIVE_x_BURIED:: Humanoid Expected" );
            }

            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            List llst_other_ALIVE_x_BURIED =
               rsU.buildList_other_ALIVE_x_BURIED(
                  lcl_currentDisasterSpace.humanoids, lcl_selfHumanoid );
            List llst_possibleToRescue = rsU.getPossibleToRescue( llst_other_ALIVE_x_BURIED );
            lbln_eval = ( ! llst_possibleToRescue.isEmpty() );
            if( lbln_eval )
            {
               // ----------------------------------------------------------------
               // Assert this list of "other humanoids here with HEALTH SITUATION"
               // (to be used as the "candidate argument" to the StatementRule)
               // ----------------------------------------------------------------
               E_Fact lcl_fact = new E_Fact( I_FactMemoryConstants.kint_candidateStatementRuleArguments,
                                             llst_possibleToRescue );
               acl_factMemory.assertFact( lcl_fact );
            }
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_ConditionRule getSituation_self_ROAD_BLOCKADE()
   {
     E_ConditionRule lC_conditionRule =
      new E_ConditionRule()
      {
         public boolean eval( E_FactMemory acl_factMemory )
         {
            boolean lbln_eval = false;
            // GIS Agent representation
            DisasterSpace lcl_currentDisasterSpace = acl_factMemory.getCurrentDisasterSpace();
            RealObject lcl_self = lcl_currentDisasterSpace.self;
            if( ! ( lcl_self instanceof Humanoid ) )
            {
               throw new IllegalArgumentException( "PTS: getSituation_self_ROAD_BLOCKADE:: Humanoid Expected" );
            }
            Humanoid lcl_selfHumanoid = ( Humanoid )lcl_self;
            if( lcl_self.motionlessPosition() instanceof Road )
            {
               Road lcl_road = ( Road )lcl_self.motionlessPosition();
               lbln_eval = ( lcl_road.passableLines() == 0 );
               ArrayList larr_argument = new ArrayList();
               larr_argument.add( lcl_road );
               rsU.assertTrueFact_candidateStatementRuleArguments( lbln_eval, larr_argument, acl_factMemory  );
               // println( "PTS: ROAD_BLOCKADE == " + lbln_eval + " at Road ID = " + lcl_road.id );
            }
            return lbln_eval;
         }
      };
      return lC_conditionRule;
   }


   static synchronized E_StatementRule getStatementRule_self_HEALTH_SITUATION(
      final I_PrimaryInteraction acl_targetObject, final String astr_targetMethodName )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            // -----------------------------------------------------------------------
            // Dynamically Build the Statement to be executed
            // (object with a target, methodName and arguments as per the parameters)
            // acl_targetObject.astr_targetMethodName( larr_targetMethodArguments )
            // -----------------------------------------------------------------------
            String lstr_messageContent = rsU.buildMessageContent_SELF_AT_HDB_POS_ID( acl_factMemory );
            Object[] larr_targetMethodArguments = { lstr_messageContent };
            Statement lstt_statement = new Statement( acl_targetObject, astr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   static synchronized E_StatementRule getStatementRule_other_ALIVE_x_BURIED_inform_AT(
      final I_PrimaryInteraction acl_targetObject, final String astr_targetMethodName )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            String lstr_messageContent = rsU.buildMessageContent_OTHER_AT_HDB_POS_ID( acl_factMemory );
            Object[] larr_targetMethodArguments = { lstr_messageContent };
            Statement lstt_statement = new Statement( acl_targetObject, astr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   static synchronized E_StatementRule getStatementRule_self_moveREFUGE(
      final I_PrimaryInteraction acl_targetObject, final String astr_targetMethodName, final I_Planner acl_plannerCapability )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            // -----------------------------------------------------------------------
            // Dynamically Build the Statement to be executed
            // (object with a target, methodName and arguments as per the parameters)
            // acl_targetObject.astr_targetMethodName( larr_targetMethodArguments )
            // -----------------------------------------------------------------------
            // =============!!
            // PTS: VER ISTO
            // =============!!
            // ----------------------------
            // Build a Plan to get a refuge
            // ----------------------------
            ArrayList larr_refuges = acl_factMemory.getCurrentDisasterSpace().refuges;
            ArrayList larr_route = acl_plannerCapability.getPassableRouteTo( larr_refuges );
            Object[] larr_targetMethodArguments = { larr_route };
            String lstr_targetMethodName = astr_targetMethodName;
            // ------------------------------------------------
            // If there is no route ==>> rest
            // (a different method from the initially expected)
            // ------------------------------------------------
            if( larr_route.isEmpty() )
            {
               println( "PTS: - alteracao de plano - devia ser move(REFUGE) mas nao ha caminho ==>> rest()" );
               lstr_targetMethodName = I_PrimaryAction.kstr_rest;
               larr_targetMethodArguments = new Object[ 0 ];
            }

            Statement lstt_statement = new Statement( acl_targetObject, lstr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   static synchronized E_StatementRule getStatementRule_self_motionlessPosition_REFUGE_unload_OR_rest(
      final I_PrimaryInteraction acl_targetObject, final String astr_targetMethodName )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            // -----------------------------------------------------------------------
            // Dynamically Build the Statement to be executed
            // (object with a target, methodName and arguments as per the parameters)
            // acl_targetObject.astr_targetMethodName( larr_targetMethodArguments )
            // -----------------------------------------------------------------------
            // unload and rest are zero arity method (no arguments required)
            // -------------------------------------------------------------
            Object[] larr_targetMethodArguments = { };
            Statement lstt_statement = new Statement( acl_targetObject, astr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   static synchronized E_StatementRule getStatementRule_other_here_HEALTH_SITUATION(
      final I_PrimaryCapability_AmbulanceTeam acl_targetObject, final String astr_targetMethodName )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            // Get the candidate argument list (built at "conditionRule.evel()")
            List llst_candidateStatementRuleArgument =
               ( List )( acl_factMemory.getLastFact( I_FactMemoryConstants.kint_candidateStatementRuleArguments ).fact );

            // 1st rescue the humanoid with higher "damage"
            // --------------------------------------------
            // =============!!
            // PTS: VER ISTO
            // =============!!
            // -----------------------------------------------------------------------
            // Dynamically Build the Statement to be executed
            // (object with a target, methodName and arguments as per the parameters)
            // acl_targetObject.astr_targetMethodName( larr_targetMethodArguments )
            // -----------------------------------------------------------------------
            Humanoid lcl_humanoid = ( Humanoid )( PRP_DAMAGE.max( llst_candidateStatementRuleArgument ) );
            Object[] larr_targetMethodArguments = { lcl_humanoid };
            Statement lstt_statement = new Statement( acl_targetObject, astr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   static synchronized E_StatementRule getStatementRule_self_ROAD_BLOCKADE_clear(
      final I_PrimaryCapability_PoliceForce acl_targetObject, final String astr_targetMethodName )
   {
      E_StatementRule lC_statementRule =
      new E_StatementRule()
      {
         public Statement getStatement( E_FactMemory acl_factMemory )
         {
            // Get the candidate argument list (built at "conditionRule.evel()")
            List llst_candidateStatementRuleArgument =
               ( List )( acl_factMemory.getLastFact( I_FactMemoryConstants.kint_candidateStatementRuleArguments ).fact );
            // -----------------------------------------------------------------------
            // Dynamically Build the Statement to be executed
            // (object with a target, methodName and arguments as per the parameters)
            // acl_targetObject.astr_targetMethodName( larr_targetMethodArguments )
            // -----------------------------------------------------------------------
            Road lcl_road = ( Road )llst_candidateStatementRuleArgument.get( 0 );
            Object[] larr_targetMethodArguments = { lcl_road };
            Statement lstt_statement = new Statement( acl_targetObject, astr_targetMethodName, larr_targetMethodArguments );
            return lstt_statement;
         }
      };
      return lC_statementRule;
   }


   private static void println( String astr_mensagem )
   {
	   System.out.println( astr_mensagem );
	}
}
