/* PTS */


package rCr.agent.skillLevel_0;


import rCr.communicativeAct.C_Actuator;
import rCr.util.X_RcR_Accao;
import rCr.initiator.I_Config;
import yab.agent.object.Road;
import yab.io.NozzleElement;
import yab.agent.object.Humanoid;
import java.util.ArrayList;
import rCr.util.U_RcR;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class B_PrimaryCapability
implements  I_PrimaryInteraction,
            I_PrimaryCapability_Civilian,
            I_PrimaryCapability_AmbulanceTeam,
            I_PrimaryCapability_FireBrigade,
            I_PrimaryCapability_PoliceForce,
            I_PrimaryCapability_AgentModel
{
   /**
    * @directed 
    */
   private C_Actuator adaptee;

   /**
    * Agent ID (platform specefic)
    * (to be used at action submit)
    */
   private int iint_agentID;

   /**
    * Maximum number of sent inter-agent messages
    * (between 2 consecutive simulation cycles)
    */
   private int iint_actosDiscursoEnviados = 0;

   /**
    * Create the "Primary Capability"
    * and Set the Actuator (Adaptee instance)
    */
   public B_PrimaryCapability( C_Actuator acl_actuator )
   {
      this.adaptee = acl_actuator;
   }


   public void setAgentID( int aint_agentID )
   {
      this.iint_agentID = aint_agentID;
   }


   public void beginSimulationCycle()
   {
      iint_actosDiscursoEnviados = 0;
   }


   private int limiteEnvioActosDiscurso()
   {
      return I_Config.UTTERANCE_LIMIT ;
   }


   /**
    * "dizer" uma mensagem de "viva voz"
    */
   public void say( String acl_mensagem )
   {
      if( iint_actosDiscursoEnviados < limiteEnvioActosDiscurso() )
      {
         adaptee.akSay( iint_agentID, acl_mensagem );
         iint_actosDiscursoEnviados++;
      }
   }


   /**
    * "dizer" uma mensagem atraves de um meio de telecomunicacao
    */
   public void tell( String acl_mensagem )
   {
      if( iint_actosDiscursoEnviados < limiteEnvioActosDiscurso() )
      {
         adaptee.akTell( iint_agentID, acl_mensagem );
         iint_actosDiscursoEnviados++;
      }
   }


   /**
    * indicar inactividade (nao fazer nada)
    */
   public void rest()
   throws X_RcR_Accao
   {
      adaptee.akRest( iint_agentID );
   }


   public void clear( Road acl_road )
   throws X_RcR_Accao
   {
       adaptee.akClear( iint_agentID, acl_road.id );
   }


   public void extinguish( NozzleElement[] aarr_nozzleElement )
   throws X_RcR_Accao
   {
      adaptee.akExtinguish( iint_agentID, aarr_nozzleElement );
   }


   /**
    * Loads injured (and immovable) civilians
    */
   public void load( Humanoid acl_humanoide )
   throws X_RcR_Accao
   {
	   adaptee.akLoad( iint_agentID, acl_humanoide.id );
   }


   /**
    * Descarrega Civis
    */
   public void unload() throws X_RcR_Accao
   {
	   adaptee.akUnLoad( iint_agentID );
   }


   /**
    * Desenterra civis
    */
   public void rescue( Humanoid acl_humanoide )
   throws X_RcR_Accao
   {
	   adaptee.akRescue( iint_agentID, acl_humanoide.id );
   }


   public void move( ArrayList aarr_percurso )
   throws X_RcR_Accao
   {
       move( U_RcR.getIDs( aarr_percurso ) );
   }


   public void move( int[] aarr_percurso )
   throws X_RcR_Accao
   {
       adaptee.akMove( iint_agentID, aarr_percurso );
   }
}
