/* PTS */


package rCr.agent.skillLevel_1;


import yab.agent.object.MotionlessObject;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem;
import java.util.ArrayList;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem_widerShorterRoad;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem_shorterRoad;
import java.util.Iterator;
import rCr.agent.skillLevel_1.problemSolver.E_Node;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem.E_State;
import rCr.util.U_RcR;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class B_GIS_Router_FromTo
{
   public ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination )
   {
      return getPassableRouteFromTo( acl_origin, Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getPassableRouteFromTo( acl_origin, Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      B_GIS_RoutingProblem icl_routingProblem =
         new B_GIS_RoutingProblem(
               acl_origin,
               acl_destinationSet,
               acl_tabooLocations );

      ArrayList larr_route = icl_routingProblem.solve();
      return U_RcR.fromSolutionNodeToMotionlessObject( larr_route );
   }


   public ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination )
   {
      return getWiderShorterRouteFromTo( acl_origin, Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getWiderShorterRouteFromTo( acl_origin, Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      B_GIS_RoutingProblem icl_routingProblem =
         new B_GIS_RoutingProblem_widerShorterRoad(
               acl_origin,
               acl_destinationSet,
               acl_tabooLocations );

      ArrayList larr_route = icl_routingProblem.solve();
      return U_RcR.fromSolutionNodeToMotionlessObject( larr_route );
   }


   public ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination )
   {
      return getShorterRouteFromTo( acl_origin, Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getShorterRouteFromTo( acl_origin, Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      B_GIS_RoutingProblem icl_routingProblem =
         new B_GIS_RoutingProblem_shorterRoad(
               acl_origin,
               acl_destinationSet,
               acl_tabooLocations );

      ArrayList larr_route = icl_routingProblem.solve();
      return U_RcR.fromSolutionNodeToMotionlessObject( larr_route );
   }
}
