/* PTS */


package rCr.agent.skillLevel_1;


import yab.agent.object.RealObject;
import yab.agent.object.MotionlessObject;
import java.util.Collections;
import java.util.Collection;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem;
import java.util.ArrayList;
import java.util.Iterator;
import rCr.agent.skillLevel_1.problemSolver.E_Node;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem.E_State;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem_widerShorterRoad;
import java.util.HashSet;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem_shorterRoad;
import yab.agent.object.Road;
import yab.agent.object.PointObject;
import rCr.agent.skillLevel_1.problemSolver.I_ProblemSolver;
import yab.agent.object.MovingObject;
import rCr.util.U_RcR;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class B_GIS_Router_To
extends B_GIS_Router_FromTo
implements I_Planner
{
   /**
    * "Agent Self" (platform specefic)
    * (represented at DisasterSpace from YabAI)
    */
   private RealObject icl_agentSelf;


   public void setAgentSelf( RealObject acl_agentSelf )
   {
      this.icl_agentSelf = acl_agentSelf;
   }


   /**
    * PTS: return of int[] with IDs are deprecated at RRR
    * at RRR all planner return ArrayList with MotionlessObject
    * These two methods are implementes just for compatibility (with Baseline) purposes:
    * public int[] getPassableRouteIDsTo( MotionlessObject acl_destination );
    * public int[] getPassableRouteIDsTo( Collection acl_destinationSet );
    */
   public int[] getPassableRouteIDsTo( MotionlessObject acl_destination )
   { return U_RcR.getIDs( getPassableRouteTo( acl_destination ) ); };
   public int[] getPassableRouteIDsTo( Collection acl_destinationSet )
   { return U_RcR.getIDs( getPassableRouteTo( acl_destinationSet ) ); };


   public ArrayList getPassableRouteTo( MotionlessObject acl_destination )
   {
      return getPassableRouteTo( Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getPassableRouteTo( Collection acl_destinationSet )
   {
      return getPassableRouteTo( acl_destinationSet, new HashSet() );
   }


   public ArrayList getPassableRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getPassableRouteTo( Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getPassableRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      return getPassableRouteFromTo( icl_agentSelf.motionlessPosition(), acl_destinationSet, acl_tabooLocations );
   }


   public ArrayList getPassableRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations )
   {
      if( acl_mustGoLocations.isEmpty() )
      {
         return getPassableRouteTo( acl_destinationSet, acl_tabooLocations );
      }

      // The 1st SubProblem:
      // - from current location
      // - to a "mustGo" location
      // ------------------------
      B_GIS_RoutingProblem lcl_firstSubProblem =
         new B_GIS_RoutingProblem(
               icl_agentSelf.motionlessPosition(),
               acl_mustGoLocations,
               acl_tabooLocations );

      // The 2nd SubProblem
      // - from the "mustGo" location (solution of previous subproblem)
      // - to a "destination" location
      // Note:
      // The initial state of 2nd subproblem is still unknown
      // (it will be the solution state obtained from 1st subproblem)
      // ------------------------------------------------------------
      B_GIS_RoutingProblem lcl_secondSubProblem =
         new B_GIS_RoutingProblem(
               acl_destinationSet,
               acl_tabooLocations );

      // Return the composition of 1st and 2nd SubProblems
      // -------------------------------------------------
      return getSolutionFromTwoSubProblemComposition( lcl_firstSubProblem, lcl_secondSubProblem );
   }


   public ArrayList getWiderShorterRouteTo( MotionlessObject acl_destination )
   {
      return getWiderShorterRouteTo( Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getWiderShorterRouteTo( Collection acl_destinationSet )
   {
      return getWiderShorterRouteTo( acl_destinationSet, new HashSet() );
   }


   public ArrayList getWiderShorterRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getWiderShorterRouteTo( Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getWiderShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      return getWiderShorterRouteFromTo( icl_agentSelf.motionlessPosition(), acl_destinationSet, acl_tabooLocations );
   }


   public ArrayList getWiderShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations )
   {
      if( acl_mustGoLocations.isEmpty() )
      {
         return getWiderShorterRouteTo( acl_destinationSet, acl_tabooLocations );
      }

      // The 1st SubProblem:
      // - from current location
      // - to a "mustGo" location
      // ------------------------
      B_GIS_RoutingProblem lcl_firstSubProblem =
         new B_GIS_RoutingProblem_widerShorterRoad(
               icl_agentSelf.motionlessPosition(),
               acl_mustGoLocations,
               acl_tabooLocations );

      // The 2nd SubProblem
      // - from the "mustGo" location (solution of previous subproblem)
      // - to a "destination" location
      // Note:
      // The initial state of 2nd subproblem is still unknown
      // (it will be the solution state obtained from 1st subproblem)
      // ------------------------------------------------------------
      B_GIS_RoutingProblem lcl_secondSubProblem =
         new B_GIS_RoutingProblem_widerShorterRoad(
               acl_destinationSet,
               acl_tabooLocations );

      // Return the composition of 1st and 2nd SubProblems
      // -------------------------------------------------
      return getSolutionFromTwoSubProblemComposition( lcl_firstSubProblem, lcl_secondSubProblem );
   }


   public ArrayList getShorterRouteTo( MotionlessObject acl_destination )
   {
      return getShorterRouteTo( Collections.singleton( acl_destination ), new HashSet() );
   }


   public ArrayList getShorterRouteTo( Collection acl_destinationSet )
   {
      return getShorterRouteTo( acl_destinationSet, new HashSet() );
   }


   public ArrayList getShorterRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations )
   {
      return getShorterRouteTo( Collections.singleton( acl_destination ), acl_tabooLocations );
   }


   public ArrayList getShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations )
   {
      return getShorterRouteFromTo( icl_agentSelf.motionlessPosition(), acl_destinationSet, acl_tabooLocations );
   }


   public ArrayList getShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations )
   {
      if( acl_mustGoLocations.isEmpty() )
      {
         return getShorterRouteTo( acl_destinationSet, acl_tabooLocations );
      }

      // The 1st SubProblem:
      // - from current location
      // - to a "mustGo" location
      // ------------------------
      B_GIS_RoutingProblem lcl_firstSubProblem =
         new B_GIS_RoutingProblem_shorterRoad(
               icl_agentSelf.motionlessPosition(),
               acl_mustGoLocations,
               acl_tabooLocations );

      // The 2nd SubProblem
      // - from the "mustGo" location (solution of previous subproblem)
      // - to a "destination" location
      // Note:
      // The initial state of 2nd subproblem is still unknown
      // (it will be the solution state obtained from 1st subproblem)
      // ------------------------------------------------------------
      B_GIS_RoutingProblem lcl_secondSubProblem =
         new B_GIS_RoutingProblem_shorterRoad(
               acl_destinationSet,
               acl_tabooLocations );

      // Return the composition of 1st and 2nd SubProblems
      // -------------------------------------------------
      return getSolutionFromTwoSubProblemComposition( lcl_firstSubProblem, lcl_secondSubProblem );
   }


   public ArrayList getShorterRouteTo_roadThroughHead( Road acl_destinationRoad )
   {
      MotionlessObject lcl_agentMotionlessPosition = icl_agentSelf.motionlessPosition();

      boolean lbln_atRoad =  ( lcl_agentMotionlessPosition instanceof Road );
      // Agent is already at the destination Road
      if( lbln_atRoad )
      {
         Road lcl_road = ( Road )lcl_agentMotionlessPosition;
         if( acl_destinationRoad == lcl_road )
         {
            return getShorterRouteTo_thisRoadThroughHead();
         }
      }
      // Agent is not at the destination Road
      // ------------------------------------
      // (is either at Road's Head, Tail or any other MotionlessObject)
      // Let us define a SubProblem:
      // - to "tail" and "road" is "taboo" (can not pass through)
      Collection lcl_tabooLocation = new HashSet();
      lcl_tabooLocation.add( acl_destinationRoad );
      ArrayList larr_solution = getShorterRouteTo( acl_destinationRoad.head(), lcl_tabooLocation );

      // Now build the complete solution:
      // - join the missing point
      //  (Road at the end of the "partialSolution")
      // larr_partialSolution + lcl_road
      larr_solution.add( acl_destinationRoad );
      return larr_solution;

      /*PTS: deprecated - old usage of int[]
      int[] larr_solution = new int [ larr_partialSolution.length + 1 ];
      larr_solution[ larr_solution.length - 1 ] = acl_destinationRoad.id;
      // Copy the partial solution points
      for( int lint_iLoop = 0; lint_iLoop < larr_partialSolution.length; lint_iLoop++ )
      {
         larr_solution[ lint_iLoop ] = larr_partialSolution[ lint_iLoop ];
      }
      return larr_solution;
      */
   }


   public ArrayList getShorterRouteTo_roadThroughTail( Road acl_destinationRoad )
   {
      MotionlessObject lcl_agentMotionlessPosition = icl_agentSelf.motionlessPosition();

      boolean lbln_atRoad =  ( lcl_agentMotionlessPosition instanceof Road );
      // Agent is already at the destination Road
      // ----------------------------------------
      if( lbln_atRoad )
      {
         Road lcl_road = ( Road )lcl_agentMotionlessPosition;
         if( acl_destinationRoad == lcl_road )
         {
            return getShorterRouteTo_thisRoadThroughTail();
         }
      }
      // Agent is not at the destination Road
      // ------------------------------------
      // (is either at Road's Head, Tail or any other MotionlessObject)
      // Let us define a SubProblem:
      // - to "tail" and "road" is "taboo" (can not pass through)
      Collection lcl_tabooLocation = new HashSet();
      lcl_tabooLocation.add( acl_destinationRoad );
      ArrayList larr_solution = getShorterRouteTo( acl_destinationRoad.tail(), lcl_tabooLocation );

      // Now build the complete solution:
      // - join the missing point
      // (Road at the end of the "partialSolution")
      // larr_partialSolution + lcl_road
      larr_solution.add( acl_destinationRoad );
      return larr_solution;

      /*PTS: deprecated - old usage of int[]
      ArrayList larr_solution = new int [ larr_partialSolution.length + 1 ];
      larr_solution[ larr_solution.length - 1 ] = acl_destinationRoad.id;
      // Copy the partial solution points
      for( int lint_iLoop = 0; lint_iLoop < larr_partialSolution.length; lint_iLoop++ )
      {
         larr_solution[ lint_iLoop ] = larr_partialSolution[ lint_iLoop ];
      }
      return larr_solution;
      */
   }


   public ArrayList getShorterRouteTo_thisRoadThroughTheOtherEndPoint()
   {
      ArrayList larr_solution = new ArrayList();
      MotionlessObject lcl_agentMotionlessPosition = icl_agentSelf.motionlessPosition();
      boolean lbln_atRoad =  ( lcl_agentMotionlessPosition instanceof Road );
      if( ! lbln_atRoad )
      {
         return larr_solution;
      }

      // See if agent is closer to head or tail
      Road lcl_road = ( Road )lcl_agentMotionlessPosition;
      boolean lbln_closerToHead = ( ( ( MovingObject  )icl_agentSelf ).positionExtra() < lcl_road.length() / 2 );
      if( lbln_closerToHead )
      {
         larr_solution = getShorterRouteTo_thisRoadThroughEndPoint( false );
      }
      else
      {
         larr_solution = getShorterRouteTo_thisRoadThroughEndPoint( true );
      }
      return larr_solution;
   }


   public ArrayList getShorterRouteTo_thisRoadThroughHead()
   {
      return getShorterRouteTo_thisRoadThroughEndPoint( true );
   }


   public ArrayList getShorterRouteTo_thisRoadThroughTail()
   {
      return getShorterRouteTo_thisRoadThroughEndPoint( false );
   }


   private ArrayList getShorterRouteTo_thisRoadThroughEndPoint( boolean lbln_isHeadEndPoint )
   {
      ArrayList larr_emptySolution = new ArrayList();
      MotionlessObject lcl_agentMotionlessPosition = icl_agentSelf.motionlessPosition();
      boolean lbln_atRoad =  ( lcl_agentMotionlessPosition instanceof Road );
      if( ! lbln_atRoad )
      {
         return larr_emptySolution;
      }
      Road lcl_road = ( Road )lcl_agentMotionlessPosition;

      // Define origin and destination of subproblem
      MotionlessObject lcl_origin = lbln_isHeadEndPoint ? lcl_road.tail() : lcl_road.head();
      MotionlessObject lcl_destination = lbln_isHeadEndPoint ? lcl_road.head() : lcl_road.tail();

      // Get the partial solution (subproblem's solution)
      // (from "origin" to "destination" with taboo=Road)
      // ------------------------------------------------
      ArrayList larr_solution = getShorterRouteFromTo( lcl_origin, lcl_destination, Collections.singleton( lcl_road ) );
      if( larr_solution.isEmpty() )
      {
         return larr_emptySolution;
      }

      // Now build the complete solution:
      // - join the missing points
      // (Road at both ends of the "partialSolution")
      // lcl_road + larr_partialSolution + lcl_road
      larr_solution.add( 0, lcl_road );
      larr_solution.add( lcl_road );
      return larr_solution;

      /*PTS: deprecated - old usage of int[]
      larr_solution = new int [ larr_partialSolution.length + 2 ];
      larr_solution[ 0 ] = lcl_road.id;
      larr_solution[ larr_solution.length - 1 ] = lcl_road.id;
      // Copy the partial solution points
      for( int lint_iLoop = 0; lint_iLoop < larr_partialSolution.length; lint_iLoop++ )
      {
         larr_solution[ lint_iLoop + 1 ] = larr_partialSolution[ lint_iLoop ];
      }
      return larr_solution;
      */
   }


   private ArrayList getSolutionFromTwoSubProblemComposition( B_GIS_RoutingProblem acl_firstSubProblem, B_GIS_RoutingProblem acl_secondSubProblem )
   {
      ArrayList larr_emptySolution = new ArrayList();

      // Solve 1st SubProblem (return if solution is void)
      // -------------------------------------------------
      ArrayList larr_routeFromFirstSubProblem = acl_firstSubProblem.solve();
      if( larr_routeFromFirstSubProblem.isEmpty() )
      {
         return larr_emptySolution;
      }

      // Get the last state (E_State) from the 1st subproblem
      // (it will be the initial state of the 2nd subproblem)
      int lint_lastIndex = larr_routeFromFirstSubProblem.size() - 1;
      E_Node lcl_lastNode = ( E_Node )( larr_routeFromFirstSubProblem.get( lint_lastIndex ) );
      E_State lcl_lastState = ( ( E_State )( lcl_lastNode.getState() ) );

      // Specify the second subproblem (RoutingProblem) initial state
      acl_secondSubProblem.specifyRoutingProblemInitialState( lcl_lastState.gisLocation );

      // Solve 2nd SubProblem
      // --------------------
      ArrayList larr_routeFromSecondSubProblem = acl_secondSubProblem.solve();
      if( larr_routeFromSecondSubProblem.isEmpty() )
      {
         return larr_emptySolution;
      }

      // Append:
      // - 1st SubProblem Solution, with
      // - 2nd SubProblem Solution
      // (except first (index == 0) element of 2nd SubProblem
      //  because it is equal to the last element of 1st SubProblem)
      larr_routeFromSecondSubProblem.remove( 0 );
      larr_routeFromFirstSubProblem.addAll( larr_routeFromSecondSubProblem );
      return U_RcR.fromSolutionNodeToMotionlessObject( larr_routeFromFirstSubProblem );

      /*PTS: deprecated - old usage of int[]
      larr_routeFromSecondSubProblem.remove( 0 );
      if( larr_routeFromFirstSubProblem.addAll( larr_routeFromSecondSubProblem ) )
      {
         larr_solution = getIDs( larr_routeFromFirstSubProblem );
      }
      return larr_solution;
      */
   }
}
