/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import java.util.ArrayList;
import java.util.LinkedList;


/**
 *  @author PTS
 *  @since MAY.2004
 */
abstract class C_BestFirst
implements I_SearchStrategy
{
   /**
    * ================================================
    * Diferentes algoritmos de pesquisa guiada
    * Notar que as unicas "diferencas" sao a nivel da
    * - chave pela qual e' feita o adicionar
    * ================================================
    */
   abstract protected boolean costOrderRelation( E_Node acl_nodeToInsert, E_Node acl_nodeFromQueue );


   /**
    * C_BreadthFirst: insert new nodes at the end of the queue
    */
   public void addNodesToQueue( ArrayList aarr_nodeList, LinkedList acl_nodeQueue )
   {
      for( int lint_iLoop = 0; lint_iLoop < aarr_nodeList.size(); lint_iLoop++ )
      {
         insertLaterInAscendentOrder( aarr_nodeList.get( lint_iLoop ), acl_nodeQueue );
      }
   }

   private void insertLaterInAscendentOrder( Object acl_nodeToInsert, LinkedList acl_nodeQueue )
   {
      final int lint_queueSize = acl_nodeQueue.size();
      int lint_insertIndex = lint_queueSize;
      int lint_iLoop = 0;
      boolean lbln_foundIndex = false;
      while( ( ! lbln_foundIndex ) && ( lint_iLoop < lint_queueSize ) )
      {
         E_Node lcl_nodeFromQueue = ( E_Node )acl_nodeQueue.get( lint_iLoop );
         //
         //( acl_nodeToInsert.f_cost < lcl_nodeFromQueue.f_cost );
         lbln_foundIndex = costOrderRelation( ( E_Node )acl_nodeToInsert, lcl_nodeFromQueue );
         lint_iLoop++;
      }
      if( lbln_foundIndex )
      {
         lint_insertIndex = lint_iLoop - 1;
      }
      // [Java manual]
      // IndexOutOfBoundsException - if the specified
      // index is out of range (index < 0 || index > size())
      acl_nodeQueue.add( lint_insertIndex, acl_nodeToInsert);

      /*
      CODIGO DO Yab
      for( int lint_iLoop = 0;  lint_iLoop < lint_queueSize;  lint_iLoop ++ )
      {
         E_Node lcl_nodeFromQueue = ( E_Node )acl_nodeQueue.get( lint_iLoop );
         if( lcl_nodeFromQueue.end == acl_nodeToInsert.end )
         {
            if( lcl_nodeFromQueue.cost > acl_nodeToInsert.cost )
            {
               acl_nodeQueue.remove( lint_iLoop);
               acl_nodeQueue.add( lint_insertIndex, acl_nodeToInsert);
            }
            return;
         }

         if( lcl_nodeFromQueue.cost > acl_nodeToInsert.cost  &&
             lint_iLoop < lint_insertIndex)
         {
            lint_insertIndex = lint_iLoop;
         }
      }
      acl_nodeQueue.add( lint_insertIndex, acl_nodeToInsert);
      */
   }


   /**
    * Exemplo utilizacao da "conditionPreExpand":
    * nao expandir um elemento para
    * alem de determinada profundidade
    * ===
    * true: allows the state (acl_currentNode.getState()) expand
    * false: does not allow the state expand
    */
   public boolean preStateExpandCondition( E_Node acl_currentNode )
   {
      return true;
   }


   /**
    * Exemplo utilizacao da "postStateExpandCondition":
    * nao considerar um elemento cujo
    * estado ja tenha sido considerado
    * (tres situacoes: como pai; no mesmo ramo; em toda a arvore)
    * ===
    * true: allows the state (acl_currentNode.getState())
    *       to enter the "fringe queue" of states
    * false: does not allow the state to enter the "fringe queue" of states
    */
   public boolean postStateExpandCondition( E_Node acl_parentNode, I_State aitf_aNextState )
   {
      return true;
   }
}
