/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import java.util.ArrayList;
import yab.agent.object.MotionlessObject;
import java.util.Iterator;
import yab.agent.object.Building;
import yab.agent.object.Road;
import yab.agent.object.PointObject;
import java.util.HashSet;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem;
import rCr.util.E_Condition;


/**
 *  @author PTS
 *  @since MAY.2004
 */
class E_GIS_move
implements I_Operator
{
   /**
    * Each State is a "B_GIS_Router.E_State" instance
    */
   public ArrayList getNextStateSet( I_State acl_currentState )
   {
      B_GIS_RoutingProblem.E_State lcl_state = ( B_GIS_RoutingProblem.E_State )acl_currentState;
      MotionlessObject lcl_currentGisLocation = lcl_state.gisLocation;
      E_Condition stateInvariant = lcl_state.stateInvariant;

      ArrayList larr_reachableStates = new ArrayList( 4 );
      for( Iterator litf_iterator = lcl_currentGisLocation.neighborhood().iterator() ;
           litf_iterator.hasNext() ; )
      {
         MotionlessObject lcl_reachableGisLocation = ( MotionlessObject )litf_iterator.next();
         // ---------------------------------------------
         // Eval (evaluate) the State Aditional Condition
         // (do not consider states that fail the eval)
         // ---------------------------------------------
         if( stateInvariant.eval( lcl_reachableGisLocation ) )
         {
            larr_reachableStates.add( new B_GIS_RoutingProblem.E_State ( lcl_reachableGisLocation, stateInvariant ) );
         }
      }
      return larr_reachableStates;
   }


   public float getCost( I_State acl_currentState, I_State acl_nextState )
   {
      // The Yab cost function
      // ---------------------
      B_GIS_RoutingProblem.E_State lcl_stateOrigin = ( B_GIS_RoutingProblem.E_State )acl_currentState;
      B_GIS_RoutingProblem.E_State lcl_stateDestination = ( B_GIS_RoutingProblem.E_State )acl_nextState;
      MotionlessObject lcl_origin = lcl_stateOrigin.gisLocation;
      MotionlessObject lcl_destination = lcl_stateDestination.gisLocation;

      final int WEIGHT = Integer.MAX_VALUE;
      float lflt_cost = 1;
      if( ! ( lcl_destination instanceof Road ) )
      {
         print( "COST_a = " + lflt_cost );
         return lflt_cost;
      }

      Road lcl_road = ( Road )lcl_destination;
      PointObject lcl_point = ( PointObject )lcl_origin;
      if( lcl_road.passableLinesFrom( lcl_point ) == 0 )
      {
         print( "COST_b = " + lflt_cost );
         return lflt_cost * WEIGHT * WEIGHT;
      }
      print( "COST_c = " + lflt_cost );
      return lcl_road.hasBeenSeen() ?
             lflt_cost
             :
             lflt_cost * WEIGHT;
   }


   public String getAction()
   {
      return "move";
   }


   private void print( String s )
   {
      // System.out.print( " " + s + "|");
   }
}
