/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import yab.agent.object.MotionlessObject;
import yab.agent.object.PointObject;
import yab.agent.object.Road;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class E_GIS_move_widerShorterRoad
extends E_GIS_move
{
   /**
    * Cost indicates the relation between:
    * - distance (between origin and destinaton), and
    * - the number of lines available to travel from origin to destination
    * cost = lenghtOfRoad / linesToExit
    * (linesToExit = linesToHead OR linesToTail)
    */
   public float getCost( I_State acl_currentState, I_State acl_nextState )
   {
      B_GIS_RoutingProblem.E_State lcl_stateOrigin = ( B_GIS_RoutingProblem.E_State )acl_currentState;
      B_GIS_RoutingProblem.E_State lcl_stateDestination = ( B_GIS_RoutingProblem.E_State )acl_nextState;
      MotionlessObject lcl_origin = lcl_stateOrigin.gisLocation;
      MotionlessObject lcl_destination = lcl_stateDestination.gisLocation;

      // Only moving "into a Road" has a cost
      // ------------------------------------
      float lflt_cost = 0;

      boolean lbln_moveIntoRoad = ( lcl_destination instanceof Road );
      if( lbln_moveIntoRoad )
      {
         Road lcl_road = ( Road )lcl_destination;
         int lint_roadLength = lcl_road.length();
         // Moving to head/tail?
         boolean lbln_toHead = ( ( ( PointObject )lcl_origin )
                                 ==
                                 lcl_road.tail() );
         // boolean lbln_toHead = ( ! lbln_toTail );
         int lint_linesToExitRoad = ( lbln_toHead ) ?
                                    lcl_road.linesToHead()
                                    :
                                    lcl_road.linesToTail();

         // Length "shrinks" with the number of lines to exit the Road
         lflt_cost = lint_roadLength / lint_linesToExitRoad;
      }
      return lflt_cost;
   }
}
