/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import java.util.ArrayList;
import java.util.Hashtable;
import java.util.LinkedList;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class E_Node
{
   private final E_Node parent;
   private final I_State state;
   private final int depth;
   // Cost to reach this State
   public final float g_cost;
   // Estimated (Heuristic) Cost to reach a Goal State
   public final float h_cost;
   // Composition of g_cost and h_cost
   // A*: f_cost = g_cost + h_cost
   public final float f_cost;
   // Operator Action to reach this State
   public final String action;


   public E_Node( I_State acl_state )
   {
      this.parent =  null;
      this.state = acl_state;
      this.depth = 0; // 1 ?

      this.g_cost = 0;
      this.h_cost = 0;
      this.f_cost = 0;

      this.action = "";
	}


	public E_Node( I_State acl_state, E_Node acl_parent, float g_cost, float h_cost, float f_cost, String astr_action )
   {
      this.parent = acl_parent;
		this.state = acl_state;
		this.depth = parent.depth + 1;

      this.g_cost = g_cost;
      this.h_cost = h_cost;
      this.f_cost = f_cost;

      this.action = astr_action;
	}


	public boolean isRootNode()
   {
      return ( parent == null );
	}


	public I_State getState()
   {
      return state;
	}


	public int getDepth()
   {
		return depth;
	}


   public ArrayList getPathFromRoot()
   {
      ArrayList larr_pathFromRoot = new ArrayList();
	   E_Node lcl_currentNode = this;
	   while( ! ( lcl_currentNode.isRootNode() ) )
      {
         larr_pathFromRoot.add( 0, lcl_currentNode );
	      lcl_currentNode = lcl_currentNode.parent;
	   }
      // Add Root Node
	   larr_pathFromRoot.add( 0, lcl_currentNode );
	   return larr_pathFromRoot;
	}
}