/* PTS */


package rCr.agentWorkingMemory;


import java.util.HashMap;
import java.util.ArrayList;
import yab.agent.DisasterSpace;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class E_FactMemory
implements I_FactMemoryConstants
{
   // The Agent WorkingMemory
   private E_WorkingMemory agentWorkingMemory;
   // HashMap with each asserted Fact f:
   // key = f.getType()
   // value = a Collection (ArrayList) of Facts of "key Type"
   private HashMap ihsh_factMemory = new HashMap();


   public E_FactMemory( E_WorkingMemory acl_agentWorkingMemory )
   {
      // Keep the reference to the agent Working Memory
      this.agentWorkingMemory = acl_agentWorkingMemory;
      // Initialize this Fact Memory
      for( int lint_iLoop = 0; lint_iLoop < iarr_knownFactTypes.length; lint_iLoop++ )
      {
         initializeFactMemoryType( iarr_knownFactTypes[ lint_iLoop ] );
      }
   }


   public void assertFact( E_Fact acl_fact )
   {
      ArrayList larl_value = initializeFactMemoryType( acl_fact.factType );
      // Set "timeOfAssert" and "assertFact"
      acl_fact.setTimeOfAssert( agentWorkingMemory.getCurrentDisasterSpace().time() );
      larl_value.add( acl_fact );
   }


   public ArrayList getFactSet( int aint_factType )
   {
      ArrayList larr_factSet = new ArrayList();
      Integer lcl_key = new Integer( aint_factType );
      Object lcl_value = ihsh_factMemory.get( lcl_key );
      if( lcl_value != null )
      {
         larr_factSet = ( ArrayList )lcl_value;
      }
      return larr_factSet;
   }


   public E_Fact getLastFact( int aint_factType )
   {
      E_Fact lcl_lastFact = null;
      Integer lcl_key = new Integer( aint_factType );
      Object lcl_value = ihsh_factMemory.get( lcl_key );

      if( lcl_value != null )
      {
         ArrayList larl_value = ( ArrayList )lcl_value;
         int lint_lastIndex = larl_value.size() - 1;
         lcl_lastFact = ( E_Fact )( larl_value.get( lint_lastIndex ) );
      }
      return lcl_lastFact;
   }


   public DisasterSpace getCurrentDisasterSpace()
   {
      return agentWorkingMemory.getCurrentDisasterSpace();
   }


   public E_WorkingMemory getAgentWorkingMemory()
   {
      return agentWorkingMemory;
   }


   private ArrayList initializeFactMemoryType( int aint_factType )
   {
      Integer lcl_key = new Integer( aint_factType );
      Object lcl_value = ihsh_factMemory.get( lcl_key );

      if( lcl_value == null )
      {
      lcl_value = new ArrayList();
      ihsh_factMemory.put( lcl_key, lcl_value );
      }

      return ( ArrayList )lcl_value;
   }


   /**
    * @author PTS
    * @since JUN.2004
    * The Fact definition class
    */
   public static class E_Fact
   {
      public final int factType;
      public final Object fact;
      public int timeOfAssert;


      public E_Fact( int aint_factType, Object acl_fact )
      {
         this.factType = aint_factType;
         this.fact = acl_fact;
      }


      public void setTimeOfAssert( int aint_timeOfAssert )
      {
         this.timeOfAssert = aint_timeOfAssert;
      }
   }
}
