/* PTS */


package rCr.agentWorkingMemory;


import yab.agent.object.Road;
import rCr.util.U_LeitorEscritorLinha;
import rCr.util.U_Geral;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class E_SectionBorder
{
   // Section Border "head" and "tail"
   // --------------------------------
   private E_Point head = null;
   private E_Point tail = null;
   // Main Road that intersects the SectionBorder
   // -------------------------------------------
   private Road mainRoad = null;
   private E_Point mainRoadIntersection = null;


   public E_SectionBorder( E_Point acl_head, E_Point acl_tail )
   {
      this.head = acl_head;
      this.tail = acl_tail;
   }


   public E_Point getHead()
   {
      return head;
   }


   public E_Point getTail()
   {
      return tail;
   }


   public E_Point getMid()
   {
      return new E_Point( ( head.getX() + tail.getX() ) / 2,
                          ( head.getY() + tail.getY() ) / 2 );
   }


   public Road getMainRoad()
   {
      return mainRoad;
   }


   public E_Point getMainRoadIntersection()
   {
      return mainRoadIntersection;
   }


   public void setMainRoad( Road acl_mainRoad )
   {
      this.mainRoad = acl_mainRoad;
      mainRoadIntersection =
         U_Geometry.getLineIntersection(
               head,
               tail,
               new E_Point( mainRoad.head().x(), mainRoad.head().y() ),
               new E_Point( mainRoad.tail().x(), mainRoad.tail().y() ) );
   }


   public void printlnAll()
   {
      U_LeitorEscritorLinha.escrever( "SectionBorder:" );
      U_LeitorEscritorLinha.escrever( "head(x,y) = " + head.myToString() );
      U_LeitorEscritorLinha.escrever( "tail(x,y) = " + tail.myToString() );
      if( mainRoad == null )
      {
         U_LeitorEscritorLinha.escrever( "mainRoad = [ null ID ]" );
         return;
      }
      U_LeitorEscritorLinha.escrever( "mainRoad = " + "[ " + mainRoad.id + " ]" );
      if( mainRoadIntersection == null )
      {
         U_LeitorEscritorLinha.escrever( "mainRoadIntersection = [ null E_Point ] :: ???SITUACAO DE ERRO???" );
         return;
      }
      U_LeitorEscritorLinha.escrever( "mainRoadIntersection(x,y) = " + mainRoadIntersection.myToString() );
   }
}