/* PTS & AR */


/*
 * Created on 4/Jun/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package rCr.agentWorkingMemory;


import java.util.ArrayList;
import yab.agent.object.Road;
import rCr.agent.skillLevel_1.B_GIS_Router_FromTo;
import rCr.util.U_LeitorEscritorLinha;
import rCr.util.U_RcR;
import yab.agent.object.MotionlessObject;
import yab.agent.DisasterSpace;
import java.util.Iterator;
import rCr.util.U_Geral;
import yab.agent.object.Node;


/**
 * @author aremedios
 * @review PTS
 * @since JUN.2004
 */
public class E_SectionWithRoads
extends E_Section
implements I_Border
{
   // Section Borders
   private E_SectionBorder borderNORTH = null;
   private E_SectionBorder borderSOUTH = null;
   private E_SectionBorder borderEAST = null;
   private E_SectionBorder borderWEST = null;

   // Main Route between Main Border Roads
   // NW = NORTH to WEST (and reverse)
   // NE = NORTH to EAST (and reverse)
   // NS = NORTH to SOUTH (and reverse) (vertical traversal)
   // SW = SOUTH to WEST (and reverse)
   // SE = SOUTH to EAST (and reverse)
   // EW = EAST to WEST (and reverse) (horizontal traversal)
	private ArrayList NW = new ArrayList();
	private ArrayList NE = new ArrayList();
   private ArrayList NS = new ArrayList();
	private ArrayList SW = new ArrayList();
	private ArrayList SE = new ArrayList();
	private ArrayList EW = new ArrayList();

   // HOME Section position (MotionlessObject) (Node V Road)
   // ------------------------------------------------------
   private MotionlessObject HOME = null;

   // All Roads, Nodes and Buildings of this Section
   private ArrayList iarr_allSection_NODES = new ArrayList();
   private ArrayList iarr_allSection_ROADS = new ArrayList();
   private ArrayList iarr_allSection_BUILDINGS = new ArrayList();


   public E_SectionWithRoads( E_Section acl_aSection, DisasterSpace acl_disasterSpace )
   {
      this.setBottomRight( acl_aSection.getBottomRight() );
      this.setTopLeft( acl_aSection.getTopLeft() );

      // Construct each Border: NORTH, SOUTH, EAST, WEST
      // -----------------------------------------------
      constructEachBorder();

      // Construct each Border Main Road: wider Road closer to BORDER central point
      // --------------------------------------------------------------------------
      constructEachBorderMainRoad( acl_disasterSpace );

      // Construct each Main Route (route between borders): NW, NE, NS, SW, SE, EW
      // -------------------------------------------------------------------------
      constructEachMainRoute();

      // Construct HOME: Node OR Road closer to the SECTION central point
      // ----------------------------------------------------------------
      constructHOME( acl_disasterSpace );

      // Construct all Section Roads, Nodes, Buildings
      // ---------------------------------------------
      constructAllSection_NODES_ROADS_BUILDINGS( acl_disasterSpace );
   }


   public ArrayList getNW()
   {
      return U_RcR.buildShallowCopy( NW.iterator() );
   }


   public ArrayList getNE()
   {
      return U_RcR.buildShallowCopy( NE.iterator() );
   }


   public ArrayList getNS()
   {
      return U_RcR.buildShallowCopy( NS.iterator() );
   }


   public ArrayList getSW()
   {
      return U_RcR.buildShallowCopy( SW.iterator() );
   }


   public ArrayList getSE()
   {
      return U_RcR.buildShallowCopy( SE.iterator() );
   }


   public ArrayList getEW()
   {
      return U_RcR.buildShallowCopy( EW.iterator() );
   }


   public ArrayList getAllMainRoutes()
   {
      ArrayList larr_allMainRoads = getNW();
      larr_allMainRoads.addAll( getNE() );
      larr_allMainRoads.addAll( getNS() );
      larr_allMainRoads.addAll( getSW() );
      larr_allMainRoads.addAll( getSE() );
      larr_allMainRoads.addAll( getEW() );
      return larr_allMainRoads;
   }


   public int getMidBorderNORTH()
   {
      return borderNORTH.getMid().getX();
   }


   public int getMidBorderSOUTH()
   {
      return borderSOUTH.getMid().getX();
   }


   public int getMidBorderEAST()
   {
      return borderEAST.getMid().getY();
   }


   public int getMidBorderWEST()
   {
      return borderWEST.getMid().getY();
   }


   public E_SectionBorder getBorderNORTH()
   {
      return borderNORTH;
   }


   public E_SectionBorder getBorderSOUTH()
   {
      return borderSOUTH;
   }


   public E_SectionBorder getBorderEAST()
   {
      return borderEAST;
   }


   public E_SectionBorder getBorderWEST()
   {
      return borderWEST;
   }


   public MotionlessObject getHOME()
   {
      return HOME;
   }


   public ArrayList getAllSection_NODES()
   {
      // Shallow copy (pointer level only) to allow delete form the returned ArrayList
      // (PTS: ???confirm if necessary???)
      return U_RcR.buildShallowCopy( iarr_allSection_NODES.iterator() );
   }


   public ArrayList getAllSection_ROADS()
   {
      // Shallow copy (pointer level only) to allow delete form the returned ArrayList
      // (PTS: ???confirm if necessary???)
      return U_RcR.buildShallowCopy( iarr_allSection_ROADS.iterator() );
   }


   public ArrayList getAllSection_BUILDINGS()
   {
      // Shallow copy (pointer level only) to allow delete form the returned ArrayList
      // (PTS: ???confirm if necessary???)
      return U_RcR.buildShallowCopy( iarr_allSection_BUILDINGS.iterator() );
   }


   private void constructEachBorder()
   {
      // Create each SectionBorder( head, tail )
      borderNORTH = new E_SectionBorder(
         new E_Point( getTopLeft().getX(), getTopLeft().getY() ),
         new E_Point( getBottomRight().getX(), getTopLeft().getY() ) );

      borderSOUTH = new E_SectionBorder(
         new E_Point( getTopLeft().getX(), getBottomRight().getY() ),
         new E_Point( getBottomRight().getX(), getBottomRight().getY() ) );

      borderEAST = new E_SectionBorder(
         new E_Point( borderSOUTH.getTail() ),
         new E_Point( borderNORTH.getTail() ) );


      borderWEST = new E_SectionBorder(
         new E_Point( borderSOUTH.getHead() ),
         new E_Point( borderNORTH.getHead() ) );
   }


   private void constructEachBorderMainRoad( DisasterSpace acl_disasterSpace )
   {
      // Iterate the diasasterSpace roads to
      // build border and main roads of SectionRoads
      for(Iterator litf_iteratorRoads = acl_disasterSpace.roads.iterator();
          litf_iteratorRoads.hasNext(); )
      {
         Road lcl_currentRoad = ( Road )litf_iteratorRoads.next();
         boolean lbln_currentRoadIntersectAtLeastOneSectionBorder =
            roadIntersectAtLeastOneSectionBorder( lcl_currentRoad );
	         
         if( lbln_currentRoadIntersectAtLeastOneSectionBorder )
         {
            E_Point lcl_intersectionPoint = null;
            E_Point currentRoad_p0 = new E_Point( lcl_currentRoad.head().x(), lcl_currentRoad.head().y() );
            E_Point currentRoad_p1 = new E_Point( lcl_currentRoad.tail().x(), lcl_currentRoad.tail().y() );

            // NORTH Border: (Update SectionBorder if Road intersects the Border)
            // -----
            lcl_intersectionPoint = U_Geometry.getSegmentLineIntersection(
               getBorderNORTH().getHead(), getBorderNORTH().getTail(),
               currentRoad_p0, currentRoad_p1,
               pint_toleranceForBorderIntersection);
            // Road intersects Border
            if( lcl_intersectionPoint != null )
            {
               updateSectionBorderMainRoad( getBorderNORTH(), lcl_intersectionPoint, lcl_currentRoad );
            }

            // SOUTH Border: (Update SectionBorder if Road intersects the Border)
            // -----
            lcl_intersectionPoint = U_Geometry.getSegmentLineIntersection(
               getBorderSOUTH().getHead(), getBorderSOUTH().getTail(),
               currentRoad_p0, currentRoad_p1,
               pint_toleranceForBorderIntersection);
            // Road intersects Border
            if( lcl_intersectionPoint != null )
            {
               updateSectionBorderMainRoad( getBorderSOUTH(), lcl_intersectionPoint, lcl_currentRoad );
            }

            // EAST Border: (Update SectionBorder if Road intersects the Border)
            // ----
            lcl_intersectionPoint = U_Geometry.getSegmentLineIntersection(
               getBorderEAST().getHead(), getBorderEAST().getTail(),
               currentRoad_p0, currentRoad_p1,
               pint_toleranceForBorderIntersection);
            // Road intersects Border
            if( lcl_intersectionPoint != null )
            {
               updateSectionBorderMainRoad( getBorderEAST(), lcl_intersectionPoint, lcl_currentRoad );
            }

            // WEST Border: (Update SectionBorder if Road intersects the Border)
            // ----
            lcl_intersectionPoint = U_Geometry.getSegmentLineIntersection(
               getBorderWEST().getHead(), getBorderWEST().getTail(),
               currentRoad_p0, currentRoad_p1,
               pint_toleranceForBorderIntersection);
            // Road intersects Border
            if( lcl_intersectionPoint != null )
            {
               updateSectionBorderMainRoad( getBorderWEST(), lcl_intersectionPoint, lcl_currentRoad );
            }
         }
      }
   }


   /**
    * Set HOME to the Node OR Road closer to the Section central point
    */
   private void constructHOME( DisasterSpace acl_disasterSpace )
   {
      // Build Central Point
      int x0 = ( getTopLeft_X() + getBottomRight_X() ) / 2;
      int y0 = ( getTopLeft_Y() + getBottomRight_Y() ) / 2;

      // Get the Node Iterator
      Iterator litf_nodeIterator = acl_disasterSpace.nodes.iterator();
      if( ! litf_nodeIterator.hasNext() )
      {
         HOME = null;
         return;
      }
      // Current best (closer to (x0,y0) section mid point)
      MotionlessObject lcl_currentBestObject = ( MotionlessObject )litf_nodeIterator.next();
      // Get the best Node OR Road
      // -------------------------
      lcl_currentBestObject = getCloserToSectionMid( x0, y0, litf_nodeIterator, lcl_currentBestObject );
      lcl_currentBestObject = getCloserToSectionMid( x0, y0, acl_disasterSpace.roads.iterator(), lcl_currentBestObject );

      // Set HOME (Node OR Road closer to Section Central point)
      HOME = ( isPointInsideSection( lcl_currentBestObject.x(), lcl_currentBestObject.y() ) ) ?
             lcl_currentBestObject : null;
   }


   private void constructAllSection_NODES_ROADS_BUILDINGS( DisasterSpace acl_disasterSpace )
   {
      iarr_allSection_NODES = constructAllSection_GIS_ELEMENTS( acl_disasterSpace.nodes.iterator() );
      iarr_allSection_ROADS = constructAllSection_GIS_ELEMENTS( acl_disasterSpace.roads.iterator() );
      iarr_allSection_BUILDINGS = constructAllSection_GIS_ELEMENTS( acl_disasterSpace.buildings.iterator() );
   }


   private ArrayList constructAllSection_GIS_ELEMENTS( Iterator litf_iterator )
   {
      ArrayList larr_resultSet = new ArrayList();
      while( litf_iterator.hasNext() )
      {
         MotionlessObject lcl_object = ( MotionlessObject )litf_iterator.next();
         if( isPointInsideSection( lcl_object.x(), lcl_object.y() ) )
         {
            larr_resultSet.add( lcl_object );
         }
      }
      return larr_resultSet;
   }


   private MotionlessObject getCloserToSectionMid(
      final int x0, final int y0, final Iterator aitf_iterator, final MotionlessObject acl_currentBestObject )
   {
      // Set current best
      MotionlessObject lcl_currentBestObject = acl_currentBestObject;
      int x1 = lcl_currentBestObject.x();
      int y1 = lcl_currentBestObject.y();
      double ldbl_currentBestDistance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );

      // Iterate go get better then current best
      while( aitf_iterator.hasNext() )
      {
         MotionlessObject lcl_object = ( MotionlessObject )aitf_iterator.next();
         x1 = lcl_object.x();
         y1 = lcl_object.y();
         // Only evaluate points inside this Section
         // ----------------------------------------
         if( isPointInsideSection( x1, y1 ) )
         {
            double ldbl_distance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );
            if( ldbl_distance < ldbl_currentBestDistance )
            {
               ldbl_currentBestDistance = ldbl_distance;
               lcl_currentBestObject = lcl_object;
            }
         }
      }
      return lcl_currentBestObject;
   }


   private void constructEachMainRoute()
   {
      updateRoute_NW();
      updateRoute_NE();
      updateRoute_NS();
      updateRoute_SW();
      updateRoute_SE();
      updateRoute_EW();
   }


   /**
    * If this candidate Road is better then the current one
    * (closer to border mid or wider if near the current one)
    * then updates the SectionBorder current Main Road
    */
   private void updateSectionBorderMainRoad(
      E_SectionBorder acl_sectionBorder, E_Point acl_candidateRoadIntersectionPoint, Road acl_candidateRoad )
   {
      Road lcl_currentMainRoad = acl_sectionBorder.getMainRoad();
      // If there is no main road,
      // then accept candidate road
      if( lcl_currentMainRoad == null )
      {
         acl_sectionBorder.setMainRoad( acl_candidateRoad );
         return;
      }
      boolean lbln_updateMainRoad = false;
      // Set the intersection point closer to mid border
      E_Point lcl_borderMidPoint = acl_sectionBorder.getMid();
      E_Point lcl_currentIntersectionPoint = acl_sectionBorder.getMainRoadIntersection();
      E_Point[] larr_pointsToEval = { lcl_currentIntersectionPoint, acl_candidateRoadIntersectionPoint };
      E_Point lcl_closerToMid = lcl_borderMidPoint.closerTo( larr_pointsToEval );
      lbln_updateMainRoad = ( lcl_closerToMid == acl_candidateRoadIntersectionPoint );
      if( lbln_updateMainRoad )
      {
         acl_sectionBorder.setMainRoad( acl_candidateRoad );
         return;
      }

      // Set the wider road (at a threshold distance form the current main one)
      if( U_Geometry.getPointToPointDistance( lcl_currentIntersectionPoint, acl_candidateRoadIntersectionPoint )
          < pint_thresholdToAcceptCandidateMainRoad)
      {
         int lint_candidateTotalLines = acl_candidateRoad.linesToHead() + acl_candidateRoad.linesToTail();
         int lint_currentTotalLines = lcl_currentMainRoad.linesToHead() + lcl_currentMainRoad.linesToTail();
         lbln_updateMainRoad = ( lint_currentTotalLines < lint_candidateTotalLines );
         if( lbln_updateMainRoad )
         {
            acl_sectionBorder.setMainRoad( acl_candidateRoad );
            return;
         }
      }
   }


   private void updateRoute_NW()
   {
      Road lcl_mainRoad_NORTH = borderNORTH.getMainRoad();
      Road lcl_mainRoad_WEST = borderWEST.getMainRoad();
      if( ( lcl_mainRoad_NORTH == null ) || ( lcl_mainRoad_WEST == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      NW = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_NORTH, lcl_mainRoad_WEST );
	}


   private void updateRoute_NE()
   {
      Road lcl_mainRoad_NORTH = borderNORTH.getMainRoad();
      Road lcl_mainRoad_EAST = borderEAST.getMainRoad();
      if( ( lcl_mainRoad_NORTH == null ) || ( lcl_mainRoad_EAST == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      NE = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_NORTH, lcl_mainRoad_EAST );
	}


   private void updateRoute_NS()
   {
      Road lcl_mainRoad_NORTH = borderNORTH.getMainRoad();
      Road lcl_mainRoad_SOUTH = borderSOUTH.getMainRoad();
      if( ( lcl_mainRoad_NORTH == null ) || ( lcl_mainRoad_SOUTH == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      NS = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_NORTH, lcl_mainRoad_SOUTH );
	}


   private void updateRoute_SW()
   {
      Road lcl_mainRoad_SOUTH = borderSOUTH.getMainRoad();
      Road lcl_mainRoad_WEST = borderWEST.getMainRoad();
      if( ( lcl_mainRoad_SOUTH == null ) || ( lcl_mainRoad_WEST == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      SW = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_SOUTH, lcl_mainRoad_WEST );
	}


   private void updateRoute_SE()
   {
      Road lcl_mainRoad_SOUTH = borderSOUTH.getMainRoad();
      Road lcl_mainRoad_EAST = borderEAST.getMainRoad();
      if( ( lcl_mainRoad_SOUTH == null ) || ( lcl_mainRoad_EAST == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      SE = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_SOUTH, lcl_mainRoad_EAST );
	}


	private void updateRoute_EW()
   {
      Road lcl_mainRoad_EAST = borderEAST.getMainRoad();
      Road lcl_mainRoad_WEST = borderWEST.getMainRoad();
      if( ( lcl_mainRoad_EAST == null ) || ( lcl_mainRoad_WEST == null ) )
      {
         return;
      }
      // Build and register plan
      B_GIS_Router_FromTo lcl_planner = new B_GIS_Router_FromTo();
      EW = lcl_planner.getWiderShorterRouteFromTo( lcl_mainRoad_EAST, lcl_mainRoad_WEST );
	}


   /**
    * @param acl_road
 	 * @param acl_section
 	 * @return true if road intersect any section border
    * @author aremedios
    * @review PTS
    * @since JUN.2004
 	 */
   private boolean roadIntersectAtLeastOneSectionBorder( Road acl_road )
   {
      boolean lbln_headInside = isPointInsideSection( acl_road.head().x(), acl_road.head().y() );
      boolean lbln_tailInside = isPointInsideSection( acl_road.tail().x(), acl_road.tail().y() );
      boolean lbln_roadInside = isPointInsideSection( acl_road.x(), acl_road.y() );

      // Road intersect at least one section border if:
      // - either head or tail (Exclusive OR - XOR) is inside the section
      //  OR
      // - road is inside the border and head and tail are both outside the border
      boolean lbln_xorHeadTail = lbln_headInside ^ lbln_tailInside;
      boolean lbln_roadAndNotHeadAndNotTail = lbln_roadInside && ( ! lbln_headInside ) && ( ! lbln_tailInside );
      return lbln_xorHeadTail || lbln_roadAndNotHeadAndNotTail;

      /*
      // deprecated: exactly one section border intersection
      // Exclusive OR (road intersect EXACTLY ONE section border) if:
      // - either head or tail (XOR) is inside the section
      boolean lbln_xorHeadTail = lbln_headInside ^ lbln_tailInside;
      return lbln_xorHeadTail;
      */
   }


   public void printlnAll()
   {
      super.printlnAll();
      U_LeitorEscritorLinha.escrever( "-----" );
      U_LeitorEscritorLinha.escrever( "SectionWithRoads:" );
      U_LeitorEscritorLinha.escreverMesmaLinha( "HOME: " );
      String lstr_infoHOME = "[ null ]";
      if( HOME != null )
      {
         lstr_infoHOME = U_Geral.paraString( HOME.id );
         E_Point lcl_HOME = new E_Point( HOME.x(), HOME.y() );
         lstr_infoHOME = " ID== " + lstr_infoHOME + " (x,y)== " + lcl_HOME.myToString();
      }
      U_LeitorEscritorLinha.escrever( lstr_infoHOME );
      U_LeitorEscritorLinha.escrever( "borderNORTH:" );
      U_LeitorEscritorLinha.escrever( "borderNORTH:" );
      borderNORTH.printlnAll();
      U_LeitorEscritorLinha.escrever( "borderSOUTH:" );
      borderSOUTH.printlnAll();
      U_LeitorEscritorLinha.escrever( "borderEAST:" );
      borderEAST.printlnAll();
      U_LeitorEscritorLinha.escrever( "borderWEST:" );
      borderWEST.printlnAll();
      U_LeitorEscritorLinha.escreverMesmaLinha( "NW: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( NW ) );
      U_LeitorEscritorLinha.escreverMesmaLinha( "NE: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( NE ) );
      U_LeitorEscritorLinha.escreverMesmaLinha( "NS: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( NS ) );
      U_LeitorEscritorLinha.escreverMesmaLinha( "SW: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( SW ) );
      U_LeitorEscritorLinha.escreverMesmaLinha( "SE: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( SE ) );
      U_LeitorEscritorLinha.escreverMesmaLinha( "EW: " );
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( EW ) );
   }
}
