/* PTS */


package rCr.agentWorkingMemory;


import yab.agent.DisasterSpace;
import rCr.util.U_LeitorEscritorLinha;
import rCr.initiator.I_Config;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class E_WorkingMemory_RRR
extends E_WorkingMemory
{
   /**
    * @directed 
    */
   // =================================================
   // Each Institution MapGrid Coordination Perspective
   private E_SpaceGrid icl_spaceGrid_POLICE = null;
   private E_SpaceGrid icl_spaceGrid_AMBULANCE = null;
   private E_SpaceGrid icl_spaceGrid_FIRE = null;
   // For testing purposes only:
   private E_SpaceGrid icl_spaceGrid_CIVILIAN = null;
   // =================================================

   public void postInitialize( Object acl_object )
   {
      // PTS: esta classe e' para depois tirar
      // os parametros serao calculados automaticamente
      E_SpaceGridParameters lcl_spaceGridParameters = ( E_SpaceGridParameters )acl_object;
      buildSpaceGrid( lcl_spaceGridParameters.institutionID,
         lcl_spaceGridParameters.numberOfColumns, lcl_spaceGridParameters.numberOfLines, currentDisasterSpace );
   }


   public void buildSpaceGrid(
      int aint_institutionID, int aint_numberOfColumns, int aint_numberOfLines, DisasterSpace acl_disasterSpace )
   {
         E_SpaceGrid lcl_spaceGrid = new E_SpaceGrid(
            aint_numberOfColumns, aint_numberOfLines, acl_disasterSpace );
         switch( aint_institutionID )
         {
            case I_Config.AGENT_TYPE_POLICE_FORCE:
            case I_Config.AGENT_TYPE_POLICE_OFFICE:
               this.icl_spaceGrid_POLICE = lcl_spaceGrid;
            break;

            case I_Config.AGENT_TYPE_AMBULANCE_TEAM:
            case I_Config.AGENT_TYPE_AMBULANCE_CENTER:
               this.icl_spaceGrid_AMBULANCE = lcl_spaceGrid;
            break;

            case I_Config.AGENT_TYPE_FIRE_BRIGADE:
            case I_Config.AGENT_TYPE_FIRE_STATION:
               this.icl_spaceGrid_FIRE = lcl_spaceGrid;
            break;

            case I_Config.AGENT_TYPE_CIVILIAN:
               this.icl_spaceGrid_CIVILIAN = lcl_spaceGrid;
            break;

            default:
               throw new Error( "PTS:: buildSpaceGrid - valid institutionID expected" );
         }
   }


   public void buildAnyEmptySpaceGrid( DisasterSpace acl_disasterSpace )
   {
      if( icl_spaceGrid_POLICE == null )
      {
         buildSpaceGrid( I_Config.AGENT_TYPE_POLICE_FORCE,
            pint_numberColumnsSpaceGrid_default, pint_numberLinesSpaceGrid_default, acl_disasterSpace );
      }

      if( icl_spaceGrid_AMBULANCE == null )
      {
         buildSpaceGrid( I_Config.AGENT_TYPE_AMBULANCE_TEAM,
            pint_numberColumnsSpaceGrid_default, pint_numberLinesSpaceGrid_default, acl_disasterSpace );
      }

      if( icl_spaceGrid_FIRE == null )
      {
         buildSpaceGrid( I_Config.AGENT_TYPE_FIRE_BRIGADE,
            pint_numberColumnsSpaceGrid_default, pint_numberLinesSpaceGrid_default, acl_disasterSpace );
      }
   }


   /**
    * Civilian is used form testing purposes only
    */
   public void buildEmptySpaceGrid_CIVILIAN( DisasterSpace acl_disasterSpace )
   {
      if( icl_spaceGrid_CIVILIAN == null )
      {
         buildSpaceGrid( I_Config.AGENT_TYPE_CIVILIAN,
            pint_numberColumnsSpaceGrid_default, pint_numberLinesSpaceGrid_default, acl_disasterSpace );
      }
   }


   public E_SpaceGrid getSpaceGrid_POLICE()
   {
      return icl_spaceGrid_POLICE;
   }


   public E_SpaceGrid getSpaceGrid_AMBULANCE()
   {
      return icl_spaceGrid_AMBULANCE;
   }


   public E_SpaceGrid getSpaceGrid_FIRE()
   {
      return icl_spaceGrid_FIRE;
   }


   public E_SpaceGrid getSpaceGrid_CIVILIAN()
   {
      return icl_spaceGrid_CIVILIAN;
   }


   public void printlnAllSpaceGrid()
   {
      icl_spaceGrid_POLICE.printlnAll();
      icl_spaceGrid_AMBULANCE.printlnAll();
      icl_spaceGrid_FIRE.printlnAll();
      icl_spaceGrid_CIVILIAN.printlnAll();
   }


   public void printlnSpaceGrid_POLICE()
   {
      if( icl_spaceGrid_POLICE == null )
      {
         return;
      }
      U_LeitorEscritorLinha.escrever( "" );
      U_LeitorEscritorLinha.escrever( " -- POLICE:: WorkingMemory_RRR [currentSpaceGrid] -- " );
      icl_spaceGrid_POLICE.printlnAll();
   }


   public void printlnSpaceGrid_AMBULANCE()
   {
      if( icl_spaceGrid_AMBULANCE == null )
      {
         return;
      }
      U_LeitorEscritorLinha.escrever( "" );
      U_LeitorEscritorLinha.escrever( " -- AMBULANCE:: WorkingMemory_RRR [currentSpaceGrid] -- " );
      icl_spaceGrid_AMBULANCE.printlnAll();
   }


   public void printlnSpaceGrid_FIRE()
   {
      if( icl_spaceGrid_FIRE == null )
      {
         return;
      }
      U_LeitorEscritorLinha.escrever( "" );
      U_LeitorEscritorLinha.escrever( " -- FIRE:: WorkingMemory_RRR [currentSpaceGrid] -- " );
      icl_spaceGrid_FIRE.printlnAll();
   }


   public void printlnSpaceGrid_CIVILIAN()
   {
      if( icl_spaceGrid_CIVILIAN == null )
      {
         return;
      }
      U_LeitorEscritorLinha.escrever( "" );
      U_LeitorEscritorLinha.escrever( " -- FIRE:: WorkingMemory_RRR [currentSpaceGrid] -- " );
      icl_spaceGrid_CIVILIAN.printlnAll();
   }


   /**
    * PTS
    * Classe para depois retirar
    */
   public static class E_SpaceGridParameters
   {
      public int institutionID, numberOfColumns, numberOfLines;
      public E_SpaceGridParameters( int aint_institutionID, int aint_numberOfColumns, int aint_numberOfLines )
      {
         this.institutionID = aint_institutionID;
         this.numberOfColumns = aint_numberOfColumns;
         this.numberOfLines = aint_numberOfLines;
      }
   }
}
