/* PTS */

package rCr.initiator;


/**
 *  Insert the type's description here.
 *  Criado: (3/25/00 8:21:30 PM)
 *  @author: Paulo Trigo Silva*/
public interface I_Config 
{

   /**
   * "host"
   */
   public static final String kstr_nomeNoRemoto = "localhost";
   
   /**
   * "port"
   */
   public static final int kint_portoProcessoRemoto = 6000; //7000;

   /**
    * Valor de omissao para o numero de "Threads" de cada classe iniciadora
    * (por omissao: o numero maximo aceite pelo Kernel)
    */
   public static final int kint_MAXIMO_AGENTES_ACEITE = Integer.MAX_VALUE;
   public static final int kint_numeroThreads = kint_MAXIMO_AGENTES_ACEITE;

   /**
    * Motivo pelo qual o Kernel recusa o pedido de conexao
    * (nao existe, no GIS, objecto que represente o agente que pede conexao)
    */
   public static final String kstr_motivoConexaoRecusada = "no more agent";

   /**
    * Classes iniciadoras (de cada um dos agentes do sistema)
    */
   // os Agentes "tipo humano"
   public static final String kstr_civilian =      "rCr._BUILDER.C_BUILDER_Civilian"; //"rCr.agent.C_Civilian";
   public static final String kstr_fireBrigade =   "rCr._BUILDER.C_BUILDER_FireBrigade";
   public static final String kstr_ambulanceTeam = "rCr._BUILDER.C_BUILDER_AmbulanceTeam";
   public static final String kstr_policeForce =   "rCr._BUILDER.C_BUILDER_PoliceForce";

   // os Centros de Comando
   public static final String kstr_fireStation = "rCr._BUILDER.C_BUILDER_FireStation";
   public static final String kstr_ambulanceCenter = "rCr._BUILDER.C_BUILDER_AmbulanceCenter";
   public static final String kstr_policeOffice = "rCr._BUILDER.C_BUILDER_PoliceOffice";

   // por Omissao: classe desconhecida
   public static final String kstr_classeAgenteOmissao = "Classe_Agente_Nao_Definida";


   /**
   * Nome da classe que implementa as primitivas basicas de comunicacao
   * com o mundo exterior a este processo
   */
   public static final String kstr_classeComunicadoraOmissao = "rCr.communicator.B_RCRSS";
   // "rCr.communicator.B_LongUDP";
   // "rCr.communicator.B_DatagramCommunicator";

   /**
   * Codigo do Tipo de Agente
   * (de acordo com manual RoboCupRescue - pg. 35)
   */
   public static final int
      AGENT_TYPE_CIVILIAN         =  1,
      AGENT_TYPE_FIRE_BRIGADE     =  2,
      AGENT_TYPE_FIRE_STATION     =  4,
      AGENT_TYPE_AMBULANCE_TEAM   =  8,
      AGENT_TYPE_AMBULANCE_CENTER = 16,
      AGENT_TYPE_POLICE_FORCE     = 32,
      AGENT_TYPE_POLICE_OFFICE    = 64;

   // Limite do numero de actos de discurso:
   // - recebidos em cada ciclo (entre dois "KaSense")
   // - enviados em cada ciclo (entre dois "KaSense")
   public static final int HEARING_LIMIT_OF_HUMANOID = 4; // [message/cycle]
   public static final int UTTERANCE_LIMIT = 4; // [message/cycle]
}
