/* PTS */


package rCr.util;


import java.util.*;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public abstract class E_Condition
{
   public abstract boolean eval( Object acl_object );


   public ArrayList extract( Collection acl_collection )
   {
      ArrayList larr_resultSet = new ArrayList();
      for( Iterator litf_iterator = acl_collection.iterator();
           litf_iterator.hasNext();  )
      {
         Object lcl_object = litf_iterator.next();
         if( eval( lcl_object) )
         {
            larr_resultSet.add( lcl_object );
         }
      }
      return larr_resultSet;
   }


   public E_Condition and( final E_Condition rhs )
   {
      final E_Condition lhs = this;
      E_Condition lcl_result =
      new E_Condition()
      {
         public boolean eval( Object acl_object )
         {
            return lhs.eval( acl_object ) && rhs.eval( acl_object );
         }
      };
      return lcl_result;
    }


   public E_Condition or( final E_Condition rhs )
   {
      final E_Condition lhs = this;
      E_Condition lcl_result =
      new E_Condition()
      {
         public boolean eval( Object acl_object )
         {
            return lhs.eval( acl_object ) || rhs.eval( acl_object );
         }
      };
      return lcl_result;
   }


   public E_Condition not()
   {
      final E_Condition cond = this;
      E_Condition lcl_result =
      new E_Condition()
      {
         public boolean eval( Object acl_object )
         {
            return ! cond.eval( acl_object );
         }
      };
      return lcl_result;
    }
}
