package rCr.util;
// package aremedios.util;


public class RingBuffer
implements java.io.Serializable
{
    public Object[] buffer;
    protected int begin;
    protected int end;
    protected boolean isEmpty;
    protected int c;

    public int mode;
    public static final int OVERWRITE = 1;
    public static final int IGNORE = 2;
    public static final int FAIL = 3;
    public static final int BLOCK = 4;

    public RingBuffer(int capacity)
    {
        this(capacity,OVERWRITE);
    }

    public RingBuffer(int capacity, int _mode)
    {
    	  mode = _mode;
        c = capacity;
        buffer = new Object[c];
        isEmpty = true;
        begin = end = 0;
    }

    public void put(Object o)
    {
        if (!isEmpty)
        {
            if (begin == end)
            {
                switch (mode)
                {
                    case OVERWRITE:
                        begin = (begin + 1) % c;
                        break;
                    case FAIL:
                        // throw new RuntimeException
                    case IGNORE:
                        return;
                }
            }

            buffer[end] = o;
            end = (end + 1) % c;
        }
        else
        {
            buffer[end] = o;
            end = (end + 1) % c;
            isEmpty = false;
        }
    }

    public Object get()
    {
        if (isEmpty)
            return null;
        else
        {
            Object res = buffer[begin];
            begin = (begin + 1) % c;

            if (begin == end)
                isEmpty = true;

            return res;
        }
    }
	public Object getLast(int idx)
	{
		if (isEmpty)
			return null;
		else
		{
			int i = (end - idx);
			if( i<0)
				i = c - ((i*(-1))%c); 
			//System.out.println("indice do buffer a aceder walkeBuffer"+i);
			Object res = buffer[i];
			return res;
		}
	}
}