package rCr.util;
// package aremedios.util;


public class SynchronizedRingBuffer extends RingBuffer
{
    public SynchronizedRingBuffer(int capacity)
    {
        super(capacity,BLOCK);
    }

    public synchronized void put(Object o)
    {
        if (mode != BLOCK)
            super.put(o);
        else
        {
            while (true)
            {
                if ( (isEmpty) || (end != begin) )
                {
                    buffer[end] = o;
                    end = (end + 1) % c;
                    notifyAll();
                    return;
                }
                else
                {
                    try
                    {
                        wait();
                    }
                    catch (InterruptedException ex)
                    {
                    }
                }
            }
        }
    }

    public synchronized Object get()
    {
        Object r;

        while ( ( r = super.get()) == null)
        {
            try
            {
                wait();
            }
            catch (InterruptedException ex)
            {
            }
        }

        notifyAll();
        return r;
    }
}