/* PTS */


package rCr.util;


import java.lang.*;
import java.applet.*;
import java.awt.*;
import java.util.Date;
import java.util.Vector;
import java.sql.SQLException;
import java.sql.Types;
import java.text.SimpleDateFormat;
import java.text.ParsePosition;
import java.util.Calendar;
import java.util.HashSet;
import java.util.Collection;



/**
* @author: Paulo Trigo Silva
*/
public class U_Geral implements I_Depurador
{
   /**
    * Numero de bits:
    * representacao do tipo basico short
    */
   public final static int kint_numeroBitsDoShort =
                              ( int )Math.ceil( Math.log( Short.MAX_VALUE ) / Math.log( 2 ) ) + 1;

   /**
    * Numero de bytes:
    * representacao o tipo basico short
    */
   public final static int kint_numeroBytesDoShort =
                              ( int )Math.ceil( kint_numeroBitsDoShort / 8 );

   /**
    * Numero de bits:
    * representacao do tipo basico int
    */
   public final static int kint_numeroBitsDoInt =
                              ( int )Math.ceil( Math.log( Integer.MAX_VALUE ) / Math.log( 2 ) ) + 1;

   /**
    * Numero de bytes:
    * representacao do tipo basico int
    */
   public final static int kint_numeroBytesDoInt =
                              ( int )Math.ceil( kint_numeroBitsDoInt / 8 );

   /**
    * Formato a usar para
    * apresentar valores do tipo "Data"
    */
   public final static String kstr_formatoData = "dd / MM / yyyy";

   public static String paraNomeClasse(Object aobj_objecto)
   {
      return aobj_objecto.getClass().getName();
   }
   

   public static Object paraObject(Object aobj_nomeClasse)
   {
      return paraObject( aobj_nomeClasse.toString() );
   }
   

   public static Object paraObject(String astr_nomeClasse)
   {
      // Classe - representada como instancia (objecto) da classe Class
      // ... a classe e' um objecto ...
      Class lcl_class  = null;

      try
      {
         // A classe como um objecto
         lcl_class = Class.forName( astr_nomeClasse );
      }

      catch( ClassNotFoundException excepcao )
      {
         U_Depurador.escrever( kint_depurarErro,
                               "U_Geral",
                               "ERRO - ClassNotFoundException ..." );
      }

      return paraObject( lcl_class );
   }
   

   public static Object paraObject(Class acls_classe)
   {
      // Objecto que se pretende instanciar
      Object lobj_objecto = null;

      try
      {
         // O objecto - instancia da classe
	      // - a classe era um objecto,
	      // - que soube responder a "newInstance"
	      // - instancia da classe de nome "astr_nomeClasse"
         lobj_objecto = acls_classe.newInstance();
      }

      catch( InstantiationException excepcao )
      {
         U_Depurador.escrever( kint_depurarErro,
                               "U_Geral",
                               "InstantiationException ..." );
      }

      catch( IllegalAccessException excepcao )
      {
         U_Depurador.escrever( kint_depurarErro,
                               "U_Geral",
                               "IllegalAccessException ..." );
      }

      return lobj_objecto;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
    */
   public static String paraString(Date adte_data, String astr_formato) 
   {
	String lstr_data = "";
	
	if( null != adte_data )
	{
		SimpleDateFormat lsdf_formatoData =
			new SimpleDateFormat( astr_formato );

		lstr_data = lsdf_formatoData.format( adte_data );
	}

	return lstr_data;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/10/00 12:13:01 PM)
 *     @author: Paulo Trigo Silva
 *     @return int
 *     @param astr_paraConverter java.lang.String
    */
   public static String paraString(Integer aing_paraConverter) 
   {
	return paraString( paraInt( aing_paraConverter ) );
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/10/00 12:57:08 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
 *     @param aint_paraConverter int
 *     @roseuid 3BB1E4F500AE
    */
   public static String paraString(int aint_paraConverter) 
   {
   	return Integer.toString( aint_paraConverter );
   }
   
   /**
 *     Insert the method's description here.
 *     Creation date: (19-07-2000 10:13:43)
 *     @return <{String}>
 *     @param aobj_objecto java.lang.Object
    */
   public static String toString( Object aobj_objecto )
   {
      return ( aobj_objecto == null ) ? "" : aobj_objecto.toString();
   }

   /**
    * @author PTS
    * @since JUN.2004
    */
   public static String toString( int[] aarr_int )
   {
      String lstr_result = "";
      for( int iLoop = 0; iLoop < aarr_int.length; iLoop++ )
      {
         lstr_result = lstr_result + Integer.toString( aarr_int[ iLoop ] );
         lstr_result = lstr_result +
                       ( ( iLoop < aarr_int.length - 1 ) ? ", " : " " );
      }
      return lstr_result;
   }

   /**
    * @author PTS
    * @since JUN.2004
    */
   public static String toString( java.beans.Statement astt_statement )
   {
      String lstr_result = "";
      if( astt_statement == null )
      {
         return lstr_result;
      }
      String lstr_targetObject = astt_statement.getTarget().toString();
      String lstr_targetMethod = astt_statement.getMethodName();
      Object[] larr_targetMethodArguments = astt_statement.getArguments();

      String lstr_arguments = " ";
      for( int iLoop = 0; iLoop < larr_targetMethodArguments.length; iLoop++ )
      {
         lstr_arguments = lstr_arguments + U_Geral.toString( larr_targetMethodArguments[ iLoop ] );
         lstr_arguments = lstr_arguments +
                          ( ( iLoop < larr_targetMethodArguments.length - 1 ) ? ", " : " " );
      }
      lstr_result = lstr_targetObject + "." + lstr_targetMethod + "(" + lstr_arguments + ")";
      return lstr_result;
	}

   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
    */
   public static Date paraDate(String astr_data) 
   {
	Date ldte_data = null;

	if( ! igual( astr_data, "" ) )
	{
		SimpleDateFormat lsdf_formatoData =
			new SimpleDateFormat(
				substituir( kstr_formatoData, " ", "" ) );

		lsdf_formatoData.setLenient( false );

		ldte_data =
			lsdf_formatoData.parse(
					substituir( astr_data, " ", "" ),
					new ParsePosition( 0 ) );
	}

	return ldte_data;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/10/00 12:13:01 PM)
 *     @author: Paulo Trigo Silva
 *     @return int
 *     @param astr_paraConverter java.lang.String
    */
   public static int paraInt(Integer aint_paraConverter) 
   {
	return aint_paraConverter.intValue();
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/10/00 12:13:01 PM)
 *     @author: Paulo Trigo Silva
 *     @return int
 *     @param astr_paraConverter java.lang.String
    */
   public static int paraInt(String astr_paraConverter) 
   {
	return Integer.valueOf( astr_paraConverter ).intValue();
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/10/00 12:13:01 PM)
 *     @author: Paulo Trigo Silva
 *     @return int
 *     @param aint_int int
    */
   public static Integer paraInteger(int aint_int) 
   {
      return new Integer( aint_int );
   }


   public static HashSet toHashSet( Collection litf_collection )
   {
      return ( litf_collection instanceof HashSet ) ?
             ( HashSet )litf_collection
             :
             new HashSet( litf_collection );
   }


   /**
 *     Metodo Global Privado (static private)
 *     Retorna:
 *     1. a classe, passada no argumento as_classePretendida
 *     da qual o objecto passado no argumento acl_cliente
 *     e' cliente
 *     2. null caso nao exista o objecto procurado em 1
 *     NOTA: Este metodo percorre toda a estrutura
 *     de contentores (containers) e para cada cliente
 *     toda a hierarquia de classes (estrutura de herancas)
 *     Criado: (2/15/00 12:16:30 PM)
    */
   private static Object detectarClasse(Container acl_cliente, String as_classePretendida) throws ClassNotFoundException 
   {
	// Classe que se pretende detectar
	Class lcl_classePretendida = Class.forName( as_classePretendida );

	// Classe a partir da qual se vai iniciar a procura
	// A procura vai ser efectuada para cada um dos elementos
	// da hierarquia de clientes (Containers) e para cada um
	// deles para todos os elementos da hierarquia de herancas
	Container lcl_clienteCorrente = acl_cliente;
		
	// Indicacao de fim de hierarquia de clientes
	boolean lb_fimHierarquiaClientes = ( null == lcl_clienteCorrente );

	// Classe que em cada instante sera analisada
	Class lcl_classeCorrente;

	// Indicacao de fim de hierarquia de classes
	boolean lb_fimHierarquiaClasses;

	// Indicacao de que foi detectada a classe Frame
	boolean lb_encontrou = false;


	// Percorrer hirarquia de clientes (containers)
	// ============================================
	while ( ( ! lb_encontrou ) &&
			( ! lb_fimHierarquiaClientes ) )
	{
		// Obter a classe relativa ao cliente corrente
		lcl_classeCorrente =
				lcl_clienteCorrente.getClass();

		lb_encontrou =
				( lcl_classeCorrente == lcl_classePretendida );

		lb_fimHierarquiaClasses =
				( null == lcl_classeCorrente );

		// Percorrer hierarquia de classes
		// Verificar se a classe corrente e derivada de Frame
		// ==================================================
		while ( ( ! lb_encontrou ) &&
				( ! lb_fimHierarquiaClasses ) )
		{
			// Obter a classe da qual a classe corrente e derivada
			lcl_classeCorrente =
				lcl_classeCorrente.getSuperclass();

			lb_encontrou =
				( lcl_classeCorrente == lcl_classePretendida );

			lb_fimHierarquiaClasses =
				( null == lcl_classeCorrente );
		}

		// Se nao foi detectada a classe Frame efectuar
		// um novo ciclo com a proxima classe cliente
		if (! lb_encontrou )
		{
			// Obter o proximo cliente (container)
			lcl_clienteCorrente =
				lcl_clienteCorrente.getParent();

			lb_fimHierarquiaClientes =
				( null == lcl_clienteCorrente );
		}
	}

	// Se a classe Frame foi detectada retornar
	// o retornar a respectiva classe cliente
	if ( lb_encontrou )
		return (Frame) lcl_clienteCorrente;
	else
		return null;
   }
   
   /**
 *     Metodo Global (static)
 *     Retorna:
 *     1. a classe Frame da qual o objecto
 *     passado por argumento e' cliente
 *     2. null caso nao exista o objecto procurado em 1
    */
   public static Frame detectarClasseFrame(Container acl_cliente) 
   {
	// Classe que se pretende detectar (Frame )
	String ls_classeFrame = "java.awt.Frame";

	// Se a classe for detectada sera aqui guardada
	Frame lcl_frame = null;

	try
	{
		lcl_frame = (Frame) detectarClasse( acl_cliente, ls_classeFrame );
	}

	catch ( Exception ClassNotFoundException )
	{
		System.out.print( "\nPTS: ERRO EXCEPCAO - Global::m_detectarClasseFrame\n" );
	}

	return lcl_frame;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (4/1/00 8:41:20 PM)
 *     @author: Paulo Trigo Silva
 *     @param avct_vectorOriginal java.util.Vector
 *     @param aobj_elementoExcluir java.lang.Object
 *     @roseuid 3BB1E4F50284
    */
   public static Vector excluirElemento(Vector avct_vectorOriginal, Object aobj_elementoExcluir) 
   {
   	if( ( null == avct_vectorOriginal ) ||
	       ( null == aobj_elementoExcluir ) )
   	{
   		return new Vector();
   	}
	
	   avct_vectorOriginal.
		   removeElement( aobj_elementoExcluir );

   	return avct_vectorOriginal;
   }

   /**
 *     Insert the method's description here.
 *     Criado: (2/26/00 8:25:52 PM)
 *     @author: Paulo Trigo Silva
 *     @return boolean
 *     @param astr_a java.lang.String
 *     @param astr_b java.lang.String
    */
   public static boolean igual(String astr_a, String astr_b) 
   {
	   return ( 0 == astr_a.compareTo( astr_b ) );
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
    */
   public static int obterAno(Calendar adte_data) 
   {
   	// Ano
   	int lint_ano =
   		adte_data.get( Calendar.YEAR );

	   return lint_ano;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
    */
   public static int obterAno(Date adte_data) 
   {
   	String lstr_ano = "";
	
   	if( null != adte_data )
   	{
   		SimpleDateFormat lsdf_formatoData =
	   		new SimpleDateFormat( "yyyy" );

		   lstr_ano = lsdf_formatoData.format( adte_data );
   	}

	   return paraInt( lstr_ano );
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/26/00 5:39:24 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{Calendar}>
    */
   public static Calendar obterDataCorrente() 
   {
   	Calendar lcln_dataCorrente =
	   	Calendar.getInstance();

   	// Outra hipotese:
   	// Calendar lcln_dataCorrente =
   	//	new GregorianCalendar();

	   return lcln_dataCorrente;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
 *     @roseuid 3BB1E4F60181
    */
   public static int obterDia(Calendar adte_data) 
   {
   	// Dia
   	int lint_dia =
   		adte_data.get( Calendar.DAY_OF_MONTH );

	   return lint_dia;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
 *     @roseuid 3BB1E4F601C7
    */
   public static int obterDia(Date adte_data) 
   {
   	String lstr_dia = "";
	
   	if( null != adte_data )
	   {
		   SimpleDateFormat lsdf_formatoData =
			   new SimpleDateFormat( "dd" );

   		lstr_dia = lsdf_formatoData.format( adte_data );
	   }

   	return paraInt( lstr_dia );
   }
   
   /**
 *     Insert the method's description here.
 *     Creation date: (19-07-2000 13:06:20)
 *     @return int
 *     @param adte_dataNascimento java.util.Date
 *     @roseuid 3BB1E4F6020E
    */
   public static String obterIdade(Date adte_dataNascimento, Calendar acln_dataCorrente) 
   {
	/*
	If dNascimento=DATETIME_Null
		Return NUMBER_Null
	Set nIdade=SalDateYear( dHoje )-SalDateYear(dNascimento )-1
	If SalDateMonth( dHoje ) > SalDateMonth( dNascimento )
		Return nIdade+1
	Else If SalDateMonth( dHoje ) = SalDateMonth( dNascimento )
		If SalDateDay( dHoje ) >= SalDateDay( dNascimento )
			Return nIdade+1
	Return nIdade
	*/

	String lstr_idade = "";
	if( null == adte_dataNascimento )
	{
		return lstr_idade;
	}

	int lint_idade =
			obterAno( acln_dataCorrente ) -
			obterAno( adte_dataNascimento ) -
			1;

	if( obterMes( acln_dataCorrente ) >
		obterMes( adte_dataNascimento ) )
	{
		lint_idade = lint_idade + 1;
	}
	else
	{
		if( ( obterMes( acln_dataCorrente ) ==
			  obterMes( adte_dataNascimento ) )
				&&
			( obterDia( acln_dataCorrente ) >=
			  obterDia( adte_dataNascimento ) ) )
		{
			lint_idade = lint_idade + 1;
		}
	}
			
	lstr_idade = paraString( lint_idade );

	return lstr_idade;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
 *     @roseuid 3BB1E4F6027C
    */
   public static int obterMes(Calendar adte_data) 
   {
   	// Mes
   	int lint_mes =
	   	adte_data.get( Calendar.MONTH );

   	return lint_mes;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/9/00 11:58:45 AM)
 *     @author: Paulo Trigo Silva
 *     @return <{Date}>
 *     @param astr_data java.lang.String
 *     @roseuid 3BB1E4F602C2
    */
   public static int obterMes(Date adte_data) 
   {
	   String lstr_mes = "";
	
   	if( null != adte_data )
	   {
	   	SimpleDateFormat lsdf_formatoData =
		   	new SimpleDateFormat( "MM" );

   		lstr_mes = lsdf_formatoData.format( adte_data );
	   }

   	return paraInt( lstr_mes );
   }
   
   /**
 *     Preencher a "String", ate' 'a dimensao indicada
 *     colocando 'a direita o caracter indicado
 *     Criado: (3/19/00 8:09:36 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
 *     @param astr_paraPreencher java.lang.String
 *     @param aint_dimensaoParaPreencher int
 *     @param achr_preencher char
 *     @roseuid 3BB1E4F70060
    */
   public static String preencherDireita(String astr_paraPreencher, int aint_dimensaoParaPreencher, char achr_preencher) 
   {
   	int lint_dimensaoPalavra = astr_paraPreencher.length();
   	if( ( lint_dimensaoPalavra >= aint_dimensaoParaPreencher ) ||
   		 ( aint_dimensaoParaPreencher < 0 ) )
   	{
   		return astr_paraPreencher;
   	}

	   // Preencher um "array" com o caracter pedido
   	char[] lchr_resultado =
	   	new char[ aint_dimensaoParaPreencher ];
   	for( int lint_ciclo = 0;
	   	 lint_ciclo < aint_dimensaoParaPreencher;
		    lint_ciclo++ )
   	{
	   	lchr_resultado[ lint_ciclo ] = achr_preencher;
   	}

	   // Colocar no "array" os caracteres
   	// da "String" alinhados 'a direita
   	astr_paraPreencher.
	   	getChars( 0,
		   	 	  lint_dimensaoPalavra,
			   	  lchr_resultado,
				     0 );

   	return ( new String( lchr_resultado ) );
   }
   
   /**
 *     Preencher a "String", ate' 'a dimensao indicada
 *     colocando 'a esquerda o caracter indicado
 *     Criado: (3/19/00 8:09:36 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
 *     @param astr_paraPreencher java.lang.String
 *     @param aint_dimensaoParaPreencher int
 *     @param achr_preencher char
 *     @roseuid 3BB1E4F70101
    */
   public static String preencherEsquerda(String astr_paraPreencher, int aint_dimensaoParaPreencher, char achr_preencher) 
   {
   	int lint_dimensaoPalavra = astr_paraPreencher.length();
	   if( ( lint_dimensaoPalavra >= aint_dimensaoParaPreencher ) ||
		   ( aint_dimensaoParaPreencher < 0 ) )
   	{
	   	return astr_paraPreencher;
   	}

   	// Preencher um "array" com o caracter pedido
	   char[] lchr_resultado =
		   new char[ aint_dimensaoParaPreencher ];
   	for( int lint_ciclo = 0;
	   	 lint_ciclo < aint_dimensaoParaPreencher;
		    lint_ciclo++ )
   	{
	   	lchr_resultado[ lint_ciclo ] = achr_preencher;
   	}

   	// Colocar no "array" os caracteres
	   // da "String" alinhados 'a direita
   	astr_paraPreencher.getChars( 0,
   			 	                    lint_dimensaoPalavra,
                     				  lchr_resultado,
	   			                    aint_dimensaoParaPreencher -
              	                    lint_dimensaoPalavra );

   	return ( new String( lchr_resultado ) );
   }
   
   /**
 *     Substitui na "String" "astr_original",
 *     as ocorrencias da "String" "astr_padraoProcurar"
 *     pela "String" "astr_padraoSubstituir"
 *     Criado: (2/27/00 1:57:45 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
    */
   public static String substituir(String astr_original, String astr_padraoProcurar, String astr_padraoSubstituir) 
   {
	StringBuffer lstb_substituida =
			new StringBuffer( "" );

	int lint_dimensaoPadraoProcurar =
			astr_padraoProcurar.length();
	int lint_inicioSubPalavra;
	int lint_fimSubPalavra = - lint_dimensaoPadraoProcurar;
	do
	{	
		lint_inicioSubPalavra =
			lint_fimSubPalavra +
			lint_dimensaoPadraoProcurar;

		lint_fimSubPalavra =
			astr_original.indexOf(
				astr_padraoProcurar,
				lint_inicioSubPalavra );

		int lint_indiceFim;
		String lstr_substituir;
		if( -1 == lint_fimSubPalavra )
		{
			lint_indiceFim = astr_original.length();
			lstr_substituir = "";
		}
		else
		{
			lint_indiceFim = lint_fimSubPalavra;
			lstr_substituir = astr_padraoSubstituir;
		}

		String lstr_subPalavra =
			astr_original.substring(
				lint_inicioSubPalavra,
				lint_indiceFim );
		
		lstb_substituida =
			lstb_substituida.
				append( lstr_subPalavra ).
				append( lstr_substituir );
	}
	while( -1 != lint_fimSubPalavra );
	
	return lstb_substituida.toString();
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/19/00 7:51:30 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
 *     @param astr_paraTruncar java.lang.String
 *     @param aint_dimensaoTotal int
 *     @roseuid 3BB1E4F70287
    */
   public static String truncarDireita(String astr_paraTruncar, int aint_dimensaoParaTruncar) 
   {
	int aint_dimensaoInicial = astr_paraTruncar.length();

	if( ( aint_dimensaoInicial <= aint_dimensaoParaTruncar ) ||
		( aint_dimensaoParaTruncar < 0 ) )
	{
		return astr_paraTruncar;
	}
	
	String lstr_truncada =
		astr_paraTruncar.substring(
			0,
			aint_dimensaoParaTruncar );

	return lstr_truncada;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/19/00 7:51:30 PM)
 *     @author: Paulo Trigo Silva
 *     @return <{String}>
 *     @param astr_paraTruncar java.lang.String
 *     @param aint_dimensaoTotal int
 *     @roseuid 3BB1E4F702F5
    */
   public static String truncarEsquerda(String astr_paraTruncar, int aint_dimensaoParaTruncar) 
   {
	int aint_dimensaoInicial = astr_paraTruncar.length();

	if( ( aint_dimensaoInicial <= aint_dimensaoParaTruncar ) ||
		( aint_dimensaoParaTruncar < 0 ) )
	{
		return astr_paraTruncar;
	}
	
	String lstr_truncada =
		astr_paraTruncar.substring(
			aint_dimensaoInicial - aint_dimensaoParaTruncar,
			aint_dimensaoInicial );

	return lstr_truncada;
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (2/26/00 9:12:04 PM)
 *     @author: Paulo Trigo Silva
 *     @return boolean
 *     @param astr_palavra java.lang.String
 *     @roseuid 3BB1E4F7036D
    */
   public static boolean vazio( String astr_palavra )
   {
   	return igual( astr_palavra, "" );
   }
   
   /**
   * Creation date: (3/9/00 5:10:26 PM)
   * @return boolean
   * @param avct_vector java.util.Vector
   */
   public static boolean vazio( Vector avct_vector )
   {
   	return ( 0 == avct_vector.size() );
   }


   public static void copiar( int aint_origem, byte[] abyt_destino, int posicao )
   {
      // Pre-condicao:
      // abyt_destino ter dimensao apropriada
      try
      {
         U_PreCondicao.assercaoVerdadeira(
            abyt_destino.length >= posicao + U_Geral.kint_numeroBytesDoInt - 1,
            "U_Geral", "copiar" );
      }
      catch( X_PreCondicao lexc_preCondicao )
      {
         return;
      }

      // op1 & op2
      // bitwise and
      //------------
      // op1 | op2
      // bitwise or
      //-----------
      // op1 ^ op2
      // bitwise xor
      //------------
      // op1 ~ op2
      // bitwise complement
      //-------------------

      // op1 << op2
      // shift bits of op1 left by distance op2
      //---------------------------------------
      // op1 >> op2
      // shift bits of op1 right by distance op2
      //----------------------------------------
      // op1 >>> op2
      // shift bits of op1 right by distance op2 (unsigned)
      //---------------------------------------------------

      // numero de bits a deslocar para obter cada um dos byte do int
      int lint_deslocamento = kint_numeroBitsDoInt - 8;
      for( int lint_ciclo = 0; lint_ciclo < kint_numeroBytesDoInt; lint_ciclo++ )
      {
         abyt_destino[ posicao + lint_ciclo ] = ( byte )( ( aint_origem >>> lint_deslocamento ) & 0xFF );

         // deslocar menos um byte (8 bits)
         lint_deslocamento = lint_deslocamento - 8;
      }
   }
}
