/* PTS */


package rCr.util;


import java.util.Collection;
import java.util.Iterator;
import rCr.agent.skillLevel_1.problemSolver.E_Node;
import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem.E_State;
import java.util.ArrayList;
import yab.agent.object.MotionlessObject;
import rCr.agentWorkingMemory.U_Geometry;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class U_RcR
{
   /**
    * @param aitf_route A Collection with a MotionlessObject at each position
    * Return an int[] with a MotionlessObject.id at each position
    */
   public static final int[] getIDs( Collection aitf_route )
   {
      int[] larr_routeIDs = new int[ aitf_route.size() ];
      int lint_iLoop = 0;
      for( Iterator litf_iterator = aitf_route.iterator();
           litf_iterator.hasNext(); )
      {
         MotionlessObject lcl_motionlessObject = ( MotionlessObject )litf_iterator.next();
         larr_routeIDs[ lint_iLoop ] = lcl_motionlessObject.id;
         lint_iLoop ++;
      }
      return larr_routeIDs;
   }


   /**
    * @param aitf_route A Collection with a E_Node at each position
    * Return an ArrayList with a MotionlessObject at each position
    */
   public static final ArrayList fromSolutionNodeToMotionlessObject( Collection aitf_route )
   {
      ArrayList larr_route = new ArrayList( aitf_route.size() );
      for( Iterator litf_iterator = aitf_route.iterator();
           litf_iterator.hasNext(); )
      {
         E_Node lcl_node = ( E_Node )litf_iterator.next();
         larr_route.add( ( ( E_State )( lcl_node.getState() ) ).gisLocation );
      }
      return larr_route;
   }


   public static final Integer getIndexOfCloserTo( MotionlessObject acl_object, ArrayList aarr_toSearch )
   {
      U_Order lC_order =
      new U_Order()
      {
         public boolean eval( double leftSide, double rightSide )
         {
            return ( leftSide < rightSide );
         }
      };
      return getIndexOfCloserFarther( acl_object, aarr_toSearch, lC_order );
   }


   public static final Integer getIndexOfFartherFrom( MotionlessObject acl_object, ArrayList aarr_toSearch )
   {
      U_Order lC_order =
      new U_Order()
      {
         public boolean eval( double leftSide, double rightSide )
         {
            return ( leftSide > rightSide );
         }
      };
      return getIndexOfCloserFarther( acl_object, aarr_toSearch, lC_order );
   }


   private static final Integer getIndexOfCloserFarther( MotionlessObject acl_object, ArrayList aarr_toSearch, U_Order acl_order )
   {
      if( aarr_toSearch.isEmpty() )
      {
         return null;
      }
      // Object coordinates
      int x0 = acl_object.x();
      int y0 = acl_object.y();
      // Set current best
      MotionlessObject lcl_currentBestObject = ( MotionlessObject )aarr_toSearch.get( 0 );
      int x1 = lcl_currentBestObject.x();
      int y1 = lcl_currentBestObject.y();
      double ldbl_currentBestDistance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );

      // Iterate go get better then current best
      int lint_bestIndex = 0;
      for( int lint_iLoop = 1; lint_iLoop < aarr_toSearch.size(); lint_iLoop++ )
      {
         MotionlessObject lcl_object = ( MotionlessObject )aarr_toSearch.get( lint_iLoop );
         x1 = lcl_object.x();
         y1 = lcl_object.y();
         double ldbl_distance = U_Geometry.getPointToPointDistance( x0, y0, x1, y1 );
         if( acl_order.eval( ldbl_distance, ldbl_currentBestDistance ) )
         {
            ldbl_currentBestDistance = ldbl_distance;
            lint_bestIndex = lint_iLoop;
         }
      }
      return new Integer( lint_bestIndex );
   }


   /**
    * First level (pointer only) ArrayList Shallow Copy
    * To allow posterior "delete" over the returned Arraylist
    * and not to destroy the initial one (litf_iterator)
    * PTS: ??? confirm if necessary ???
    */
   public static final ArrayList buildShallowCopy( Iterator litf_iterator )
   {
      ArrayList larr_result = new ArrayList();
      while( litf_iterator.hasNext() )
      {
         larr_result.add( litf_iterator.next() );
      }
      return larr_result;
   }





   /**
    * Utility Class
    * (for inquality comparation)
    */
   abstract private static class U_Order
   {
      public abstract boolean eval( double leftSide, double rightSide );
   }
}
