/* PTS */
/**
* Utilizacao do codigo de yab.agent
* classe: HumanoidAgent
* metodos: getRoute, outsidePosition, modifyOriginToCurrentPosition
*/

package yab.agent;


import yab.agent.object.MotionlessObject;
import yab.agent.object.Humanoid;
import yab.agent.object.MovingObject;
import java.util.Collections;
import java.util.Collection;
import yab.agent.object.Road;
import yab.agent.object.PointObject;
import yab.agent.object.RealObject;

public class B_GIS_Router_Yab_Adapter
{
   /**
    **********************************************
    * CODIGO DE YabAI
    * Alteracoes: cada linha com:
    * - // PTS:
    * - foi substituida pela linha colocado abaixo
    **********************************************
    */

    /** This method returns the minimum cost route reaching one of
     *  <code>destinations</code> in consideration for a blockade
     *  located at the midpoint of a road where the controlled object
     *  is.
     *  This method routes, estimating cost of a route based upon its
     *  passability:
     *  <ul>
     *      <li>if the agent has seen a road and the road is passable,
     *      cost for reaching the road is low</li>
     *      <li>if the agent has seen a road and the road is not
     *      passable, the cost is high</li>
     *      <li>if the agent has not seen a road but the road may be
     *      passable, the cost is the middle</li>
     *  </ul>
     * @see Router.CostFunction#cost(MotionlessObject, MotionlessObject) cost
     */
    // PTS: protected Route getRoute(Collection destinations) {
    static public Route getRoute( Collection destinations, RealObject acl_objectoAgente ) {
        // PTS: MotionlessObject pos = self().motionlessPosition();
        MotionlessObject pos = acl_objectoAgente.motionlessPosition();
        if (!(pos instanceof Road)  ||  ((Road) pos).passableLines() >= 1)
            return Router.get(pos, destinations, RELIABILITY_COST_FUNCTION);
        // PTS: Route route = Router.get(outsidePosition(), destinations,
        Route route = Router.get(outsidePosition( acl_objectoAgente ), destinations,
                                 RELIABILITY_COST_FUNCTION);
        // PTS: modifyOriginToCurrentPosition(route);
        modifyOriginToCurrentPosition( route, acl_objectoAgente );
        return route;
    }
    // PTS: private MotionlessObject outsidePosition() {
    static private MotionlessObject outsidePosition( RealObject acl_objectoAgente ) {
        // PTS: Road rd = (Road) self().motionlessPosition();
        Road rd = (Road) acl_objectoAgente.motionlessPosition();
        // PTS: return (self().positionExtra() < rd.length() / 2)
        // PTS: MAY.2004
        // return ( acl_objectoAgente.positionExtra() < rd.length() / 2)
        return ( ( ( MovingObject )acl_objectoAgente ).positionExtra() < rd.length() / 2)
               ? rd.head() : rd.tail();
    }
    // PTS: private void modifyOriginToCurrentPosition(Route route) {
    static private void modifyOriginToCurrentPosition( Route route, RealObject acl_objectoAgente ) {
        // PTS: MotionlessObject pos = self().motionlessPosition();
        MotionlessObject pos = acl_objectoAgente.motionlessPosition();
        for (Route rt = route;  true;  rt = rt.previous()) {
            if (rt.end == pos) {
                rt.setPrevious(null);
                return;
            }
            if (rt.previous() == null) {
                rt.setPrevious(new Route(pos));
                return;
            }
        }
    }
    private static final Router.CostFunction RELIABILITY_COST_FUNCTION
        = new Router.CostFunction() {
                public float cost(MotionlessObject from, MotionlessObject to) {
                    final int WEIGHT = Integer.MAX_VALUE;
                    float c = 1;
                    if (!(to instanceof Road))
                        return c;
                    Road rd = (Road) to;
                    PointObject po = (PointObject) from;
                    if (rd.passableLinesFrom(po) == 0)
                        return c * WEIGHT * WEIGHT;
                    return rd.hasBeenSeen() ? c : c * WEIGHT; }};
}
